#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.
//////////////////////////////////////////////////////////////////////////////////////////////////////
//Sep, 2022. PROYECTO OXIGENO
//Ignacio Perales
//////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////

//**//

Function Init_Globals()
	String/G root:actVuelo = "Vuelo_01"
	String/G root:actOxim = "-"
	
	variable i
	
	//Create resources folder
	NewDataFolder/O root:Resources
	NewDataFolder/O root:Resources:Oximetry
	DFREF dfrResource = root:Resources:Oximetry
	
	variable/G dfrResource:OximIni/N=OximIni = 1 //First oxim on chamber
	variable/G dfrResource:OximLast/N=OximLast = 12 //Last oxim on chamber
	String/G dfrResource:OximInstruct/N=OximInstruct = "11,12" //list of oximeters used by instructors on chamber
	
	//Variables for raw found vuelos	
	String/G dfrResource:SelPathDir/N=SelPathDir = "" //Global str for selected raw Vuelos containing folder
	String/G dfrResource:VuelosDisponibles = "" //Global list str with every Vuelo_XXX folder name
	Variable/G dfrResource:VuelosDispCount = 0 //Global var counting how many vuelos in selected directory	
	
	//Variables for vuelos loaded in root
	SVAR /Z VuelosIRs = dfrResource:VuelosInRoot
	IF(!SVAR_Exists(VuelosIRs))
		String/G dfrResource:VuelosInRoot/N=VuelosIRs = ""	// Create vspanel vuelo type display string
	ENDIF
		
	NVAR/Z VuelosIRC = dfrResource:VuelosInRootCount
	IF(!NVAR_Exists(VuelosIRC))
		Variable/G dfrResource:VuelosInRootCount/N=VuelosIRC = 0 // Create vuelos cargados global var
	endif
	NVAR/z VuelosDC = dfrResource:VuelosDispCount
	IF(!NVAR_Exists(VuelosDC))
		Variable/G dfrResource:VuelosDispCount/N=VuelosDC = 0 // Create vuelos disponibles global var
	ENDIF
	
	SVAR /Z VSmainInfo = dfrResource:VSmainInfo
	IF(!SVAR_Exists(VSmainInfo))
		String/G dfrResource:VSmainInfo/N=VSmainInfo = "-"	// Create vspanel bottom info display string
	ENDIF
	
	SVAR /Z VStipovuelo = dfrResource:VStipovuelo
	IF(!SVAR_Exists(VStipovuelo))
		String/G dfrResource:VStipovuelo/N=VStipovuelo = "-"	// Create vspanel vuelo type display string
	ENDIF
	SVAR /Z VSorigExpNm = dfrResource:VSorigExpNm
	IF(!SVAR_Exists(VSorigExpNm))
		String/G dfrResource:VSorigExpNm/N=VSorigExpNm = "-"	// Create vspanel vuelo original Igor experiment name display string
	ENDIF	
	
	//Create VuelosStatus
	Make/O/N=(0,1+OximLast-OximIni+1) dfrResource:VuelosStatus/wave=VuelosStatus
	SetDimLabel 1,0,Vuelos,VuelosStatus //First column holds Vuelo type
	for(i=1;i<OximLast-OximIni+2;i++) //Oxim columns for oximeter status
		setDimLabel 1,i,$("Oxim_"+num2str(i)),VuelosStatus
	endfor
	
	//Default status display for infoText listBox
	variable numColors = 15 
	Make/O/N=(numColors,3)/T dfrResource:Default_StatusHelp/wave=Default_StatusHelp = ""
	//Default_StatusHelp[][0] = {"No procesado","Completo","Incompleto","No encontrado","Seleccionado","Revisar","Otro tipo","No data","-","X","-","V.D+N","V.D","V.DCr","V.M"}
	Default_StatusHelp[][0] = {"Unprocessed","Processed","MissingData","Not found","Favorite","Excluded","Other","No data","-","X","-","Day+Night","OnlyDay","FastDecompression","Medical"}
	SetDimLabel 1,0,$"Status",Default_StatusHelp
	SetDimLabel 1,1,$"-",Default_StatusHelp
	SetDimLabel 1,2,$"-",Default_StatusHelp
	
	Make/O/N=(numColors,3,2)/B/U dfrResource:Default_StatusHelpSel/WAVE=Default_StatusHelpSel = 0 //Selection wave
	Default_StatusHelpSel[][0][1] = p
	SetDimLabel 2,1,backColors,Default_StatusHelpSel
	
	Make/FREE/N=(numColors)/T ColorNames = {\
	"White","Orange","Yellow","LightGray","LightGreen","Red","DarkRed","-","-","DarkGray","-","LightBlue","DarkBlue","Lime","Pink"}
	//"Blanco","Naranja","Amarillo","GrisClaro","VerdeClaro","RojoMedio","RojoOscuro","-","-","GrisOscuro","-","CelesteClaro","CelesteOscuro","Lima","Rosa"}
	
	Make/O/N=(numColors,3)/W/U dfrResource:Default_Colors/WAVE=Default_Colors //Default color of status in listBox
	for(i=0;i<numColors;i++)
		setDimLabel 0,i,$(ColorNames[i]),Default_Colors
	endfor
	
		Default_Colors[0][] = {{65535},{65535},{65535}}		//Blanco - No proc
		Default_Colors[1][] = {{65535},{43690},{0}} 			//Naranja - Selected
		Default_Colors[2][] = {{65535},{65535},{0}} 			//Amarillo - Incomp
		Default_Colors[3][] = {{52428},{52428},{52428}} 		//Gris claro - No enct 
		Default_Colors[4][] = {{40969},{65535},{16385}}		//Verde claro - Conf
		Default_Colors[5][] = {{52428},{1},{1}}  				//Rojo medio - Revisar
		Default_Colors[6][] = {{40969},{1},{1}} 				//Rojo oscuro - Otro tipo
		Default_Colors[7][] = {{65535},{65535},{65535}}		//Blanco - No data
		Default_Colors[8][] = {{65535},{65535},{65535}}		//Blanco - 
		Default_Colors[9][] = {{39321},{39321},{39321}}		//GrisOscuro - 
		Default_Colors[10][] = {{65535},{65535},{65535}}		//Blanco - 
		Default_Colors[11][] = {{49151},{60031},{65535}}		//CelesteClaro - "V.D+N" (Diurno+Nocturno)
		Default_Colors[12][] = {{49151},{53155},{65535}}		//CelesteOScuro -"V.D" (Diurno)
		Default_Colors[13][] = {{49151},{65535},{57456}}		//Lima - "V.DCr" (49151,65535,57456) (Descompresion rapida)
		Default_Colors[14][] = {{65535},{49151},{62258}}		//Rosa - "V.M" (65535,49151,62258) (Vuelo Medico)
		//{}
	
	//
	loadFlight_DataWave(printInfo=0,remakePath=0) //Check selected path for available vuelos. Puts them on Help wave
	
	loadFlight_CheckFolder(reCheck=1) //Checks root for loaded vuelos. Updates VueloStatus. Create ListaVuelos_Root with vueloTypes
	
	vueloStatus_InfoWave() //Use VuelosStatus for Info display on LIST BOX. reCheck=1 includes loadFlight_CheckFolder()
	
	Reporte_VuelosInfoComp(blank=1) //Tablas compilado datos temporales
	
	Confirmar_TablaCompilado(blank=1) //Tablas compilado datos segmentos
END

//Note/K VuelosStatus,"0 default, -1 oximetro no activo, -2 oximetro con datos faltantes\n1 oximetro calculado, 2 oximetro confirmado"
//	SVAR/Z VuelosDisponibles = dfrResource:VuelosDisponibles
//	IF(!Svar_Exists(VuelosDisponibles))
//		String/G dfrResource:VuelosDisponibles = ""
//	ENDIF

//PeakResult[%'Peak Found']   =V_flag
//PeakResult[%PeakLoc]        =V_PeakLoc
//			switch (actStatus)
//				case 0:
//						corrStatus = 0		// "No procesado"
//					break
//				case 1:
//						corrStatus = 1		// "Completo"		
//					break
//				case -1:
//						corrStatus = 2		// "InCompleto"			
//					break
//				case -2:
//						corrStatus = 3		// "No encontrado"			
//					break
//				case 2:
//						corrStatus = 4		// "Seleccionado"		
//					break					
//				case -3:
//						corrStatus = 5		// "Revisar"	
//					break
//				case -4:
//						corrStatus = 6		// "Otro tipo"		
//					break					
//			endSwitch


//-------------------------------------------------------------------//

Function A0Show()
END
//////////////////////////////////////////////////////////////////////////////////////////////////////
//00//**BASIC GRAPH**///////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////

Function showFlight(variable flightNum,[string hostWin,variable modeDisp])

	SVAR actvuelo = root:actVuelo
	sprintf actVuelo,"Vuelo_%g",flightNum
	DFREF dfrVuelo = root:$(actVuelo)
	
	wave altura = dfrVuelo:w_alt_L
	wave altMarkers = dfrVuelo:w_alt_Markers
		IF(!WaveExists(altura))
			//printf "showFlight: vuelo %g no encontrado\n",flightNum
			return 0
		ENDIF
	
	string alturaName = nameOfWave(altura)
	string altMarkerName = nameOfWave(altMarkers)	
		
	variable alturaTimeMax = pnt2x(altura,dimSize(altura,0)-1)
	string alturaElapsed = secs2time(alturaTimeMax,4)
	string alturaInfoText
	IF(modeDisp==0)
		sprintf alturaInfoText,"Flight time: %s\n%s",alturaelapsed,actVuelo
	ELSEIF(modeDisp==1)
		sprintf alturaInfoText,"Flight time: %s",alturaelapsed
	ENDIF
	
	IF(paramIsDefault(hostWin))
		hostWin = ""
	ENDIF

	IF(modeDisp==0)
		display/K=1/HOST=$(hostWin)/N=$(actVuelo)/FG=(FL,FT,FR,FB) altura
	ENDIF
	
	IF(cmpStr(hostWin,"")==0)
		string flWinName = actvuelo
	ELSE
		flWinName = hostWin + "#" + actvuelo
	ENDIF
	
	IF(modeDisp==0)
		AppendToGraph/W=$(flWinName) altMarkers
	ELSEIF(modeDisp==1)
		string chWin = childwindowList(hostWin)
		string actWin = stringfromList(0,chWin,";")
		flWinName = hostWin + "#" + actWin
		appendToGraph/W=$(flWinName)/R altura,altMarkers
	ENDIF
	
	ModifyGraph/W=$(flWinName)  rgb($(alturaName))=(0,0,0),lstyle($(alturaName))=3
	ModifyGraph/W=$(flWinName)  mode($(altMarkerName))=1,rgb($(altMarkerName))=(0,0,0)//rgb($(altMarkerName))=(0,0,0) //(0,65535,0) green
	
	TextBox/W=$(flWinName)/C/N=text1/F=0 alturaInfoText

	IF(modeDisp==0)
		Label/W=$(flWinName) left "Altitude"//"Altura"
		Label/W=$(flWinName) bottom "Time"//"Tiempo"
		SetAxis/W=$(flWinName) left 0,*	
	ELSEIF(modeDisp==1)
		Label/W=$(flWinName) right "Altitude"
		//Label/W=$(flWinName) bottom "Tiempo"
		SetAxis/W=$(flWinName) right 0,*	
	ENDIF
END

//-------------------------------------------------------------------//

Function showOxim(variable oximNum,[variable processed,string hostWin,variable modeDisp])

	SVAR actvuelo = root:actVuelo
	DFREF dfrVuelo = root:$(actVuelo)

	SVAR actOxim = root:actOxim
	sprintf actOxim,"Oxim_%g",oximNum
	
	DFREF dfrOx = dfrVuelo:$(actOxim)
		IF(DataFolderRefStatus(dfrOx)==0)
			//printf "showOximt: Oxim %g no encontrado\n",oximNum
			return 0
		ENDIF
	
	string procStr = ""
	IF(processed==1)
		procStr = "_proc"
	ENDIF
	
	wave w_conexion = dfrOx:$("w_conexion")
	
	wave w_saturacion = dfrOx:$("w_sat"+procStr)
	
	wave w_cardiaco = dfrOx:$("w_lpm"+procStr)
	
	string wConName = nameOfWave(w_conexion)
	string wSatName = nameOfWave(w_saturacion)
	string wCardName = nameOfWave(w_cardiaco)
	
	IF(paramIsDefault(hostWin))
		hostWin = ""
	ENDIF
	
	display/K=1/HOST=$(hostWin)/N=$(actvuelo+"_"+actOxim)/FG=(FL,FT,FR,FB)
	
	IF(cmpStr(hostWin,"")==0)
		string oxWinName = actvuelo+ "_" + actOxim
	ELSE
		oxWinName = hostWin + "#" + actvuelo + "_" +actOxim 
	ENDIF
	
	IF(waveExists(w_conexion))
		IF(modeDisp==0)
			appendToGraph/W=$(oxWinName)/R w_conexion
			ModifyGraph/W=$(oxWinName) rgb($wConName)=(0,0,0)
		ELSEIF(modeDisp==1)
			appendToGraph/W=$(oxWinName) w_conexion
			ModifyGraph/W=$(oxWinName) offset($wConName)={0,100},muloffset($wConName)={0,10},rgb($wConName)=(0,0,0)
		ENDIF
	ENDIF
	
	IF(waveExists(w_saturacion))
		appendToGraph/W=$(oxWinName) w_saturacion
		ModifyGraph/W=$(oxWinName) rgb($wSatName)=(32768,40777,65535),lsize($wSatName)=2 //(0,0,65535)
	ENDIF
	
	IF(waveExists(w_cardiaco))
		appendToGraph/W=$(oxWinName) w_cardiaco
		ModifyGraph/W=$(oxWinName) rgb($wCardName)=(65535,32764,16385),lsize($wCardName)=2 //(65535,0,0)
	ENDIF
	
	IF(waveExists(w_cardiaco) || waveExists(w_saturacion))
		SetAxis/W=$(oxWinName)/A/N=1 left
		SetAxis/W=$(oxWinName) left 40,160
	ENDIF
	
	SVAR Nombre = dfrOx:s_apellidoP
	NVAR Edad = dfrOx:v_edad
	SVAR Sexo = dfrOx:s_sexo
	SVAR Rango = dfrOx:s_rango
	
	string OximInfoText
	sprintf oximInfoText,"%s %s\n%s (%s), %g",actvuelo,actOxim,Nombre,sexo,edad
	TextBox/W=$(oxWinName)/C/N=text0/F=1/A=LT oximInfoText
END

//-------------------------------------------------------------------//

Function showOxim_higlight(variable segment,[variable showFit,variable oximNum,string hostWin,variable pan])

	SVAR actvuelo = root:actVuelo
	DFREF dfrVuelo = root:$(actVuelo)

	SVAR actOxim = root:actOxim	
	variable actOxNuM
	sscanf ActOxim,"Oxim_%g",actOxNum
	IF(oximNum!=0) //Change active oxim
		sprintf actOxim,"Oxim_%g",oximNum
		ActOxNum = oximNum
	ELSE
		oximNum = actOxNum
	ENDIF
	DFREF dfrOx = dfrVuelo:$(actOxim)
		IF(DataFolderRefStatus(dfrOx)==0)
			printf "showOximt: Oximeter %g not found\n",oximNum
			return 0
		ENDIF
	
	wave/WAVE AllSegmentRefWave = dfrOx:AllSegmentRefWave
		IF(!WaveExists(AllSegmentRefWave))
			//printf "showOxim_higlight: Oxim %g SegmentRef wave no encontrado\n",oximNum
		ENDIF
	
	wave/WAVE AllSegmentFitRefWave = dfrOx:AllFitRefWave
		IF(!WaveExists(AllSegmentFitRefWave) && showFit!=0)
			//printf "showOxim_higlight: Oxim %g FitRef wave no encontrado\n",oximNum
			return 0
		ENDIF
	
	IF(segment==-1)	
		variable inSeg = 1
		variable outSeg = dimSize(AllSegmentRefWave,0)
	ELSEIF(segment==0)
		return 0
	ELSE
		inSeg = segment
		outSeg = segment
	ENDIF	
	
	IF(pan==0 && (ParamIsDefault(hostWin) || cmpStr(hostWin,"")==0))
		string oxWinName = actvuelo+ "_" + actOxim
	ELSEIF(pan==1)
		oxWinName = "oximwindow" + "#" + actvuelo + "_" +actOxim 
	ELSE
		oxWinName = hostWin + "#" + actvuelo + "_" +actOxim 
	ENDIF
		
	DoWindow/HIDE=? $("OximWindow")
	variable i,winExists = v_flag
	
	String ActiveWin = ChildWindowList("OximWindow")
	IF(itemsInList(ActiveWin,";")==0)
		//printf "OximPanel display window not active\n"
		return 0
	ENDIF
	
	IF(showFit != 2) // 2 only adds fit
		
		for(i=inSeg;i<=outSeg;i++)
			wave segmentSat = AllSegmentRefWave[i-1][0]
			wave segmentCard = AllSegmentRefWave[i-1][1]
			
			string segmentSatName = nameOfWave(segmentSat)
			string segmentCardName = nameOfWave(segmentCard)
			
			IF(WaveExists(segmentSat) && winExists)
				appendToGraph/W=$(oxWinName) segmentSat
				ModifyGraph/W=$(oxWinName) rgb($segmentSatName)=(0,0,65535),lsize($segmentSatName)=2 //(16385,49025,65535)
			ENDIF
			IF(WaveExists(segmentCard) && winExists)
				appendToGraph/W=$(oxWinName) segmentCard
				ModifyGraph/W=$(oxWinName) rgb($segmentCardName)=(65535,0,0),lsize($segmentCardName)=2 //(65535,32764,16385)
			ENDIF
		endfor
	ENDIF
	
	IF(showFit>=1 || showFit==-1)
	
		for(i=inSeg;i<=outSeg;i++)
			wave segmentSatFit = AllSegmentFitRefWave[i-1][0]
			wave segmentCardFit = AllSegmentFitRefWave[i-1][1]
			
			string segmentSatFitName = nameOfWave(segmentSatFit)
			string segmentCardFitName = nameOfWave(segmentCardFit)
			
			IF(WaveExists(segmentSatFit) && winExists)
				appendToGraph/W=$(oxWinName) segmentSatFit
				ModifyGraph/W=$(oxWinName) rgb($segmentSatFitName)=(52428,17472,1),lsize($segmentSatFitName)=2
			ENDIF
			IF(WaveExists(segmentCardFit) && winExists)
				appendToGraph/W=$(oxWinName) segmentCardFit
				ModifyGraph/W=$(oxWinName) rgb($segmentCardFitName)=(1,34817,52428),lsize($segmentCardFitName)=2
			ENDIF
		endfor
	
	ENDIF
	
END

Function show_NIRS(variable flightNum,variable setSensor)

	SVAR actvuelo = root:actVuelo
	sprintf actVuelo,"Vuelo_%g",flightNum
	DFREF dfrVuelo = root:$(actVuelo)

	string panelName = "OximPanel"
	string dispWinName = "NIRSWindow"

	ControlInfo/W=$(PanelName) btOP8
	variable pp8ud = str2num(s_userData[7,inf])
	
	variable iniL = 250
	variable iniT = 400
	variable ancho = 500
	variable alto = 250
		
//	IF(reset==1 || reset==-1) //Reset all (1)
//		Killwindow/Z $(OximWindowName)
//	ELSEIF(reset==0)
//		DoWindow/F $(OximWindowName)
//	ENDIF
//	IF((OximWindowExists==0 && reset!=-1) || (OximWindowExists==1 && reset==1))
//		NewPanel/K=1/N=$(OximWindowName)
//	
	IF(pp8ud==1)
		display/K=1/HOST=$("")/N=$(dispWinName)/FG=(FL,FT,FR,FB)/W=(iniL,iniT,iniL+ancho,iniT+alto)
	ELSE
		killWindow/Z $(dispWinName)
		return 0
	ENDIF
	
	DFREF dfrResource = root:Resources:Oximetry
	SVAR NIRSpath = dfrResource:NIRSSelPathDir
	SVAR NIRSdisp = dfrResource:NIRSVuelosDisponibles
	NVAR NIRSdispCount = dfrResource:NIRSVuelosDispCount
	
	string foundStr = removeEnding(GrepList(NIRSdisp, num2str(flightNum)),";")
	variable foundStrIndex = WhichListItem(foundStr,NIRSdisp)
	
	
	DFREF dfrNIRS = root:VuelosNIRS
	DFREF dfrImporte = dfrNIRS:$(foundStr)
	
	wave tiempo = dfrImporte:dateVuelo
	IF(setSensor==0 || setSensor==1)
		wave sensor1 = dfrImporte:columnD
		wave sensor2 = dfrImporte:columnH
		string sensores = "Sensores D+H"
	ELSEIF(setSensor==2)
		wave sensor1 = dfrImporte:columnL
		wave sensor2 = dfrImporte:columnP	
		sensores = "Sensores L+P"
	ENDIF
	
	wave marcadores = dfrImporte:columnE
	SVAR actNIRSdata = dfrImporte:ExcelInfo
	string NIRSdataSheet = StringByKey("NAME", actNIRSdata)
	
	appendtograph/W=$(dispWinName) sensor1 vs tiempo
	appendtograph/W=$(dispWinName) sensor2 vs tiempo
	SetAxis left 20,100
	
	appendtograph/W=$(dispWinName)/R marcadores vs tiempo
	ModifyGraph/W=$(dispWinName) rgb(columnE)=(0,0,0),mode(columnE)=8
	SetAxis right 0.1,*
	
	string NIRSInfoText = ""
	sprintf NIRSInfoText,"%s, %s\n%s",actvuelo,sensores,NIRSdataSheet
	TextBox/W=$(dispWinName)/C/N=text0/F=1/A=LT NIRSInfoText
END

Function A1DataTreatment()
END
//////////////////////////////////////////////////////////////////////////////////////////////////////
//01//**DATA TREATMENT**//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////


Function NIRS_FirstProc(variable vueloNum)

	SVAR actvuelo = root:actVuelo
	sprintf actVuelo,"Vuelo_%g",vueloNum
	DFREF dfrVuelo = root:$(actVuelo)

	string panelName = "OximPanel"
	string dispWinName = "NIRSWindow"
	
	DFREF dfrResource = root:Resources:Oximetry
	SVAR NIRSpath = dfrResource:NIRSSelPathDir
	SVAR NIRSdisp = dfrResource:NIRSVuelosDisponibles
	NVAR NIRSdispCount = dfrResource:NIRSVuelosDispCount
	
	string foundStr = removeEnding(GrepList(NIRSdisp, num2str(vueloNum)),";")
	variable foundStrIndex = WhichListItem(foundStr,NIRSdisp)
	
	DFREF dfrNIRS = root:VuelosNIRS
	DFREF dfrImporte = dfrNIRS:$(foundStr)
	
	wave tiempo = dfrImporte:dateVuelo
	
	wave sensor1A = dfrImporte:columnD
	wave sensor1B = dfrImporte:columnH
	wave sensor2A = dfrImporte:columnL
	wave sensor2B = dfrImporte:columnP	
	
	wave marcadores = dfrImporte:columnE
	SVAR actNIRSdata = dfrImporte:ExcelInfo
	string NIRSdataSheet = StringByKey("NAME", actNIRSdata)

	NewDataFolder/o dfrImporte:ProcessNIRS
	DFREF dfrNIRSproc = dfrImporte:ProcessNIRS		
		
	Interpolate2/N=1000/Y=dfrNIRSproc:$("sensor1A") tiempo,sensor1A
	Interpolate2/N=1000/Y=dfrNIRSproc:$("sensor1B") tiempo,sensor1B
	Interpolate2/N=1000/Y=dfrNIRSproc:$("sensor2A") tiempo,sensor2A
	Interpolate2/N=1000/Y=dfrNIRSproc:$("sensor2B") tiempo,sensor2B
	
	wave sensor1A = dfrNIRSproc:$("sensor1A")
	wave sensor1B = dfrNIRSproc:$("sensor1B")
	wave sensor2A = dfrNIRSproc:$("sensor2A")
	wave sensor2B = dfrNIRSproc:$("sensor2B")
	
	Duplicate/o sensor1A,dfrNIRSproc:$("Marcadores")
	wave MarcadoresProc = dfrNIRSproc:$("Marcadores")
	MarcadoresProc = 0
	
	Make/O/N=(0,2) dfrNIRSproc:MarcadorTimes/WAVE=MarcadorTimes
	
	FindLevels/Q/M=1 marcadores,1
	wave w_findlevels
	
	Redimension/n=(v_levelsFound,2) MarcadorTimes
	
	MarcadorTimes[][0] = w_Findlevels
	killwaves/z w_findlevels
	
	NewDataFolder/o dfrNIRSproc:Sensor1
	DFREF dfrNIRSprocS1 = dfrNIRSproc:Sensor1
	NewDataFolder/o dfrNIRSproc:Sensor2
	DFREF dfrNIRSprocS2 = dfrNIRSproc:Sensor2	
	
	variable i
	for (i=1;i<v_levelsFound;i++)
		variable inPoint = MarcadorTimes[i-1]
		variable outPoint = MarcadorTimes[i]
		
		variable inTime = tiempo[inPoint]
		variable outTime = tiempo[outPoint]
		
		printf "i %g, Marc %g (%g) to %g (%g)\n",i,inPoint,inTime,outPoint,outTime
		
		MarcadorTimes[i-1][1] = inTime
		MarcadoresProc[x2pnt(MarcadoresProc,inTime)] = i
		
		Duplicate/o/R=(inTime,outTime) sensor1A,dfrNIRSprocS1:$("sensor1A"+"_S"+num2str(i))
		Duplicate/o/R=(inTime,outTime) sensor1B,dfrNIRSprocS1:$("sensor1B"+"_S"+num2str(i))
		Duplicate/o/R=(inTime,outTime) sensor2A,dfrNIRSprocS2:$("sensor2A"+"_S"+num2str(i))
		Duplicate/o/R=(inTime,outTime) sensor2B,dfrNIRSprocS2:$("sensor2B"+"_S"+num2str(i))
		
		
	endfor
	
	MarcadorTimes[v_levelsFound-1][1] = outTime
	MarcadoresProc[x2pnt(MarcadoresProc,outTime)] = v_levelsFound-1
END

//Takes ; separated vuelo list with format Vuelo_%g
Function Flight_CalcAll_Multiple([string vueloList,variable allInRoot])

	//Where to get list of data
	IF(!ParamIsDefault(vueloList) && cmpstr(vueloList,"")!=0) //Valid vueloList
		printf "Processing flights: %s\n",vueloList
	ELSEIF(allInRoot==1) //Calc all available flights from loaded folders
		VueloList = loadFlight_CheckFolder()
		printf "Processing all flights: %s\n",vueloList
	//ELSEIF(allInRoot==2) //Calc a selection of flights from loaded folders
		//wave VuelosWave = root:Resources:Oximetry:VuelosStatus_Clean
	ELSE 
		print "Flight_CalcAll_Multiple: no data given"
		return 0
	ENDIF
	
	//Process data
	variable i
	//IF(allInRoot!=2)
		variable vueloCount = itemsInList(vueloList,";")
		for(i=0;i<vueloCount;i++)
			string actVueloStr = stringFromList(i,vueloList,";")
			IF(strsearch(actVueloStr,"Vuelo_",0)==-1)
				actVueloStr = "Vuelo_" + actVueloStr
			ENDIF
			Flight_CalcVuelo(actVueloStr)
		endfor
//	ELSE
//		vueloCount = dimSize(VuelosWave,0)
//		for(i=0;i<vueloCount;i++)
//			actVueloStr = getDimLabel(vuelosWave,0,i)
//			Flight_CalcVuelo(actVueloStr)
//		endfor		
//	ENDIF
	
	//Update status
	loadFlight_CheckFolder(reCheck=1)
	//vueloStatus_InfoWave(reCheck=1)
	//vueloStatus_CleanInfoWave()
END


//-------------------------------------------------------------------//

Function Flight_CalcVuelo(string vuelo)
	DFREF dfrResource = root:Resources:Oximetry
	wave VuelosStatus = dfrResource:VuelosStatus
	
	SVAR actvuelo = root:actVuelo
	actVuelo = vuelo
		
	DFREF dfrVuelo = root:$(actVuelo)
	IF(DataFolderRefStatus(dfrVuelo)==0)
		return 0
	ENDIF
	
	variable dimPos = findDimLabel(VuelosStatus,0,actVuelo)
	IF(dimPos==-2) //Not found?
		variable VuelosStatusSize = dimSize(VuelosStatus,0)
		InsertPoints/M=0 VuelosStatusSize, 1, VuelosStatus
		SetDimLabel 0,VuelosStatusSize,$actVuelo,VuelosStatus
	ENDIF
	VuelosStatus[dimPos][] = 0 //Reset
	
	//Get interpolated w_alt_L data. Find interest points
	variable altReturn = FlightData_First()
	IF(altReturn==-4 || altReturn==-5) 	//altReturn: -1=notFound, 1=Complete, -4=Descompresion, -5=Medico
		VuelosStatus[dimPos][] = -4 //Otro vuelo
	ELSEIF(altReturn==-1 || altReturn==0)
		VuelosStatus[dimPos][] = -1 //Incompleto
	ENDIF	

	//Get points of disconnection and connection of oxygen mask
	OximData_AllConexionTimes() 
	
	//PreProcess recordings of heart rate and oxygen (remove NaNs and artifacts)
	OximData_MakeSmoothed(factorSat=0,factorCard=0,medianTrsh=0) //0 values use default nums. factors -1 disables smoothing
	Oxim_GetDesaturationTimes()
	Oxim_GetHipoxiaTimes()
	
	//Get cut waves from important landmarks
	OximData_SepByEpochAll()
	
	//Get fits of cut waves
	OximData_SepByEpoch_AllFit()
	
	//Make Analysis data
	OximToImage_Make()
END	

//-----------------------------------------------------//

//Get vuelo altitude parameters. Create VueloInfo, return status por VueloStatus
Function FlightData_First()
	SVAR actvuelo = root:actVuelo
	DFREF dfrVuelo = root:$(actVuelo)
	setDataFolder dfrVuelo
	
	SVAR/Z s_tipodeVuelo
	variable tipoSearch = strSearch(s_tipoDeVuelo,"Descomp",0,2)
	IF(SVAR_Exists(s_tipodeVuelo)==1 && tipoSearch!=-1)
		return -4 //Vuelo descompresion rapida
	ENDIF
	tipoSearch = strSearch(s_tipoDeVuelo,"dico",0,2)
	IF(SVAR_Exists(s_tipodeVuelo)==1 && tipoSearch!=-1)
		return -5 //Vuelo Medico
	ENDIF	

	wave alt = dfrVuelo:w_alt
	wave altT = dfrVuelo:w_altT
	
	IF(!WaveExists(alt) || !WaveExists(altT))
		return -1
	ENDIF
	
	Make/O/N=(12) dfrVuelo:VueloInfo
	wave VueloInfo = dfrVuelo:VueloInfo
	
	SetDimLabel 0,0,$"FlightDuration",VueloInfo 		//"Duracion":Tiempo de vuelo (Numero de puntos @1hz)
	SetDimLabel 0,1,$"MinAltitude",VueloInfo 				//"Piso":Minima altura (En pies)
	SetDimLabel 0,2,$"MaxAltitude",VueloInfo				//"Cielo":Maxima altura (En pies)
	SetDimLabel 0,3,$"Ascent1",VueloInfo			//"Subida1":Tiempo comienzo primera subida (Al cruzar 5000 pies de altura) (Vuelos D y D+N)
	SetDimLabel 0,4,$"Descend1",VueloInfo 			//"Bajada1":Tiempo comienzo primer descenso (Al bajar de 5000 pies de altura) (Vuelos D y D+N)
	SetDimLabel 0,5,$"Ascent2",VueloInfo			//"Subida2":Tiempo comienzo primera subida (Al cruzar 5000 pies de altura) (Solo Vuelos D+N)
	SetDimLabel 0,6,$"AscentToPlateau",VueloInfo	//"PlateauSube":Tiempo cruce hacia arriba 24500 pies
	SetDimLabel 0,7,$"DescendFromPlateau",VueloInfo	//"PlateauBaja":Tiempo cruce hacia abajo 24500 pies
	SetDimLabel 0,8,$"DescendFrom22k",VueloInfo			//"Baja22k":Tiempo cruce hacia abajo 22000 pies
	SetDimLabel 0,9,$"DescendFrom18k",VueloInfo			//"Baja18k":Tiempo cruce hacia abajo 18000 pies
	SetDimLabel 0,10,$"DescendFrom17.5k",VueloInfo			//"Baja17k":Tiempo cruce hacia abajo 17500 pies
	SetDimLabel 0,11,$"DescendFrom5k",VueloInfo			//"BajaFin":Tiempo comienzo descenso final (Al bajar de 5000 pies de altura)
	
	Interpolate2/T=1/N=1000/Y=w_alt_L altT,alt
	wave altL = dfrVuelo:w_alt_L
	
	Duplicate/O altL,dfrVuelo:w_alt_Markers
	wave altMarkers = dfrVuelo:w_alt_Markers
	altMarkers = 0
	
	variable duracion = indextoScale(altL,numpnts(altL)-1,0)
	variable piso = waveMin(altL)
	variable cielo = waveMax(altL)

	variable offS = 100 //100 pies de gracia
	findLevels/Q/EDGE=1/M=(offS) altL,(5000) //Primera y segunda subidas
	wave W_FindLevels //2 expected
	variable subidas = v_levelsFound
	
		variable subida1 = round(W_FindLevels[0])
		altMarkers[x2pnt(altL,subida1)] = 5000
		IF(subidas>1)
			variable subida2 = round(w_FindLevels[1])
			altMarkers[x2pnt(altL,subida2)] = 5000
		ELSE
			variable incompleteMarker = 1
		ENDIF
	
	findLevels/Q/EDGE=2/M=(offS) altL,(5000) //1era bajada y piso final
	wave W_FindLevels //2 expected
	variable bajadas = v_levelsFound
	
		variable bajada1 = round(W_FindLevels[0])
		altMarkers[x2pnt(altL,bajada1)] = 5000
		IF(bajadas>1)
			variable bajaFin = round(W_FindLevels[1])
			altMarkers[x2pnt(altL,bajaFin)] = 5000
		ELSE
			incompleteMarker = 1
		ENDIF
	
	findLevels/Q/EDGE=1/M=(offS) altL,(24500) //Llegando a plateau
	wave W_FindLevels //1 expected
	
	IF(v_levelsFound>0)
		variable plateauSube = round(W_FindLevels[0])
		altMarkers[x2pnt(altL,plateauSube)] = 24500
	ELSE
		incompleteMarker = 1
	ENDIF		
	
	findLevels/Q/EDGE=2/M=(offS) altL,(24500) //Bajando de plateau
	wave W_FindLevels //1 expected
	
	IF(v_levelsFound>0)
		variable plateauBaja = round(W_FindLevels[0])
		altMarkers[x2pnt(altL,plateauBaja)] = 24500
	ELSE
		incompleteMarker = 1
	ENDIF
	
	findLevels/Q/EDGE=2/M=(offS) altL,(22000) //Bajando a 22mil
	wave W_FindLevels //1 expected
	
	IF(v_levelsFound>0)
		variable baja22k = round(W_FindLevels[0])
		altMarkers[x2pnt(altL,baja22k)] = 22000
	ELSE
		incompleteMarker = 1
	ENDIF		
	
	findLevels/Q/EDGE=2/M=(offS) altL,(18000) //Bajando a 18mil
	wave W_FindLevels //1 expected
	
	IF(v_levelsFound>0)
		variable baja18k = round(W_FindLevels[0])
		altMarkers[x2pnt(altL,baja18k)] = 18000
	ELSE
		incompleteMarker = 1
	ENDIF		
		
	findLevels/Q/EDGE=2/M=(offS) altL,(17500) //Bajando a terra
	wave W_FindLevels //1 expected
	
	IF(v_levelsFound>0)
		variable baja17k = round(W_FindLevels[0])
		altMarkers[x2pnt(altL,baja17k)] = 17500	
	ELSE
		incompleteMarker = 1
	ENDIF			
	
	VueloInfo = {duracion,piso,cielo,subida1,bajada1,subida2,plateauSube,plateauBaja,baja22k,baja18k,baja17k,bajaFin}
	
	string noteVuelo
	//sprintf noteVuelo,"dur %g, piso %g, cielo %g,subida1 %g,bajada1 %g, subida2 %g,plateauSube %g,plateauBaja %g,baja22k %g, baja18k %g, baja17.5k %g, bajaFin %g"\
	sprintf noteVuelo,"FlightDuration %g, MinAltitude %g, MaxAltitude %g, Ascent1 %g, Descend1 %g, Ascent2 %g, AscentToPlateau %g, DescendFromPlateau %g, DescendFrom22k %g, DescendFrom18k %g, DescendFrom17.5k %g, DescendFrom5k %g"\
	,duracion,piso,cielo,subida1,bajada1,subida2,plateauSube,plateauBaja,baja22k,baja18k,baja17k,bajaFin
	note/K altL,noteVuelo
	note/K VueloInfo,noteVuelo
	
	IF(incompleteMarker==1)
		return 0
	ELSE
		return 1
	ENDIF
END 

//-------------------------------------------------------------------//

//Get connection and disconnection points from w_conexion, 
//put results in Oxim_ConexionTimes matrix by oxim number
Function OximData_AllConexionTimes([variable VueloType])
	DFREF dfrResource = root:Resources:Oximetry
	NVAR OximIni = dfrResource:OximIni
	NVAR OximFin = dfrResource:OximLast
		
	SVAR actvuelo = root:actVuelo
	DFREF dfrVuelo = root:$(actVuelo)
	
	wave VuelosStatus = dfrResource:VuelosStatus
	variable VuelodimPos = findDimLabel(VuelosStatus,0,actVuelo) 
	
	variable totalOxims = OximFin - OximIni + 1
	
	make/O/N=(totalOxims,6) dfrVuelo:Oxim_ConexionTimes = 0
	wave ConexionTimes = dfrVuelo:Oxim_ConexionTimes
	
	SetDimLabel 1,0,'First DC',ConexionTimes
	SetDimLabel 1,1,'First ReC',ConexionTimes
	SetDimLabel 1,2,'First dif',ConexionTimes
	SetDimLabel 1,3,'Second DC',ConexionTimes
	SetDimLabel 1,4,'Second ReC',ConexionTimes
	SetDimLabel 1,5,'Second dif',ConexionTimes
	
	variable i
	for(i=0;i<totalOxims;i++)
		variable actOxNum = OximIni + i
		string actOxStr = "Oxim_"+num2str(actOxNum)
		variable VueloOxdimPos = findDimLabel(VuelosStatus,1,actOxStr)
		
		variable actStatus = VuelosStatus[VuelodimPos][VueloOxdimPos]
		variable procStatus = 0
		
		SetDimLabel 0,i,$(actOxStr),ConexionTimes
		
		DFREF dfrOx = dfrVuelo:$("Oxim_"+num2str(actOxNum))
		wave w_conexion = dfrOx:'w_conexion'
		IF(!WaveExists(w_conexion) || dimSize(w_conexion,0)==0)
			printf "[%s] OximData_AllConexionTimes: Oximeter %g conection times not found\n",actVuelo,actOxNum
			if(actStatus!=4)
				VuelosStatus[VuelodimPos][VueloOxdimPos] = -2
			endif
			continue
		ENDIF
		
		Findlevels/Q w_conexion,0
		wave W_FindLevels
		IF(V_flag==2 || v_levelsFound==0)
			printf "[%s] OximData_AllConexionTimes: Oximeter %g no disconnect\n",actVuelo,actOxNum
			if(actStatus!=-4)
				VuelosStatus[VuelodimPos][VueloOxdimPos] = -2
			endif
			continue
		ENDIF
		IF((w_conexion[0]==0 || W_FindLevels[0]<200) && actStatus!=-4)
			deletePoints 0,1,W_FindLevels //Fix oxim start on 0
		ENDIF
		
		IF(actStatus==-4 && v_levelsFound==1) 	//1 crossing only (1->0 || 0->1)
			ConexionTimes[i][0] = 0
			ConexionTimes[i][1] = W_FindLevels[0]
			ConexionTimes[i][2] = W_FindLevels[0]		
		ELSE													//Normal off and on (1->0->1)
			ConexionTimes[i][0] = W_FindLevels[0]
			ConexionTimes[i][1] = W_FindLevels[1]
			ConexionTimes[i][2] = W_FindLevels[1] - W_FindLevels[0]
		
			IF(v_levelsFound<=2)
				printf "OximData_AllConexionTimes: Oximeter %g only 1 disconnect (2 expected)\n",actOxNum
				procStatus = -1
			ELSEIF(v_levelsFound<=3)
				printf "OximData_AllConexionTimes: Oximeter %g second disconnect incomplete data\n",actOxNum
				procStatus = -1
			ELSE	
				ConexionTimes[i][3] = W_FindLevels[2]
				ConexionTimes[i][4] = W_FindLevels[3]
				ConexionTimes[i][5] = W_FindLevels[3] - W_FindLevels[2]
			ENDIF
		ENDIF
		
		//Update status for every oximeter	
		IF(actStatus==0 && procStatus==0) //Got here without errors
			VuelosStatus[VuelodimPos][VueloOxdimPos] = 1 //1: complete data
		ELSEIF(actStatus==-4)
			VuelosStatus[VuelodimPos][VueloOxdimPos] = -4 //-4: Another flight type (Medico/Descompresion)
		ELSE
			VuelosStatus[VuelodimPos][VueloOxdimPos] = procStatus //-1: AAAA, -2: BBBBB
		ENDIF
	endfor

	killWaves W_FindLevels
	OximData_AllConexionTimes_ToDisplayWave()
	return 1
END

//-------------------------------------------------------------------//

Function OximData_AllConexionTimes_ToDisplayWave()

	SVAR actvuelo = root:actVuelo
	DFREF dfrVuelo = root:$(actVuelo)
		
	wave ConexionTimes = dfrVuelo:Oxim_ConexionTimes
	variable totalOxims = dimSize(ConexionTimes,0)

	wave altura = dfrVuelo:w_alt_L
	IF(!waveExists(altura))
		return 0
	ENDIF
	
	Duplicate/O altura,dfrVuelo:w_alt_OximMarkers
	wave oximMarkers = dfrVuelo:w_alt_OximMarkers
	oximMarkers = 0
	
	variable i
	FOR(i=0;i<totalOxims;i++)
		variable markPos1 = scaleToIndex(oximMarkers,Conexiontimes[i][0],0) //First DC
		variable markPos2 = scaleToIndex(oximMarkers,Conexiontimes[i][1],0) //First RC
		IF(markPos1>0 && markPos2>0)
			oximMarkers[markPos1] = i + 1
			oximMarkers[markPos2] = i + 1
		ENDIF
		
		variable markPos3 = scaleToIndex(oximMarkers,Conexiontimes[i][3],0)	//Second DC
		variable markPos4 = scaleToIndex(oximMarkers,Conexiontimes[i][4],0) //Second RC
		IF(markPos3>0 && markPos4>0)
			oximMarkers[markPos3] = i + 1
			oximMarkers[markPos4] = i + 1
		ENDIF
	ENDFOR
END

//-------------------------------------------------------------------//

//Make clean versions of heart rate and oxygen saturation
Function OximData_MakeSmoothed([variable factorSat,variable factorCard,variable medianTrsh])
	DFREF dfrResource = root:Resources:Oximetry
	NVAR OximIni = dfrResource:OximIni
	NVAR OximFin = dfrResource:OximLast
	
	SVAR actvuelo = root:actVuelo
	DFREF dfrVuelo = root:$(actVuelo)
	
	wave VuelosStatus = dfrResource:VuelosStatus
	variable VuelodimPos = findDimLabel(VuelosStatus,0,actVuelo) 
	
	IF(factorSat==0)
		factorSat = 10 //Smoothing factor of saturation
	ENDIF
	IF(factorCard==0)
		factorCard = 10 //Smoothing factor of heart rate
	ENDIF
	IF(medianTrsh==0)
		medianTrsh = 10 //Min difference for outlier detection
	ENDIF
	
	variable localNanWindow = 30 //points window for finding median when missing values
	variable localMedianWindow = 15 //points window for finding bad peaks and replacing with median
	
	variable i,actStatus
	for(i=OximIni;i<=oximFin;i++)
		actStatus = 0
		string actOxStr = "Oxim_"+num2str(i)
		DFREF dfrOx = dfrVuelo:$(actOxStr)
		variable VueloOxdimPos = findDimLabel(VuelosStatus,1,actOxStr)
		
		wave w_saturacion = dfrOx:$("w_sat")
		IF(!WaveExists(w_saturacion))
			printf "[%s] OximData_MakeSmoothed: Oximeter %g w_sat not found\n",actVuelo,i
			actStatus = -2
		ELSEIF(numpnts(w_saturacion)<=localNanWindow)
			printf "[%s] OximData_MakeSmoothed: Oximeter %g w_sat has no data\n",actVuelo,i
			actStatus = -2
		ELSE
			Duplicate/O w_saturacion,dfrOx:$("w_sat"+"_proc")
			wave w_satProc = dfrOx:$("w_sat"+"_proc")
			SetScale/P x 0,1,"s",w_satProc
			
			Smooth/M=(NaN) localNanWindow, w_satProc //Fill NaNs with local median of 20 points window
			Smooth/M=(medianTrsh) localMedianWindow, w_satProc //Smooth outliers differing by medianTrsh from local median of 10 pts window
			
			IF(factorSat!=-1) //factorSad = -1 disables
				Smooth/B factorSat, w_satProc
			ENDIF
			actStatus = 1
		ENDIF
		
		wave w_cardiaco = dfrOx:$("w_lpm")
		IF(!WaveExists(w_cardiaco))
			printf "[%s] OximData_MakeSmoothed: Oximeter %g w_lpm not found\n",actVuelo,i
			actStatus = -2
		ELSEIF(numpnts(w_cardiaco)<=localNanWindow)
			printf "[%s] OximData_MakeSmoothed: Oximeter %g w_lpm has no data\n",actVuelo,i
			actStatus = -2
		ELSE
			Duplicate/O w_cardiaco,dfrOx:$("w_lpm"+"_proc")
			wave w_cardProc = dfrOx:$("w_lpm"+"_proc")
			SetScale/P x 0,1,"s",w_cardProc
			
			Smooth/M=(NaN) localNanWindow, w_cardProc
			Smooth/M=(medianTrsh) localMedianWindow, w_cardProc
			
			IF(factorCard!=-1)
				Smooth/B factorCard, w_cardProc
			ENDIF
			actStatus = 1
		ENDIF
		
		IF(VuelosStatus[VuelodimPos][VueloOxdimPos]==0 && actStatus==1) //Incomplete?
			VuelosStatus[VuelodimPos][VueloOxdimPos] = actStatus
		ENDIF
	endfor
END

//-------------------------------------------------------------------//

Function OximData_SepByEpochAll()
	DFREF dfrResource = root:Resources:Oximetry
	NVAR OximIni = dfrResource:OximIni
	NVAR OximFin = dfrResource:OximLast
	
	variable totalOxims = OximFin - OximIni + 1
	
	SVAR actvuelo = root:actVuelo
	DFREF dfrVuelo = root:$(actVuelo)
	
	variable numSegments = 9
	
	make/O/N=(totalOxims,8,numSegments) dfrVuelo:Oxim_SegmentData = 0
	wave SegmentData = dfrVuelo:Oxim_SegmentData
	
	SetDimLabel 1,0,'O2 MinVal',SegmentData
	SetDimLabel 1,1,'O2 MaxVal',SegmentData
	SetDimLabel 1,2,'O2 AvgVal',SegmentData
	SetDimLabel 1,3,'O2 MedianVal',SegmentData
	SetDimLabel 1,4,'HR MinVal',SegmentData
	SetDimLabel 1,5,'HR MaxVal',SegmentData
	SetDimLabel 1,6,'HR AvgVal',SegmentData
	SetDimLabel 1,7,'HR MedianVal',SegmentData

	variable i,j
	for(i=0;i<totalOxims;i++)
		variable actOxNum = OximIni + i
		SetDimLabel 0,i,$("Oxim_"+num2str(actOxNum)),SegmentData
		
		wave/WAVE AllSegRef = OximData_SepByEpoch(actOxNum)
		//variable segCount = dimSize(AllSegRef,0)
		IF(!WaveExists(AllSegRef))
			//printf "OximData_SepByEpochAll: Oxim %g no disponible\n",actOxNum
			continue
		ENDIF
		
		for(j=0;j<numSegments;j++)
			wave actSat = AllSegRef[j][0] //Saturation wave by segment
			wave actCard = AllSegRef[j][1] //Heart rate wave by segment
			
			SegmentData[i][0][j] = waveMin(actSat)
			SegmentData[i][1][j] = waveMax(actSat)
			SegmentData[i][2][j] = mean(actSat)
			SegmentData[i][3][j] = median(actSat)
			
			SegmentData[i][4][j] = waveMin(actCard)
			SegmentData[i][5][j] = waveMax(actCard)
			SegmentData[i][6][j] = mean(actCard)
			SegmentData[i][7][j] = median(actCard)
		endfor
	endfor
END

//**//

Function/WAVE OximData_SepByEpoch(variable oximNum)
	
	SVAR actvuelo = root:actVuelo
	DFREF dfrVuelo = root:$(actVuelo)
	
	SVAR actOxim = root:actOxim
	sprintf actOxim,"Oxim_%g",oximNum
	DFREF dfrOx = dfrVuelo:$(actOxim)
	
	wave VueloInfo = dfrVuelo:VueloInfo
	IF(!waveExists(VueloInfo))
		variable noVueloInfo = 1
	ENDIF
	
	wave ConexionTimes = dfrVuelo:Oxim_ConexionTimes
	IF(!waveExists(ConexionTimes))
		variable noConexionTimes = 1
	ENDIF	
	variable oximRowNum = findDimLabel(ConexionTimes,0,actOxim)
	IF(ConexionTimes[oximRowNum][0]==0)
		//printf "OximData_SepByEpoch: sin segmentos en oximetro %g\n",oximNum
		return $("")
	ENDIF
	
	Wave DesaturationTimes = dfrVuelo:Oxim_DesaturationTimes
	IF(!waveExists(DesaturationTimes))
		variable noDesaturationTimes = 1
	ENDIF	
	
	wave w_satProc = dfrOx:$("w_sat"+"_proc")
	wave w_cardProc = dfrOx:$("w_lpm"+"_proc")
		IF(!WaveExists(w_satProc) ||  !WaveExists(w_cardProc))
			//printf "OximData_SepByEpoch: Oxim %g no encontrado\n",oximNum
			return $("")
		ENDIF
	
	variable numPtsWaves = min( numpnts(w_satProc),numpnts(w_cardProc) )
	
	variable extraPts = 20
	
	variable numSegments = 9
	
	Make/O/N=(numSegments,2)/WAVE dfrOx:$("AllSegmentRefWave") //Wave reference for segments
	wave/WAVE AllSegRef = dfrOx:$("AllSegmentRefWave")
	SetDimLabel 1,0,'Saturation',AllSegRef
	SetDimLabel 1,1,'HeartRate',AllSegRef
	
	Make/O/N=(numSegments,2) dfrOx:$("AllSegmentTimes") //Timestamps of each segment
	wave AllSegTimes = dfrOx:$("AllSegmentTimes")
	SetDimLabel 1,0,'In',AllSegTimes
	SetDimLabel 1,1,'Out',AllSegTimes

	//1.Post primera bajada antes segunda subida: baseline
	IF(noVueloInfo==0)
		variable p1L = vueloInfo[4] + 100//0
		variable p1R = vueloInfo[5] - 100//ConexionTimes[oximRowNum][0]
		
		if(p1L<p1R && p1L!=0 && p1R!=0)
				Duplicate/O/R=[p1L,p1R] w_satProc,dfrOx:$("w_sat"+"_proc_S1")/WAVE=satP1
				Duplicate/O/R=[p1L,p1R] w_cardProc,dfrOx:$("w_lpm"+"_proc_S1")/WAVE=cardP1
		endif
	ENDIF
	
	//2.Comienzo de ascenso hasta primera desconexion: anticipacion
	IF(noVueloInfo==0 && noConexionTimes==0)
		variable p2L = vueloInfo[5]
		variable p2R = ConexionTimes[oximRowNum][0]
	
		if(p2L<p2R && p2L!=0 && p2R!=0)
			Duplicate/O/R=[p2L,p2R] w_satProc,dfrOx:$("w_sat"+"_proc_S2")/WAVE=satP2
			Duplicate/O/R=[p2L,p2R] w_cardProc,dfrOx:$("w_lpm"+"_proc_S2")/WAVE=cardP2
		endif
	ENDIF
	
	//3.Primera desaturacion hasta conexion de mascara
	IF(noConexionTimes==0 && noDesaturationTimes==0)
		variable p3L = DesaturationTimes[oximRowNum][0]
		variable p3R = ConexionTimes[oximRowNum][1]
		
		if(p3L<p3R && p3L!=0 && p3R!=0)
			Duplicate/O/R=[p3L,p3R] w_satProc,dfrOx:$("w_sat"+"_proc_S3")/WAVE=satP3
			Duplicate/O/R=[p3L,p3R] w_cardProc,dfrOx:$("w_lpm"+"_proc_S3")/WAVE=cardP3
		endif
	ENDIF
	
	//4.Primera reconexion hasta minimo saturacion
	IF(noConexionTimes==0 && noDesaturationTimes==0)
		variable p4L = ConexionTimes[oximRowNum][1]
		//Find minimo
		Duplicate/FREE/R=[p4L,DesaturationTimes[oximRowNum][1]] w_satProc,w_SatProcFindMin
		WaveStats/Q w_SatProcFindMin
		wave M_WaveStats
		variable p4R = v_MinLoc
		killWaves/Z M_WaveStats
		//
		
		if(p4L<p4R && p4L!=0 && p4R!=0)
			Duplicate/O/R=[p4L,p4R] w_satProc,dfrOx:$("w_sat"+"_proc_S4")/WAVE=satP4
			Duplicate/O/R=[p4L,p4R] w_cardProc,dfrOx:$("w_lpm"+"_proc_S4")/WAVE=cardP4
		endif
	ENDIF
	
	//5.Post recuperacion delay hasta primera resaturacion
	IF(noConexionTimes==0 && noDesaturationTimes==0)
		variable p5L = p4R//DesaturationTimes[oximRowNum][1]
		variable p5R = DesaturationTimes[oximRowNum][1]
		
		if(p5L<p5R && p5L!=0 && p5R!=0)
			Duplicate/O/R=[p5L,p5R] w_satProc,dfrOx:$("w_sat"+"_proc_S5")/WAVE=satP5
			Duplicate/O/R=[p5L,p5R] w_cardProc,dfrOx:$("w_lpm"+"_proc_S5")/WAVE=cardP5
		endif
	ENDIF	
	
	//6.Primera resaturacion hasta desconexion: Intervalo altura
	IF(noConexionTimes==0 && noDesaturationTimes==0)
		variable p6L = DesaturationTimes[oximRowNum][1]
		variable p6R = ConexionTimes[oximRowNum][3]
		
		if(p6L<p6R && p6L!=0 && p6R!=0)
			Duplicate/O/R=[p6L,p6R] w_satProc,dfrOx:$("w_sat"+"_proc_S6")/WAVE=satP6
			Duplicate/O/R=[p6L,p6R] w_cardProc,dfrOx:$("w_lpm"+"_proc_S6")/WAVE=cardP6
		endif
	ENDIF
	
	//7.Segunda desaturacion hasta conexion de mascara
	IF(noConexionTimes==0 && noDesaturationTimes==0)
		variable p7L = DesaturationTimes[oximRowNum][3]
		variable p7R = ConexionTimes[oximRowNum][4]
		
		if(p7L<p7R && p7L!=0 && p7R!=0)
			Duplicate/O/R=[p7L,p7R] w_satProc,dfrOx:$("w_sat"+"_proc_S7")/WAVE=satP7
			Duplicate/O/R=[p7L,p7R] w_cardProc,dfrOx:$("w_lpm"+"_proc_S7")/WAVE=cardP7
		endif
	ENDIF
	
	//8.Segunda conexion de mascara hasta resaturacion
	IF(noConexionTimes==0 && noDesaturationTimes==0)
		variable p8L = ConexionTimes[oximRowNum][4]
		variable p8R = DesaturationTimes[oximRowNum][4]
		
		if(p8L<p8R && p8L!=0 && p8R!=0)
			Duplicate/O/R=[p8L,p8R] w_satProc,dfrOx:$("w_sat"+"_proc_S8")/WAVE=satP8
			Duplicate/O/R=[p8L,p8R] w_cardProc,dfrOx:$("w_lpm"+"_proc_S8")/WAVE=cardP8
		endif
	ENDIF
	
	//9.Descenso hasta piso
	IF(noVueloInfo==0)
		variable p9L = vueloInfo[10]
		variable p9R = vueloInfo[11]
		
		if(p9L<p9R && p9L!=0 && p9R!=0)
			Duplicate/O/R=[P9L,P9R] w_satProc,dfrOx:$("w_sat"+"_proc_S9")/WAVE=satP9
			Duplicate/O/R=[P9L,P9R] w_cardProc,dfrOx:$("w_lpm"+"_proc_S9")/WAVE=cardP9
		endif
	ENDIF
	
	//Save segments
	AllSegRef[][0] = {satP1,satP2,satP3,satP4,satP5,satP6,satP7,satP8,satP9}
	AllSegRef[][1] = {cardP1,cardP2,cardP3,cardP4,cardP5,cardP6,cardP7,cardP8,cardP9}
	
	//Save times
	AllSegTimes[][0] = {p1L,p2L,p3L,p4L,p5L,p6L,p7L,p8L,p9L}
	AllSegTimes[][1] = {p1R,p2R,p3R,p4R,p5R,p6R,p7R,p8R,p9R}
	
	return AllSegRef
END

//-------------------------------------------------------------------//

Function OximData_SepByEpoch_AllFit()
	DFREF dfrResource = root:Resources:Oximetry
	NVAR OximIni = dfrResource:OximIni
	NVAR OximFin = dfrResource:OximLast
	
	variable totalOxims = OximFin - OximIni + 1
	
	SVAR actvuelo = root:actVuelo
	DFREF dfrVuelo = root:$(actVuelo)
	
	variable numSegments = 9
	
	make/O/N=(totalOxims,8,numSegments) dfrVuelo:Oxim_SegmentFitCoefs = 0
	wave SegmentFit = dfrVuelo:Oxim_SegmentFitCoefs
	
	SetDimLabel 1,0,'O2 C1',SegmentFit
	SetDimLabel 1,1,'O2 C2',SegmentFit
	SetDimLabel 1,2,'O2 S1',SegmentFit
	SetDimLabel 1,3,'O2 s2',SegmentFit
	SetDimLabel 1,4,'HR C1',SegmentFit
	SetDimLabel 1,5,'HR C2',SegmentFit
	SetDimLabel 1,6,'HR S1',SegmentFit
	SetDimLabel 1,7,'HR S2',SegmentFit
	
	wave ConexionTimes = dfrVuelo:Oxim_ConexionTimes
	matrixop/free noConexion = maxRows(ConexionTimes) //check wave

	variable i,j
	for(i=0;i<totalOxims;i++)
		variable actOxNum = OximIni + i
		IF(noConexion[i]==0)
			//printf "OximData_SepByEpoch_AllFit: Oxim %g no activo\n",actOxNum
			continue
		ENDIF
		wave fitData = OximData_SepByEpoch_Fit(actOxNum)
		IF(!WaveExists(fitData))
			//printf "OximData_SepByEpoch_AllFit: Oxim %g no encontrado\n",actOxNum
			continue
		ENDIF
		
		SetDimLabel 0,i,$("Oxim_"+num2str(actOxNum)),SegmentFit
		
		SegmentFit[i][][] = fitData[0][q][r]
	endfor
END

//-------------------------------------------------------------------//

Function OximData_CustomFit()
	SVAR actvuelo = root:actVuelo
	SVAR actOxim = root:actOxim
	
	DFREF dfrVuelo = root:$(actVuelo)
	
	variable oximNum
	sscanf actOxim,"Oxim_%g",oximNum
	DFREF dfrOx = dfrVuelo:$(actOxim)
	IF(DataFolderRefStatus(dfrOx)==0)
		return 0
	ENDIF
	setDataFolder dfrOx
	
	DoWindow/HIDE=? $("OximWindow")
	variable i,winExists = v_flag
	
	String ActiveWin = ChildWindowList("OximWindow")
	IF(itemsInList(ActiveWin,";")==0)
		//printf "OximPanel display window not active\n"
		return 0
	ENDIF
	activeWin = "OximWindow" + "#" + stringFromList(0,ActiveWin,";")

	string OnGraph = TraceNameList(activeWin,";",1)
	
	variable cursorApos = str2num(StringByKey("POINT", CsrInfo(A,activeWin), ":", ";"))
	variable cursorBpos = str2num(StringByKey("POINT", CsrInfo(B,activeWin), ":", ";"))
	
	IF(numType(cursorApos)==2 || numType(cursorBpos)==2 || (cursorApos==0 && cursorBpos==0))
		return 0
	ENDIF
	
	string satName = "w_sat_proc"
	string cardName = "w_lpm_proc"
	
	wave w_satProc = TraceNameToWaveRef(activeWin,satName)
	wave w_cardProc = TraceNameToWaveRef(activeWin,cardName)

	duplicate/O/R=[cursorApos,cursorBpos] w_satProc,dfrOx:$(satName+"_CustomFit")/WAVE=satCustom
	duplicate/O/R=[cursorApos,cursorBpos] w_cardProc,dfrOx:$(cardName+"_CustomFit")/WAVE=cardCustom
			
	variable actSegCardLen = dimSize(satCustom,0)
	variable actSegSatLen = dimSize(cardCustom,0)
	
	variable actSegSatDelta = DimDelta(satCustom,0)
	variable actSegCardDelta = DimDelta(cardCustom,0)
	
	variable actSegCardOffs = DimOffset(satCustom,0)
	variable actSegSatOffs = DimOffset(cardCustom,0)	
	
	setScale/P x,0,actSegSatDelta,satCustom
	setScale/P x,0,actSegCardDelta,cardCustom
	
	CurveFit/L=(actSegCardLen) line, satCustom/D
	string customFitSatName = "fit_"+satName+"_CustomFit"
	wave customFitSat = $(customFitSatName)
	wave W_coef,W_Sigma
	
	printf "\n"
	
	CurveFit/L=(actSegCardLen) line, cardCustom/D
	string customFitCardName = "fit_"+cardName+"_CustomFit"
	wave customFitCard = $(customFitCardName)
	wave W_coef,W_Sigma	
	
	//
	
	
	
	//
	
	setScale/P x,actSegSatOffs,actSegSatDelta,satCustom,customFitSat
	setScale/P x,actSegCardOffs,actSegCardDelta,cardCustom,customFitCard
	
	wave customfitSatFind = TraceNameToWaveRef(activeWin,customFitSatName)
	IF(!waveExists(customfitSatFind))
		AppendToGraph/W=$(activeWin) satCustom,customFitSat
		ModifyGraph/W=$(activeWin) rgb($customFitSatName)=(0,0,0),lsize($customFitSatName)=2
	ENDIF	
	
	wave customfitCardFind = TraceNameToWaveRef(activeWin,customFitCardName)
	IF(!waveExists(customfitCardFind))
		AppendToGraph/W=$(activeWin) cardCustom,customFitCard
	ModifyGraph/W=$(activeWin) rgb($customFitCardName)=(0,0,0),lsize($customFitCardName)=2
	ENDIF
	
END

//-------------------------------------------------------------------//

Function/WAVE OximData_SepByEpoch_Fit(variable oximNum)

	SVAR actvuelo = root:actVuelo
	DFREF dfrVuelo = root:$(actVuelo)
	
	SVAR actOxim = root:actOxim
	sprintf actOxim,"Oxim_%g",oximNum
	DFREF dfrOx = dfrVuelo:$(actOxim)
		IF(DataFolderRefStatus(dfrOx)==0)
			printf "OximData_SepByEpoch_Fit: Oximeter %g not found\n",oximNum
			return $("")
		ENDIF
	setDataFolder dfrOx
	
	wave/WAVE AllSegRef = dfrOx:AllSegmentRefWave
	variable numSegments = DimSize(AllSegRef,0)
	IF(numType(numSegments)==2 || numSegments==0)
		return $("")
	ENDIF

	make/FREE/N=(1,8,numSegments) fitParams
	
	Make/O/N=(numSegments,2)/WAVE dfrOx:$("AllFitRefWave") //Wave reference for fits of segments
	wave/WAVE AllFitRef = dfrOx:$("AllFitRefWave")
	SetDimLabel 1,0,'Saturation',AllFitRef
	SetDimLabel 1,1,'HeartRate',AllFitRef
	
	variable i
	for(i=0;i<numSegments;i++)
		wave actSegCard = AllSegRef[i][0]
		wave actSegSat = AllSegRef[i][1]
		IF(!waveExists(actSegCard) || numtype(waveMax(actSegCard))==2 || dimSize(actSegCard,0)<10)
			continue //Invalid wave
		ENDIF
		IF(!waveExists(actSegSat) || numtype(waveMax(actSegSat))==2 || dimSize(actSegSat,0)<10)
			continue //Invalid wave
		ENDIF
		
		variable actSegCardLen = dimSize(actSegCard,0)
		variable actSegSatLen = dimSize(actSegSat,0)
		
		variable actSegCardOffs = DimOffset(actSegCard,0)
		variable actSegSatOffs = DimOffset(actSegSat,0)
		
		variable actSegCardDelta = DimDelta(actSegCard,0)
		variable actSegSatDelta = DimDelta(actSegSat,0)
		
		string SegCardName = nameOfWave(actSegCard)
		string SegSatName = nameOfWave(actSegSat)
		
		setScale/P x,0,actSegCardDelta,actSegCard
		setScale/P x,0,actSegSatDelta,actSegSat
		
		CurveFit/Q/L=(actSegCardLen) line, actSegCard/D
		wave actFitCard = $("fit_"+SegCardName)
		wave W_coef,W_Sigma
		
		fitParams[0][0][i] = W_coef[0]
		fitParams[0][1][i] = W_coef[1]
		fitParams[0][2][i] = W_sigma[0]
		fitParams[0][3][i] = W_sigma[1]
		
		CurveFit/Q/L=(actSegSatLen) line, actSegSat/D
		wave actFitSat = $("fit_"+SegSatName)
		wave W_coef,W_Sigma
		
		fitParams[0][4][i] = W_coef[0]
		fitParams[0][5][i] = W_coef[1]
		fitParams[0][6][i] = W_sigma[0]
		fitParams[0][7][i] = W_sigma[1]
		
		AllFitRef[i][0] = actFitSat
		AllFitRef[i][1] = actFitCard
		
		setScale/P x,actSegCardOffs,actSegCardDelta,actSegCard,actFitSat
		setScale/P x,actSegSatOffs,actSegSatDelta,actSegSat,actFitCard
	endfor
	
	return fitParams
END

//-------------------------------------------------------------------//

Function Oxim_GetDesaturationTimes()

	SVAR actvuelo = root:actVuelo
	DFREF dfrVuelo = root:$(actVuelo)

	SVAR actOxim = root:actOxim	
	variable actOxNuM
	sscanf ActOxim,"Oxim_%g",actOxNum
	
	DFREF dfrResource = root:Resources:Oximetry
	NVAR OximIni = dfrResource:OximIni
	NVAR OximFin = dfrResource:OximLast
	variable totalOxims = OximFin - OximIni + 1
	
	make/O/N=(totalOxims,6) dfrVuelo:Oxim_DesaturationTimes = 0
	wave DesaturationTimes = dfrVuelo:Oxim_DesaturationTimes
	
	SetDimLabel 1,0,'First Desat',DesaturationTimes
	SetDimLabel 1,1,'First Recover',DesaturationTimes
	SetDimLabel 1,2,'First dif',DesaturationTimes
	SetDimLabel 1,3,'Second Desat',DesaturationTimes
	SetDimLabel 1,4,'Second Recover',DesaturationTimes
	SetDimLabel 1,5,'Second dif',DesaturationTimes

	variable i
	for(i=0;i<totalOxims;i++)
		actOxNum = OximIni + i
		
		SetDimLabel 0,i,$("Oxim_"+num2str(actOxNum)),DesaturationTimes
		
		DFREF dfrOx = dfrVuelo:$("Oxim_"+num2str(actOxNum))
		wave saturation = dfrOx:'w_sat_proc'
		IF(!WaveExists(saturation))
			//printf "[%s] Oxim_GetDesaturationTimes: Oxim %g no encontrado\n",actVuelo,actOxNum
			continue
		ENDIF

		findLevels/Q/EDGE=2 saturation,(97) //Bajando a de 97%
		wave W_FindLevels //2 expected
		IF(V_flag==2 || v_levelsFound==0)
			//printf "[%s] Oxim_GetDesaturationTimes: Oxim %g no hay desaturacion\n",actVuelo,actOxNum
			continue
		ENDIF
		
		variable DC1 = W_FindLevels[0] //Primera y segunda Desaturaciones
		IF(v_levelsFound>1)
			variable DC2 = W_FindLevels[1]
		ENDIF
		
		findLevels/Q/EDGE=1 saturation,(97) //Recuperandose sobre 97%
		wave W_FindLevels //2 expected
		IF(V_flag==2 || v_levelsFound==0)
			//printf "[%s] Oxim_GetDesaturationTimes: Oxim %g no hay resaturacion\n",actVuelo,actOxNum
			continue
		ENDIF
		
		variable RC1 = W_FindLevels[0] //Primera y segunda recuperacion
		IF(v_levelsFound>1)
			variable RC2 = W_FindLevels[1]
		ENDIF
		
		IF(DC1!=0 && RC1!=0)
		DesaturationTimes[i][0] = round(DC1)
		DesaturationTimes[i][1] = round(RC1)
		DesaturationTimes[i][2] = round(RC1 - DC1)
		ENDIF
		IF(DC2!=0 && RC2!=0)
		DesaturationTimes[i][3] = round(DC2)
		DesaturationTimes[i][4] = round(RC2)
		DesaturationTimes[i][5] = round(RC2 - DC2)
		ENDIF
	endfor

	killWaves W_FindLevels
	
	//Get lag from mask DC or RC and desaturation status
	Duplicate/O DesaturationTimes,dfrVuelo:Oxim_DesaturationLag
	wave DesatLag = dfrVuelo:Oxim_DesaturationLag
	DesatLag = 0
	
	wave ConexionTimes = dfrVuelo:Oxim_ConexionTimes
	matrixop/free noConexion = maxRows(ConexionTimes)
	variable j
	for(j=0;j<dimSize(ConexionTimes,0);j++) //Clean desaturations with no corresponding mask dif.
		IF(noConexion[j]==0)
			DesaturationTimes[j][] = 0
		ENDIF
	endfor
	
	DesatLag = DesaturationTimes - ConexionTimes 
	
	SetDimLabel 1,0,' Lag DC1',DesatLag
	SetDimLabel 1,1,'Lag RC1',DesatLag
	SetDimLabel 1,2,'Sat vs Conect1',DesatLag
	SetDimLabel 1,3,'Lag DC2',DesatLag
	SetDimLabel 1,4,'Lag RC2',DesatLag
	SetDimLabel 1,5,'Sat vs Conect1',DesatLag
END

//-------------------------------------------------------------------//

Function Oxim_GetHipoxiaTimes()

	SVAR actvuelo = root:actVuelo
	DFREF dfrVuelo = root:$(actVuelo)

	SVAR actOxim = root:actOxim	
	variable actOxNuM
	sscanf ActOxim,"Oxim_%g",actOxNum
	
	DFREF dfrResource = root:Resources:Oximetry
	NVAR OximIni = dfrResource:OximIni
	NVAR OximFin = dfrResource:OximLast
	variable totalOxims = OximFin - OximIni + 1
	
	make/O/N=(totalOxims,6) dfrVuelo:Oxim_HipoxiaTimes = 0
	wave HipoxiaTimes = dfrVuelo:Oxim_HipoxiaTimes
	
	SetDimLabel 1,0,'First Hypoxia',HipoxiaTimes
	SetDimLabel 1,1,'First Recover',HipoxiaTimes
	SetDimLabel 1,2,'First dif',HipoxiaTimes
	SetDimLabel 1,3,'Second Hypoxia',HipoxiaTimes
	SetDimLabel 1,4,'Second Recover',HipoxiaTimes
	SetDimLabel 1,5,'Second dif',HipoxiaTimes

	variable i
	for(i=0;i<totalOxims;i++)
		actOxNum = OximIni + i
		
		SetDimLabel 0,i,$("Oxim_"+num2str(actOxNum)),HipoxiaTimes
		
		DFREF dfrOx = dfrVuelo:$("Oxim_"+num2str(actOxNum))
		wave saturation = dfrOx:'w_sat_proc'
		IF(!WaveExists(saturation))
			printf "[%s] Oxim_GetHipoxiaTimes: Oximeter %g not found\n",actVuelo,actOxNum
			continue
		ENDIF

		findLevels/Q/EDGE=2 saturation,(89) //Bajando a de 97%
		wave W_FindLevels //2 expected
		IF(V_flag==2 || v_levelsFound==0)
			printf "[%s] Oxim_GetHipoxiaTimes: Oximeter %g no hypoxic sate (<89 spO2)\n",actVuelo,actOxNum
			continue
		ENDIF
		
		variable DC1 = W_FindLevels[0] //Primera y segunda Desaturaciones
		IF(v_levelsFound>1)
			variable DC2 = W_FindLevels[1]
		ENDIF
		
		findLevels/Q/EDGE=1 saturation,(89) //Recuperandose sobre 97%
		wave W_FindLevels //2 expected
		IF(V_flag==2 || v_levelsFound==0)
			printf "[%s] Oxim_GetHipoxiaTimes: Oximeter %g no resaturation\n",actVuelo,actOxNum
			continue
		ENDIF
		
		variable RC1 = W_FindLevels[0] //Primera y segunda recuperacion
		IF(v_levelsFound>1)
			variable RC2 = W_FindLevels[1]
		ENDIF
		
		IF(DC1!=0 && RC1!=0)
		HipoxiaTimes[i][0] = round(DC1)
		HipoxiaTimes[i][1] = round(RC1)
		HipoxiaTimes[i][2] = round(RC1 - DC1)
		ENDIF
		IF(DC2!=0 && RC2!=0)
		HipoxiaTimes[i][3] = round(DC2)
		HipoxiaTimes[i][4] = round(RC2)
		HipoxiaTimes[i][5] = round(RC2 - DC2)
		ENDIF
	endfor

	killWaves W_FindLevels
	
	//Get lag from mask DC or RC and Hipoxia status
	Duplicate/O HipoxiaTimes,dfrVuelo:Oxim_HipoxiaLag
	wave HypoxiaLag = dfrVuelo:Oxim_HipoxiaLag
	HypoxiaLag = 0
	
	wave ConexionTimes = dfrVuelo:Oxim_ConexionTimes
	matrixop/free noConexion = maxRows(ConexionTimes)
	variable j
	for(j=0;j<dimSize(ConexionTimes,0);j++) //Clean Hipoxias with no corresponding mask dif.
		IF(noConexion[j]==0)
			HipoxiaTimes[j][] = 0
		ENDIF
	endfor
	
	HypoxiaLag = HipoxiaTimes - ConexionTimes 
	
	SetDimLabel 1,0,' Lag DC1',HypoxiaLag
	SetDimLabel 1,1,'Lag RC1',HypoxiaLag
	SetDimLabel 1,2,'Sat vs Conect1',HypoxiaLag
	SetDimLabel 1,3,'Lag DC2',HypoxiaLag
	SetDimLabel 1,4,'Lag RC2',HypoxiaLag
	SetDimLabel 1,5,'Sat vs Conect1',HypoxiaLag
END

//-------------------------------------------------------------------//

Function Oxim_AnalyzeSubSegments([variable oximNum])

	SVAR actvuelo = root:actVuelo
	DFREF dfrVuelo = root:$(actVuelo)

	SVAR actOxim = root:actOxim	
	variable actOxNuM
	sscanf ActOxim,"Oxim_%g",actOxNum
	IF(oximNum!=0) //Change active oxim
		sprintf actOxim,"Oxim_%g",oximNum
		ActOxNum = oximNum
	ENDIF
	DFREF dfrOx = dfrVuelo:$(actOxim)
		IF(DataFolderRefStatus(dfrOx)==0)
			printf "[%s] Oxim_AnalyzeSubSegments: Oximeter %g not found\n",actVuelo,oximNum
			return 0
		ENDIF
	
	wave/WAVE AllSegmentRefWave = dfrOx:AllSegmentRefWave
		IF(!WaveExists(AllSegmentRefWave))
			printf "[%s] Oxim_AnalyzeSubSegments: Oximeter %g SegmentRef wave not found\n",actVuelo,oximNum
		ENDIF
	
	wave/WAVE AllSegmentFitRefWave = dfrOx:AllFitRefWave
		IF(!WaveExists(AllSegmentFitRefWave))
			printf "[%s] Oxim_AnalyzeSubSegments: Oximeter %g FitRef wave not found\n",actVuelo,oximNum
		ENDIF

	wave FlightPoints = dfrVuelo:VueloInfo
	wave OximPoints = dfrVuelo:Oxim_ConexionTimes
	
	variable ConexionTimesRow = findDimLabel(OximPoints,0,actOxim)
	
	//BaseLine
	
END

//-------------------------------------------------------------------//

Function OximToImage_Handler([inType,DesconexionNum,oximOrSat,startOrEnd,inRemake,NormalizeHRbyAge,NormalizeTime,avgErrorType,sortMode])
	variable inType,DesconexionNum,oximOrSat,startOrEnd,inRemake,NormalizeHRbyAge,NormalizeTime,avgErrorType,sortMode
	
	DesconexionNum = DesconexionNum==0 ? 1 : DesconexionNum
	
	string inTypeHelp = "1. Individual flight;2. All flights;3. Selected list of flights;4. All flights (filtered);5. Selected list of flights (filtered)"
	//"1. Vuelo individual;2. Todos los vuelos;3. Lista de vuelos;4. Todos los vuelos (filtrado);5. Lista de vuelos (filtrado)"
	Prompt inType, "Selected flights: ", popUp inTypeHelp //"Vuelos seleccionados: "
	
	string DesconexionNumHelp = "1. Day flight;2. Night flight"
	//"1. Vuelo Diurno;2. Vuelo Nocturno"
	Prompt DesconexionNum, "Mask disconnect (1st o 2nd): ", popUp DesconexionNumHelp //"Desconexion (1 o 2): "
	
	string oximOrSatHelp = "1. Mask connect;2. SpO2 saturation (97%);3. SpO2 Hypoxia (89%)"
	//"1. Conexion;2. Saturacion (97%);3. Hipoxia (89%)"
	Prompt oximOrSat, "Align to Mask connect/saturation/Hypoxia:", popUp oximOrSatHelp //"Alinear a conexion/saturacion/hipoxia:"
	
	string startOrEndHelp = "1. Beginning;2. End;"
	//"1. Principio;2. Final;"
	Prompt startOrEnd, "Align to Beginning/End: ", popUp startOrEndHelp //"Alinear a principio/final: "
	
	string avgErrorTypeHelp = "1. Max/Min;2. Sdev;3. Adev"
	//"1. Max/Min;2. Sdev;3. Adev"
	Prompt avgErrorType, "Error type shown on wave of averages: ", popUp avgErrorTypeHelp //"Tipo de error en ondas promedio: "
	
	string SortHelp = "1. Do not sort;2. Age;3. Disconnected time;4. Desaturation time;5. Hypoxia time;5. Max HR;"
	//"1. Sin Ordenar;2. Ordenar por Edad;3. Tiempo desconectado;4. Tiempo desaturacion;5. Tiempo hipoxia;5. Max HR;"
	Prompt SortMode, "Sort by:", popup SortHelp //"Ordenar por:"
	
	string NormalizeHRHelp = "1. Normalize;2. Normalize by age (220-age = nHR);"
	//"1. Sin Normalizar;2. Normalizar por Edad (220-edad);"
	Prompt NormalizeHRbyAge, "Normalize Heart Rate:", popup NormalizeHRHelp //"Normalizar ritmo cardiaco:"
	
	string NormalizeTimeHelp = "1. Do not normalize time;2. Normalize time by mask disconnect;3. Normalize time by SpO2 saturation (97%);4. Normalize time by SpO2 hypoxia (89%);5. Normalize total time (DC-RC97%)"
	//"1. Sin Normalizar tiempo;2. Normalizar tiempo por desconexion;3. Normalizar tiempo por Saturacion (97%);4. Normalizar tiempo por Hipoxia (89%);5. Normalizar tiempo total (DC-RC97%)"
	Prompt NormalizeTime, "Normalize time (0-100%) by:", popup NormalizeTimeHelp	//"Normalizar tiempo (0-100%) segun:"
	
	Prompt inRemake, "Recalculate data: " //"Recalcular datos: "
	
	DoPrompt/HELP=("Select flight number to load") "Show summary graph: ", inType,DesconexionNum,oximOrSat,startOrEnd,avgErrorType,SortMode,NormalizeHRbyAge,NormalizeTime
	if (V_Flag)
		return -1
	endif
	inType -= 1 
	oximOrSat -= 1
	startOrEnd -= 1	
	avgErrorType -= 1
	NormalizeHRbyAge -= 1
	NormalizeTime -= 1
	
	variable ckInfoDisp
	IF(inType==3)
		ckInfoDisp = 1
		inType=1
	ENDIF
	IF(inType==4)
		ckInfoDisp = 1
		inType=2
	ENDIF	
	
	variable showAvg = 1
	inRemake = 1
	
	IF(inRemake==1)
	
		String SelectedVuelos = ""
		IF(inType==1)
			SelectedVuelos = "All"
		ELSEIF(inType==2) 	//Option 3. Seleccionados: Ask for flights		
			SVAR actvuelo = root:actVuelo
			variable actVueloNum
			sscanf actVuelo,"Vuelo_%g",actVueloNum
			SelectedVuelos = num2str(actVueloNum) + ","
			
			Prompt SelectedVuelos, "Flight ID (separated by comma): "
			DoPrompt/HELP=("Select flight numbers") "Show summary graph for flights: ", SelectedVuelos
			if (V_Flag)
				return -1
			endif
		ENDIF
	
		OximToImage_CreateHandler(DesconexionNum,oximOrSat,startOrEnd,NormalizeHRbyAge,NormalizeTime,ckInfoDisp,showAvg,SelectedVuelos,avgErrorType)		
	ENDIF
	
	variable Sorted = SortMode>1 ? 1 : 0
	variable SortvarSel = SortMode>1 ? SortMode-2 : 0
	OximToImage_Display(desconexionNum=DesconexionNum,alltype=inType,Sorted=Sorted,SortvarSel=SortvarSel,NormalizeHRbyAge=NormalizeHRbyAge,NormalizeTime=NormalizeTime) 
END

//-------------------------------------------------------------------//
//Unifying function for normalized and oximImage
//DesconexionNum: vuelo diurno/nocturno, oximOrSat: (0 OximTimes/1 DesatTimes/2 HipoxTimes)
//Normalize NormalizeHRbyAge: Divide values to normalized max HR %, NormalizeTime: time to percent (100%)
//CheckInfoDisplay: filtered values from VSpanel selection, SelectedVuelos: list of flights included in calc
Function OximToImage_CreateHandler(variable DesconexionNum,variable oximOrSat,variable startOrEnd,variable NormalizeHRbyAge,variable NormalizeTime,variable checkInfoDisplay,variable showAvg,String SelectedVuelos,variable avgErrorType)
	SVAR actvuelo = root:actVuelo
	
	
	string NormalizedOrSeg = ""
	IF(NormalizeTime>=1)
		NormalizedOrSeg = "Normalized"
	ELSE
		NormalizedOrSeg = "Segment"
	ENDIF	
	
//	IF(checkInfoDisplay)
//		DFREF dfrResource = root:Resources:Oximetry
//		wave/T VuelosSelection_Text = dfrResource:VuelosSelection_Text
//		wave/T VuelosSelection_Info = dfrResource:VuelosSelection_Info
//		wave VuelosSelection_Sel = dfrResource:VuelosSelection_Sel
//		IF( !WaveExists(VuelosSelection_Text) ||  !WaveExists(VuelosSelection_Info) || !WaveExists(VuelosSelection_Sel) )
//			print "[OximToImage_CreateHandler] checkInfoDisplay 1->0: Waves not found!"
//			checkInfoDisplay = 0
//		ENDIF
//	ENDIF
	
	IF(cmpstr(SelectedVuelos,"")==0) //INDIVIDUAL
		IF(NormalizeTime>=1)
			variable ImgMakeStatus = OximToImageNormalized_Make(DesconexionNum=DesconexionNum,NormalizeTime=NormalizeTime,NormalizeHRbyAge=NormalizeHRbyAge\
			,showAvg=showAvg,checkInfoDisplay=checkInfoDisplay,avgErrorType=avgErrorType)
		ELSE
			ImgMakeStatus = OximToImage_Make(DesconexionNum=DesconexionNum,oximOrSat=oximOrSat,startOrEnd=startOrEnd,NormalizeHRbyAge=NormalizeHRbyAge\
			,showAvg=showAvg,checkInfoDisplay=checkInfoDisplay,avgErrorType=avgErrorType)
		ENDIF
		
		IF(ImgMakeStatus==-1) //Failed
			return -1
		ENDIF
		
		string ImgSegOxNm,ImgSegHRNm //Individual image names
		sprintf ImgSegOxNm,"Image_%s%g_Ox",NormalizedOrSeg,DesconexionNum
		sprintf ImgSegHRNm,"Image_%s%g_HR",NormalizedOrSeg,DesconexionNum
		
		DFREF dfrVuelo = root:$(actVuelo)	
		wave sImg_Ox = dfrVuelo:$(ImgSegOxNm) //Time x oximeters
		wave sImg_Hr = dfrVuelo:$(ImgSegHRNm)	 //""
		IF(!WaveExists(sImg_Ox) || !WaveExists(sImg_Hr))
			return -1
		ENDIF	
	
		IF(dimSize(sImg_Ox,0)<2 || dimSize(sImg_HR,0)<2)
			return -1
		ENDIF
	ELSE
		OximToImage_Make_JoinFlights(desconexionNum=DesconexionNum,remake=1,oximOrSat=oximOrSat,startOrEnd=startOrEnd,VueloList=SelectedVuelos\
		,NormalizeHRbyAge=NormalizeHRbyAge,NormalizeTime=NormalizeTime,checkInfoDisplay=checkInfoDisplay,showAvg=showAvg,avgErrorType=avgErrorType)
	ENDIF
END

//-------------------------------------------------------------------//

Function OximToImage_Make_JoinFlights([string vueloList,variable DesconexionNum,variable remake,variable oximOrSat,variable startOrEnd,variable NormalizeHRbyAge,variable NormalizeTime,variable checkInfoDisplay,variable showAvg,variable avgErrorType])

	SVAR actvuelo = root:actVuelo
	SVAR actOxim = root:actOxim
	
	string saveVuelo = actVuelo
	string saveOxim = actOxim
	
	desconexionNum = desconexionNum==0 ? 1 : desconexionNum

	IF(!ParamIsDefault(vueloList) && cmpstr(vueloList,"")!=0 && cmpstr(vueloList,"All")!=0) //Valid vueloList
		variable vueloCount = itemsInList(vueloList,",")
		variable useList = 1
	ELSE //Use all available flights from found folders
		DFREF dfrResource = root:Resources:Oximetry
		WAVE VuelosStatus = dfrResource:VuelosStatus
		vueloCount = dimSize(VuelosStatus,0)
		useList = 0
	ENDIF
	
	IF(vueloCount==0)
		print "[OximToImage_Make_JoinFlights]: No flight list"
	ENDIF
	
	NewDataFolder/O root:AllVueloData
	DFREF dfrAVD = root:AllVueloData
	NewDataFolder/O dfrAVD:VueloImages
	DFREF dfrAVDdcImg = dfrAVD:VueloImages
	
	string NormalizedOrSeg = ""
	IF(NormalizeTime>=1)
		NormalizedOrSeg = "Normalized"
	ELSE
		NormalizedOrSeg = "Segment"
	ENDIF
	
	string ImgSegOxNm,ImgSegHRNm //Individual image names
	sprintf ImgSegOxNm,"Image_%s%g_Ox",NormalizedOrSeg,DesconexionNum
	sprintf ImgSegHRNm,"Image_%s%g_HR",NormalizedOrSeg,DesconexionNum
	
	string AllImgSegOxNm,AllImgSegHRNm //Joined image names
	IF(UseList==1)
		sprintf AllImgSegOxNm,"SelectedVueloImage_%s%g_Ox",NormalizedOrSeg,DesconexionNum
		sprintf AllImgSegHRNm,"SelectedVueloImage_%s%g_HR",NormalizedOrSeg,DesconexionNum				
	ELSE
		sprintf AllImgSegOxNm,"AllVueloImage_%s%g_Ox",NormalizedOrSeg,DesconexionNum
		sprintf AllImgSegHRNm,"AllVueloImage_%s%g_HR",NormalizedOrSeg,DesconexionNum
	ENDIF
	
	variable i,j,FirstImage = 0
	FOR(i=0;i<vueloCount;i++)
		IF(useList==1)
			string actVueloStr = stringFromList(i,vueloList,",")
			sprintf actVueloStr,"Vuelo_%s",actVueloStr
		ELSE
			actVueloStr = getDimLabel(VuelosStatus,0,i)
		ENDIF
		actvuelo = actVueloStr
		DFREF dfrVuelo = root:$(actVuelo)
		
		//Get or remake individual images for every vuelo
		wave/Z sImg_Ox = dfrVuelo:$(ImgSegOxNm) //Time x oximeters
		wave/Z sImg_Hr = dfrVuelo:$(ImgSegHRNm)
		IF(!WaveExists(sImg_Ox) || !WaveExists(sImg_Hr) || remake==1)
			variable CHstatus = OximToImage_CreateHandler(DesconexionNum,oximOrSat,startOrEnd,NormalizeHRbyAge,NormalizeTime,checkInfoDisplay,0,"",avgErrorType)
			IF(CHstatus==-1)
				continue
			ELSE
				wave sImg_Ox = dfrVuelo:$(ImgSegOxNm)
				wave sImg_Hr = dfrVuelo:$(ImgSegHRNm)
			ENDIF
		ENDIF
		
		//Create or add to joined image
		IF(i==0 || FirstImage==0)
			variable actDimSize = 0 //First data on image
			Duplicate/O sImg_Ox,dfrAVDdcImg:$(AllImgSegOxNm)/WAVE=AllImgSegOx
			Duplicate/O sImg_HR,dfrAVDdcImg:$(AllImgSegHRNm)/WAVE=AllImgSegHR
			FirstImage = 1
		ELSE
			actDimSize = dimSize(AllImgSegOx,1) //Starting point for actual data on image
			Concatenate/NP=1 {sImg_Ox}, AllImgSegOx
			Concatenate/NP=1 {sImg_HR}, AllImgSegHR
		ENDIF
			
		//Set labels of joined image
		for(j=0;j<dimSize(sImg_Ox,1);j++)
			string actDimLabel = getDimLabel(sImg_Ox,1,j)
			setDimLabel 1,actDimSize+j,$(actDimLabel),AllImgSegOx,AllImgSegHR
		endfor
		//
	ENDFOR
	
	IF(NormalizeTime>=1)
		setScale/P x 0,100,"%",sImg_Ox,sImg_Hr
	ENDIF

	//Get averaged waves of images
	OximToImage_GetAverages(AllImgSegOx,avgErrorType=avgErrorType)
	OximToImage_GetAverages(AllImgSegHR,avgErrorType=avgErrorType)
	
	IF(showAvg==1 && UseList==1) //Alltype 0: AAA, 1: BBB, 2: CCC
		OximToImage_GetAverages_Display(AllType=2,Segment=DesconexionNum,NormalizeTime=NormalizeTime,avgErrorType=avgErrorType)
	ELSEIF(showAvg==1 && UseList==0)
		OximToImage_GetAverages_Display(AllType=1,Segment=DesconexionNum,NormalizeTime=NormalizeTime,avgErrorType=avgErrorType)
	ENDIF
	
	actvuelo = saveVuelo //Return global strings to saved vuelo selection
	actOxim = saveOxim
END

//-------------------------------------------------------------------//

Function OximToImage_Make([variable DesconexionNum,variable oximOrSat,variable startOrEnd,variable showAvg,variable NormalizeHRbyAge,variable checkInfoDisplay,variable avgErrorType])
	
	SVAR actvuelo = root:actVuelo
	variable actVueloNum
	sscanf actVuelo,"Vuelo_%g",actVueloNum
	SVAR actOxim = root:actOxim
	
	DFREF dfrResource = root:Resources:Oximetry
	NVAR OximIni = dfrResource:OximIni
	NVAR OximFin = dfrResource:OximLast
	variable totalOxims = OximFin - OximIni + 1

	DFREF dfrVuelo = root:$(actVuelo)
	IF(DataFolderRefStatus(dfrVuelo)==0) //Invalid reference, no data from vuelo
		//print "[OximToImage_Make] No vuelo datafolder"
		return -1
	ENDIF
	
	IF(checkInfoDisplay==1)
		wave/T VuelosSelection_Text = dfrResource:VuelosSelection_Text
		wave/T VuelosSelection_Info = dfrResource:VuelosSelection_Info
		wave VuelosSelection_Sel = dfrResource:VuelosSelection_Sel
		
		variable VuelodimPos = findDimLabel(VuelosSelection_Sel,0,actVuelo)
		IF(VueloDimPos==-2) //Vuelo no encontrado o excluido de subseleccion
			return -1
		ENDIF
	ENDIF	
	
	Wave Oxim_ConexionTimes = dfrVuelo:Oxim_ConexionTimes
	IF(!WaveExists(Oxim_ConexionTimes))
		printf "[%s] OximToImage_Make: Oxim_ConexionTimes not found!\n",actVuelo
		return 0
	ENDIF
	WaveStats/Q/PCST Oxim_ConexionTimes
	wave M_WaveStats
	
	Wave Oxim_DesaturationLag = dfrVuelo:Oxim_DesaturationLag
	Wave Oxim_DesaturationTimes = dfrVuelo:Oxim_DesaturationTimes
	
	Wave Oxim_HipoxiaLag = dfrVuelo:Oxim_HipoxiaLag
	Wave Oxim_HipoxiaTimes = dfrVuelo:Oxim_HipoxiaTimes	
	
	//Wave Oxim_SegmentData = dfrVuelo:Oxim_SegmentData
	//Wave Oxim_SegmentFitCoefs = dfrVuelo:Oxim_SegmentFitCoefs
	
	variable minDisconnect = Oxim_ConexionTimes[ M_WaveStats[9][0] ][0]
	variable maxReconnect  = Oxim_ConexionTimes[ M_WaveStats[11][1] ][1]
	variable maxDifference = Oxim_ConexionTimes[ M_WaveStats[11][2] ][1]
	
	KillWaves/Z M_WaveStats
	
	variable prevTime = startOrEnd==0 ? 100 : 400
	variable stimTime = startOrEnd==0 ? 500 : 200
	variable selectedTime = prevTime + stimTime
	
	
	string ImgSegOxNm,ImgSegHRNm
	sprintf ImgSegOxNm,"Image_Segment%g_Ox",DesconexionNum
	sprintf ImgSegHRNm,"Image_Segment%g_HR",DesconexionNum
	
	Make/O/N=(selectedTime,totalOxims) dfrVuelo:$(ImgSegOxNm)/WAVE=sImg_Ox
	Make/O/N=(selectedTime,totalOxims) dfrVuelo:$(ImgSegHRNm)/WAVE=sImg_Hr
	
	setScale/P x -prevTime,1,"s",sImg_Ox,sImg_Hr
	
	desconexionNum = desconexionNum==0 ? 1 : desconexionNum //1era o 2da
	
	variable sel1 = DesconexionNum==1 ? 0 : 3
	variable sel2 = DesconexionNum==1 ? 1 : 4
		
	variable ox,deleted
	for(ox=0;ox<totalOxims;ox++)
		variable actOxNum = OximIni + ox
		string loopOxim
		sprintf loopOxim,"Oxim_%g",actOxNum 
	
		DFREF dfrOx = dfrVuelo:$(loopOxim)
		//Wave AllSegmentTimes = dfrOx:AllSegmentTimes
		
		IF(oximOrSat==0) //Align to oximeter conexion
			variable ex1 = Oxim_ConexionTimes[ox][sel1]
			variable ex2 = Oxim_ConexionTimes[ox][sel2]
		ELSEIF(oximOrSat==1)
			ex1 = Oxim_DesaturationTimes[ox][sel1]
			ex2 = Oxim_DesaturationTimes[ox][sel2]
		ELSEIF(oximOrSat==2)
			ex1 = Oxim_HipoxiaTimes[ox][sel1]
			ex2 = Oxim_HipoxiaTimes[ox][sel2]					
		ENDIF
		
		variable alignTo = startOrEnd==0 ? ex1 : ex2
		
		Wave w_lpm = dfrOx:w_lpm_proc
		wave w_sat = dfrOx:w_sat_proc
		
		IF(checkInfoDisplay==1)
			variable actStatus = VuelosSelection_Sel[VueloDimPos][actOxNum][1]
			IF(actStatus==1)
				variable confirmStatus = 1
			ELSE
				confirmStatus = 0
			ENDIF	
		ELSE
			confirmStatus = 1
		ENDIF		
		
		IF(alignTo==0 || numType(alignTo)==2 || !waveExists(w_lpm) || !waveExists(w_sat) || (alignTo - prevTime < 0) || confirmStatus==0)
			deletePoints/M=1 ox-deleted,1,sImg_Ox,sImg_Hr
			deleted +=1
			continue
		ENDIF
				
		variable t1 = alignTo - prevTime
		variable t2 = alignTo + stimTime - 1

		Duplicate/FREE/R=[t1,t2] w_lpm,extlpm,extlpm_h
		Duplicate/FREE/R=[t1,t2] w_sat,extsat,extsat_h
	
		variable range = min(SelectedTime,dimSize(extlpm,0))-1
		
		sImg_Ox[0,range][ox-deleted] = extsat[p]
		sImg_Hr[0,range][ox-deleted] = extlpm[p]
		
		IF(NormalizeHRbyAge)
			wave OximVars = OximVariables_Get(vuelo=actVueloNum,oximetro=actOxNum ,varSel=4)
			variable maxHR = OximVars[2]
			variable saveMax = 100/maxHR
			sImg_Hr[][ox-deleted] *= saveMax
		ENDIF
		
		setDimLabel 1,ox-deleted,$(actVuelo+"_"+loopOxim),sImg_Ox,sImg_Hr
	endfor
		
	OximToImage_GetAverages(sImg_Ox,avgErrorType=avgErrorType)
	OximToImage_GetAverages(sImg_Hr,avgErrorType=avgErrorType)
	IF(showAvg==1)
		OximToImage_GetAverages_Display(AllType=0,Segment=DesconexionNum,avgErrorType=avgErrorType)
	ENDIF
	
	return 0
END

//-------------------------------------------------------------------//

Function OximToImageNormalized_Make([variable DesconexionNum,variable NormalizeTime,variable showAvg,variable NormalizeHRbyAge,variable checkInfoDisplay,variable avgErrorType])

	SVAR actvuelo = root:actVuelo
	variable actVueloNum
	sscanf actVuelo,"Vuelo_%g",actVueloNum
	SVAR actOxim = root:actOxim
	
	DFREF dfrResource = root:Resources:Oximetry
	NVAR OximIni = dfrResource:OximIni
	NVAR OximFin = dfrResource:OximLast
	variable totalOxims = OximFin - OximIni + 1

	DFREF dfrVuelo = root:$(actVuelo)
	IF(DataFolderRefStatus(dfrVuelo)==0) 
		print "[OximToImageNormalized_Make] Data not found."
		return 0
	ENDIF
	
	IF(checkInfoDisplay==1)
		wave/T VuelosSelection_Text = dfrResource:VuelosSelection_Text
		wave/T VuelosSelection_Info = dfrResource:VuelosSelection_Info
		wave VuelosSelection_Sel = dfrResource:VuelosSelection_Sel
		
		variable VuelodimPos = findDimLabel(VuelosSelection_Sel,0,actVuelo)
		IF(VueloDimPos==-2) //Vuelo no encontrado o excluido de subseleccion
			return -1
		ENDIF
	ENDIF

	Wave Oxim_ConexionTimes = dfrVuelo:Oxim_ConexionTimes
	Wave Oxim_DesaturationTimes = dfrVuelo:Oxim_DesaturationTimes
	Wave Oxim_HipoxiaTimes = dfrVuelo:Oxim_HipoxiaTimes
	
	desconexionNum = desconexionNum==0 ? 1 : desconexionNum //1era o 2da
	NormalizeTime = NormalizeTime==0 ? 1 : NormalizeTime
	
	variable sel1 = DesconexionNum==1 ? 0 : 3 //Start
	variable sel2 = DesconexionNum==1 ? 1 : 4	//End
	variable sel3 = DesconexionNum==1 ? 2 : 5	//Interval
	
	string ImgSegOxNm,ImgSegHRNm
	sprintf ImgSegOxNm,"Image_Normalized%g_Ox",DesconexionNum
	sprintf ImgSegHRNm,"Image_Normalized%g_HR",DesconexionNum
	
	variable normalizedSelectedPoints = 1000
	
	Make/O/N=(normalizedSelectedPoints,totalOxims) dfrVuelo:$(ImgSegOxNm)/WAVE=sImg_Ox
	Make/O/N=(normalizedSelectedPoints,totalOxims) dfrVuelo:$(ImgSegHRNm)/WAVE=sImg_Hr
	
	setScale/P x 0,100,"%",sImg_Ox,sImg_Hr
	
	variable ox,deleted
	for(ox=0;ox<totalOxims;ox++)
		variable actOxNum = OximIni + ox
		string loopOxim
		sprintf loopOxim,"Oxim_%g",actOxNum 
	
		DFREF dfrOx = dfrVuelo:$(loopOxim)
		
		IF(NormalizeTime==1) //Align to oximeter conexion
			variable ex1 = Oxim_ConexionTimes[ox][sel1]
			variable ex2 = Oxim_ConexionTimes[ox][sel2]
			variable totalTime = Oxim_ConexionTimes[ox][sel3]
		ELSEIF(NormalizeTime==2)
			ex1 = Oxim_DesaturationTimes[ox][sel1]
			ex2 = Oxim_DesaturationTimes[ox][sel2]
			totalTime = Oxim_DesaturationTimes[ox][sel3]
		ELSEIF(NormalizeTime==3)
			ex1 = Oxim_HipoxiaTimes[ox][sel1]
			ex2 = Oxim_HipoxiaTimes[ox][sel2]
			totalTime = Oxim_HipoxiaTimes[ox][sel3]	
		ELSEIF(NormalizeTime==4)
			ex1 = Oxim_ConexionTimes[ox][sel1]
			ex2 = Oxim_DesaturationTimes[ox][sel2]
			totalTime = ex2-ex1							
		ENDIF
		
		IF(ex1==0 || ex2==0)
			deletePoints/M=1 ox-deleted,1,sImg_Ox,sImg_Hr
			deleted +=1
			continue
		ENDIF
		
		Wave w_lpm = dfrOx:w_lpm_proc
		wave w_sat = dfrOx:w_sat_proc
		
		IF(checkInfoDisplay==1)
			IF(VueloDimPos!=-2)
				variable actStatus = VuelosSelection_Sel[VueloDimPos][actOxNum][1]
			ENDIF
			IF(actStatus==1)
				variable confirmStatus = 1
			ELSE
				confirmStatus = 0
			ENDIF	
		ELSE
			confirmStatus = 1
		ENDIF	
		
		IF(!waveExists(w_lpm) || !waveExists(w_sat) || confirmStatus==0)
			deletePoints/M=1 ox-deleted,1,sImg_Ox,sImg_Hr
			deleted +=1
			continue
		ENDIF
		
		IF(1)
			setDimLabel 1,ox-deleted,$(actVuelo+"_"+loopOxim),sImg_Ox,sImg_Hr
		ELSE
			setDimLabel 1,ox-deleted,$(actVuelo+"_"+loopOxim+":"+num2str(totalTime)+"s"),sImg_Ox,sImg_Hr
		ENDIF
		
		Duplicate/FREE/R=[ex1,ex2] w_lpm,extlpm
		Duplicate/FREE/R=[ex1,ex2] w_sat,extsat
		
		Duplicate/O/R=[ex1,ex2] w_lpm,dfrOx:w_lpm_timeNormalize
		Duplicate/O/R=[ex1,ex2] w_sat,dfrOx:w_sat_timeNormalize
		
		wave extlpmSave = dfrOx:w_lpm_timeNormalize
		wave extsatSave = dfrOx:w_sat_timeNormalize 
		
		IF( DimSize(extlpm,0)<10 || DimSize(extsat,0)<10 )
			extlpmSave = NaN
			extsatSave = NaN
			
			sImg_Hr[][ox-deleted] = NaN
			sImg_Ox[][ox-deleted] = NaN	
		ELSE
			try
				Interpolate2/T=2/N=(normalizedSelectedPoints)/Y=extlpmSave extlpm; AbortOnRTE
				Interpolate2/T=2/N=(normalizedSelectedPoints)/Y=extsatSave extsat; AbortOnRTE
			catch
				Variable InterpErr = GetRTError(1)		// Gets error code and clears error
				String InterpErrMessage = GetErrMessage(InterpErr)
				printf "[OximToImageNormalized_Make] Failed! Error: %s\n",InterpErrMessage
			endtry
			
			sImg_Hr[][ox-deleted] = extlpmSave[p]
			sImg_Ox[][ox-deleted] = extsatSave[p]			
		ENDIF
		
		IF(NormalizeHRbyAge)
			wave OximVars = OximVariables_Get(vuelo=actVueloNum,oximetro=actOxNum ,varSel=4)
			variable maxHR = OximVars[2]
			variable saveMax = 100/maxHR
			sImg_Hr[][ox-deleted] *= saveMax
		ENDIF
	endfor
	
	OximToImage_GetAverages(sImg_Ox,avgErrorType=avgErrorType)
	OximToImage_GetAverages(sImg_Hr,avgErrorType=avgErrorType)
	IF(showAvg==1)
		OximToImage_GetAverages_Display(AllType=0,Segment=DesconexionNum,NormalizeTime=NormalizeTime,avgErrorType=avgErrorType)
	ENDIF	

END

//-------------------------------------------------------------------//

Function OximToImage_Display([desconexionNum,AllType,Sorted,SortvarSel,NormalizeHRbyAge,NormalizeTime,displayInVSpanel])
	variable desconexionNum 	//For vuelos D+N. Specify wich set of table (1 or 2)
	variable AllType 				//0: Individual vuelo, 1: All vuelos, 2: Subset of vuelos 
	variable Sorted				//Image will be post sorted by specified variable -> //0 display ID, 1 display VALUE
	variable SortvarSel			//This specifies the variable ****
	variable NormalizeHRbyAge	//220-Age normalized max rate, Relativize Heart rate to % of max rate 
	variable NormalizeTime		//Turn time to percent spent in selected time interval.
	variable displayInVSpanel	//0 Normal windows. 1 will show OX in VSpanel, 2 will show HR in VSpanel.
	
	desconexionNum = desconexionNum==0 ? 1 : desconexionNum 

	SVAR actvuelo = root:actVuelo
	SVAR actOxim = root:actOxim
	
	DFREF dfrResource = root:Resources:Oximetry
	DFREF dfrVuelo = root:$(actVuelo)
	IF(DataFolderRefStatus(dfrVuelo)==0) 
		return 0
	ENDIF
		
	/////////////////////////////////////////////
	string NormalizedOrSeg = ""
	IF(NormalizeTime>=1)
		NormalizedOrSeg = "Normalized"
	ELSE
		NormalizedOrSeg = "Segment"
	ENDIF
	
	string ImgSegOxNm,ImgSegHRNm
	IF(AllType==0) //Individual vuelo image
		string SelectedVuelos = ""
		sprintf ImgSegOxNm,"Image_%s%g_Ox",NormalizedOrSeg,DesconexionNum
		sprintf ImgSegHRNm,"Image_%s%g_HR",NormalizedOrSeg,DesconexionNum		
	
		wave sImg_Ox = dfrVuelo:$(ImgSegOxNm)
		wave sImg_Hr = dfrVuelo:$(ImgSegHRNm)
	ELSEIF(AllType==1 || AllType==2) // All/Selected vuelos
		SelectedVuelos = "All" ////*********FIX FOR SELECTED list VUELOS
		IF(AllType==1)
			sprintf ImgSegOxNm,"AllVueloImage_%s%g_Ox",NormalizedOrSeg,DesconexionNum
			sprintf ImgSegHRNm,"AllVueloImage_%s%g_HR",NormalizedOrSeg,DesconexionNum
		ELSEIF(AllType==2)
			sprintf ImgSegOxNm,"SelectedVueloImage_%s%g_Ox",NormalizedOrSeg,DesconexionNum
			sprintf ImgSegHRNm,"SelectedVueloImage_%s%g_HR",NormalizedOrSeg,DesconexionNum		
		ENDIF	
	
		wave sImg_Ox = root:AllVueloData:VueloImages:$(ImgSegOxNm)
		wave sImg_Hr = root:AllVueloData:VueloImages:$(ImgSegHRNm)
	ENDIF
	
	IF(!WaveExists(sImg_Ox) || !WaveExists(sImg_Hr))
			variable oximOrSat = 0
			variable startOrEnd = 0
			variable ckInfoDisp = 0
			variable avgErrorType = 0
			OximToImage_CreateHandler(DesconexionNum,oximOrSat,startOrEnd,NormalizeHRbyAge,NormalizeTime,ckInfoDisp,0,SelectedVuelos,avgErrorType)

		IF(AllType==0) //Individual vuelo image
			wave sImg_Ox = dfrVuelo:$(ImgSegOxNm)
			wave sImg_Hr = dfrVuelo:$(ImgSegHRNm)
		ELSE
			wave sImg_Ox = root:AllVueloData:VueloImages:$(ImgSegOxNm)
			wave sImg_Hr = root:AllVueloData:VueloImages:$(ImgSegHRNm)
		ENDIF
		
		IF(!WaveExists(sImg_Ox) || !WaveExists(sImg_Hr))
			printf "OximToImage_Display: images not created!\n"
			return 0
		ENDIF	
	ENDIF
			
	IF(Sorted==1)
		wave sImg_HrUnsort = sImg_Hr
		wave sImg_OxUnsort = sImg_Ox
		
		wave sImg_Hr = OximToImage_Sorter(sImg_HrUnsort,varSel=SortvarSel,segment=desconexionNum,AllType=AllType)
		wave sImg_Ox = OximToImage_Sorter(sImg_OxUnsort,varSel=SortvarSel,segment=desconexionNum,AllType=AllType)
		
		IF(!WaveExists(sImg_Ox) || !WaveExists(sImg_Hr))
			printf "OximToImage_Display: Sorted images not found\n"
			return 0
		ENDIF				
	ENDIF	
	
	variable imgOxSize = dimsize(sImg_Ox,0)
	variable imgHRSize = dimSize(sImg_Hr,0)
	IF(imgOxSize==0 || imgHRSize==0)
		printf "OximToImage_Display: Images have no data!\n"
		return 0
	ENDIF		
	/////////////////////////////////////////////
	
	
	string imgOxName = nameOfWave(sImg_Ox)
	string imgHRName = nameOfWave(sImg_HR)
	
	IF(AllType==0)
		string dispWinOxname = actVuelo + "_" + imgOxName
		string dispWinHRname =	actVuelo + "_" + imgHRName
	ELSE
		dispWinOxname =	imgOxName + "Display"
		dispWinHRname =	imgHRName + "Display"
	ENDIF
	
	IF(displayInVSpanel==0)
		variable showOx = 1
		variable showHR = 1
	ELSEIF(displayInVSpanel==1)
		showOx = 1;showHR = 0
	ELSEIF(displayInVSpanel==2)
		showOx = 0;showHR = 1
	ENDIF
	
	variable displayInfo = Sorted==0 ? 0 : 1 //0 display ID, 1 display VALUE
	
	//////HOST
	IF(displayInVSpanel)
		String VShostWinName = "VuelosStatusPanel"
		string VSmainDispWin = "VuelosStatusMainDisp"
		string VSdispComp = VShostWinName+"#"+VSmainDispWin
		
		DoWindow/HIDE=? $(VShostWinName)
		IF(v_flag==1)
			string VShostchildWin = childWindowList(VShostWinName)
			Variable VSmainSubExists = GrepString(VShostchildWin,VSmainDispWin)
		ENDIF
		
		IF(VSmainSubExists) //Any active image on VSmaingraph?
		string VSsubchildWin = ImageNameList(VSdispComp,";")
			IF(itemsInList(VSsubChildWin)>0)
				RemoveImage/W=$(VSdispComp)/Z $stringFromList(0,VSsubchildWin)
			ENDIF
		ENDIF
	ENDIF
	//////////
	
	IF(showOx)
		IF(displayInVSpanel==1)
			dispWinOxname = VSdispComp //Switch to VuelosStatusPanel main display window
		ELSE
			DoWindow/HIDE=? $(dispWinOxname)
			IF(v_flag==1)
				KillWindow/Z $(dispWinOxname)
			ENDIF
			Display/K=1/N=$(dispWinOxname)
		ENDIF
		AppendImage/W=$(dispWinOxname) sImg_Ox
	
		ModifyImage/W=$(dispWinOxname) $(imgOxName) ctab={60,97,RedWhiteBlue,1}
		ModifyImage/W=$(dispWinOxname) $(imgOxName) minRGB=(0,0,0),maxRGB=(26205,52428,1)
		IF(NormalizeTime==0)
			ModifyGraph/W=$(dispWinOxname) zero(bottom)=1,manTick(bottom)={0,60,0,0}
		ELSE
			Label bottom "Normalized Time"
		ENDIF
		
		wave AxNumOx
		wave AxTxtOx
		[AxNumOx,AxTxtOx] = OximToImage_CustomAxis(sImg_Ox,displayInfo=displayInfo)
		ModifyGraph/W=$(dispWinOxname) userticks(left)={AxNumOx,AxTxtOx},fSize(left)=7
		
		IF(1)
			ColorScale/W=$(dispWinOxname)/C/N=text0/A=RC/E/Z=1/F=0 image=$(imgOxName)
			ColorScale/W=$(dispWinOxname)/C/N=text0 axisRange={55,100}
			
			string dataUnit = WaveUnits(sImg_Ox,-1)
			String EvSt
			Sprintf EvSt,"Saturacion oxigeno %s",dataUnit
			ColorScale/W=$(dispWinOxname)/C/N=text0/X=1/Y=0 EvSt
			//ColorScale/W=$(dispWinOxname)/C/N=text0/X=1/Y=0 minor=1,tickUnit=1,fsize=10
			IF(displayInVSpanel==1)
				ColorScale/W=$(dispWinOxname)/C/N=text0 heightPct=140
			ENDIF	
		ENDIF
	ENDIF
	
	IF(showHR)
		IF(displayInVSpanel==2)
			dispWinHRname = VSdispComp //Switch to VuelosStatusPanel main display window
		ELSE
			DoWindow/HIDE=? $(dispWinHRname)
			IF(v_flag==1)
				KillWindow/Z $(dispWinHRname)
			ENDIF	
			Display/K=1/N=$(dispWinHRname)
		ENDIF
		AppendImage/W=$(dispWinHRname) sImg_Hr
		
		if(NormalizeHRbyAge==1)
			ModifyImage/W=$(dispWinHRname) $(imgHRName) ctab= {20,100,ColdWarm,0}
		else
			ModifyImage/W=$(dispWinHRname) $(imgHRName) ctab= {50,200,ColdWarm,0}
		endif
		
		IF(NormalizeTime==0)
			ModifyGraph/W=$(dispWinHRname) zero(bottom)=1,manTick(bottom)={0,60,0,0}
		ELSE
			Label bottom "Normalized Time"
		ENDIF
		
		wave AxNumHR
		wave AxTxtHR
		[AxNumHR,AxTxtHR] = OximToImage_CustomAxis(sImg_HR,displayInfo=displayInfo)
		ModifyGraph/W=$(dispWinHRname) userticks(left)={AxNumHR,AxTxtHR},fSize(left)=7	
		
		IF(1)
			ColorScale/W=$(dispWinHRname)/C/N=text0/A=RC/E/Z=1/F=0 image=$(imgHRName)
			dataUnit = WaveUnits(sImg_Hr,-1)
			IF(NormalizeHRbyAge==1)
				Sprintf EvSt,"Ritmo Cardiaco Norm. %s",dataUnit
			ELSE
				Sprintf EvSt,"Ritmo Cardiaco %s",dataUnit
			ENDIF
			ColorScale/W=$(dispWinHRname)/C/N=text0/X=1/Y=0 EvSt
			IF(displayInVSpanel==2)
				ColorScale/W=$(dispWinHRname)/C/N=text0 heightPct=140
			ENDIF			
		ENDIF	
	ENDIF
	
	IF(DisplayInVSpanel==0)
		AutoPositionWindow/E/M=0/R=$(dispWinHRname) $(dispWinOxname)
	ENDIF
END

//-------------------------------------------------------------------//

Function [wave AxNum,wave AxTxt] OximToImage_CustomAxis(wave Image,[variable displayInfo])
	DFREF dfr = getWavesDataFolderDFR(Image)
	
	string imgName = nameOfWave(Image)
	string keyName = imgName + "Key"
	
	string destAxNumWaveName = imgName + "_AxNum"
	string destAxTxtWaveName = imgName + "_AxTxt"
	
	variable ImageDimSize = dimSize(Image,1)

	Make/O/n=(ImageDimSize) dfr:$(destAxNumWaveName) = p
	wave AxNumWave = dfr:$(destAxNumWaveName)
	Make/O/n=(ImageDimSize)/T dfr:$(destAxTxtWaveName) = ""
	wave/T AxTxtWave = dfr:$(destAxTxtWaveName)
	
	
	variable i
	IF(displayInfo==0) //Display ID
		for(i=0;i<ImageDimSize;i++)
			string actDim = getDimLabel(Image,1,i)
			AxTxtWave[i] = actDim
		endfor
	ELSEIF(displayInfo>=1) //Display order value
		wave keyWave = dfr:$(keyName)
		for(i=0;i<ImageDimSize;i++)
			variable actValue = keyWave[i]
			IF(1)
				actDim = getDimLabel(Image,1,i)
				variable vuelo,oximetro
				sscanf actDim,"Vuelo_%g_Oxim_%g",vuelo,oximetro
				
				string AxTxtDo
				sprintf AxTxtDo,"V%04.f_Ox%g:%g",vuelo,oximetro,actValue
			ELSE
				AxTxtDo = num2str(actValue)
			ENDIF
			
			AxTxtWave[i] = AxTxtDo//
		endfor		
	ENDIF

	return [AxNumWave,AxTxtWave]
END

//-------------------------------------------------------------------//

Function OximToImage_GetAverages(wave Image,[variable avgErrorType])
	DFREF dfr = getWavesDataFolderDFR(Image)
	
	variable imgDim = dimSize(Image,0)
	IF(imgDim==0)
		return 0
	ENDIF

	string imgName = nameOfWave(Image)
	string destAvgWaveName = imgName + "_Avg"
	string destSdevWaveName = imgName + "_Sdev"
	string destAdevWaveName = imgName + "_Adev"
	string destMaxWaveName = imgName + "_Max"
	string destMinWaveName = imgName + "_Min"

	MatrixOp/Free imageT = Image^t
	WaveStats/PCST imageT
	wave M_WaveStats
	
	Duplicate/O/R=[3][] M_WaveStats,dfr:$(destAvgWaveName)/WAVE=avgWave //3
	
	Duplicate/O/R=[4][] M_WaveStats,dfr:$(destSdevWaveName)/WAVE=sdevWave //4: sdev
	Note/K sdevWave,"sdev"

	Duplicate/O/R=[6][] M_WaveStats,dfr:$(destAdevWaveName)/WAVE=adevWave //6: adev
	Note/K adevWave,"adev"
	
	Duplicate/O/R=[12][] M_WaveStats,dfr:$(destMaxWaveName)/WAVE=MaxWave //
	Duplicate/O/R=[10][] M_WaveStats,dfr:$(destMinWaveName)/WAVE=MinWave //
	
	MaxWave = MaxWave - avgWave //Make relative to avg
	MinWave = avgWave - MinWave

	MatrixOp/O avgWave = avgWave^t
	MatrixOp/O sdevWave = sdevWave^t
	MatrixOp/O adevWave = adevWave^t
	MatrixOp/O MaxWave = MaxWave^t
	MatrixOp/O MinWave = MinWave^t
	
	CopyScales/P Image,avgWave,sdevWave,adevWave
	CopyScales/P Image,MaxWave,MinWave
END

//-------------------------------------------------------------------//

Function OximToImage_GetAverages_Display([variable AllType,variable Segment,variable NormalizeTime,variable avgErrorType])
	SVAR actvuelo = root:actVuelo
	IF(AllType==0) //vuelo individual
		string BaseName = ""
		variable actVueloNum
		sscanf actVuelo,"Vuelo_%g",actVueloNum
		DFREF dfrVu = root:$(actVuelo)
	ELSEIF(AllType==1 || AllType==2) //Todos los vuelos / Vuelos seleccionados
		IF(AllType==1)
			BaseName = "AllVuelo"
		ELSEIF(AllType==2)
			BaseName = "SelectedVuelo"
		ENDIF
		DFREF dfrAVD = root:AllVueloData
		DFREF dfrVu = dfrAVD:VueloImages
	ENDIF	
	
	IF(DataFolderRefStatus(dfrVu)==0) 
		return 0
	ENDIF

	SVAR actOxim = root:actOxim	
	variable actOxNuM
	sscanf ActOxim,"Oxim_%g",actOxNum
	
	segment = segment==0 ? 1 : segment
	
	string NormalizedOrSeg = ""
	IF(NormalizeTime>=1)
		NormalizedOrSeg = "Normalized"
	ELSE
		NormalizedOrSeg = "Segment"
	ENDIF	

	//Avg (main) waves
	string imgNameHR
	sprintf imgNameHR,"%sImage_%s%g_HR",BaseName,NormalizedOrSeg,segment	
	string destAvgWaveNameHR = imgNameHR + "_Avg"
	wave HRAvgWave = dfrVu:$(destAvgWaveNameHR)
		
	string imgNameOx
	sprintf imgNameOx,"%sImage_%s%g_Ox",BaseName,NormalizedOrSeg,segment
	string destAvgWaveNameOx = imgNameOx + "_Avg"
	wave OxAvgWave = dfrVu:$(destAvgWaveNameOx)
	
	//Error waves
	wave HRSdevWave = dfrVu:$(imgNameHR + "_Sdev")
	wave HRAdevWave = dfrVu:$(imgNameHR + "_Adev")
	wave HRMaxWave = dfrVu:$(imgNameHR + "_Max")
	wave HRMinWave = dfrVu:$(imgNameHR + "_Min")
	
	wave OxSdevWave = dfrVu:$(imgNameOx + "_Sdev")
	wave OxAdevWave = dfrVu:$(imgNameOx + "_Adev")	
	wave OxMaxWave = dfrVu:$(imgNameOx + "_Max")
	wave OxMinWave = dfrVu:$(imgNameOx + "_Min")
	
	//Display
	string winAvgHR = destAvgWaveNameHR+num2str(avgErrorType)+"Win"
	string winAvgOX = destAvgWaveNameOx+num2str(avgErrorType)+"Win"
	
	DoWindow/HIDE=? $(winAvgHR)
		IF(v_flag==1)
			KillWindow/Z $(winAvgHR)
		ENDIF	
	DoWindow/HIDE=? $(winAvgOx)
		IF(v_flag==1)
			KillWindow/Z $(winAvgOx)
		ENDIF	
		
	Display/K=1/N=$(winAvgHR) HRAvgWave
	IF(avgErrorType==0)
		ErrorBars $(destAvgWaveNameHR) SHADE= {0,26,(0,0,0,0),(0,0,0,0)},wave=(HRMaxWave,HRMinWave)
	ELSEIF(avgErrorType==1)
		ErrorBars $(destAvgWaveNameHR) SHADE= {0,0,(0,0,0,0),(0,0,0,0)},wave=(HRSdevWave,HRSdevWave)
	ELSEIF(avgErrorType==2)
		ErrorBars $(destAvgWaveNameHR) SHADE= {0,34,(0,0,0,0),(0,0,0,0)},wave=(HRAdevWave,HRAdevWave)		
	ENDIF
	IF(NormalizeTime==0)
		ModifyGraph/W=$(winAvgHR) zero(bottom)=1,manTick(bottom)={0,60,0,0}
	ENDIF
	
	Display/K=1/N=$(winAvgOx) OxAvgWave
	IF(avgErrorType==0)
		ErrorBars $(destAvgWaveNameOx) SHADE= {0,26,(0,0,0,0),(0,0,0,0)},wave=(OxMaxWave,OxMinWave)
	ELSEIF(avgErrorType==1)	
		ErrorBars $(destAvgWaveNameOx) SHADE= {0,0,(0,0,0,0),(0,0,0,0)},wave=(OxSdevWave,OxSdevWave)
	ELSEIF(avgErrorType==2)	
		ErrorBars $(destAvgWaveNameOx) SHADE= {0,34,(0,0,0,0),(0,0,0,0)},wave=(OxAdevWave,OxAdevWave)		
	ENDIF
	ModifyGraph rgb($destAvgWaveNameOx)=(16385,28398,65535)
	IF(NormalizeTime==0)
		ModifyGraph/W=$(winAvgOx) zero(bottom)=1,manTick(bottom)={0,60,0,0}
	ENDIF
	
	AutoPositionWindow/E/M=0/R=$(winAvgHR) $(winAvgOx)
END

//-------------------------------------------------------------------//

Function/WAVE OximToImage_Sorter(wave Image,[variable varSel,variable segment,variable AllType])
	DFREF dfr = getWavesDataFolderDFR(Image)
	
	variable i,imgDim = dimSize(Image,0)
	variable imgLen = dimSize(Image,1)
	IF(imgDim==0)
		return $("")
	ENDIF
	
	segment = segment==0 ? 1 : segment
	
	string varSelName
	switch(varSel)	//
		case 0:	//
			varSelName = "Age"
			break
		case 1:	//
			varSelName = "DisconnectTime"
			break
		case 2:	//
			varSelName = "DesaturationTime"
			break
		case 3:	//
			varSelName = "HypoxiaTime"
			break		
		case 4:	//
			varSelName = "MaxHR"
			break					
	endswitch

	string imgName = nameOfWave(Image)
	string imgSortName = imgName + "_Sort" + num2str(varSel)
	
	variable imgType = GrepString(imgName,"(?i)_HR")
	
	Duplicate/O Image,dfr:$(imgSortName)/WAVE=ImageSort
	MatrixTranspose ImageSort
	
	insertPoints/M=1 0,1,ImageSort
	IF(varSel==0)
		setDimLabel 1,0,$(varSelName),ImageSort
		variable OximVarRowSel = 2
	ELSEIF(varSel==1)
		setDimLabel 1,0,$(varSelName+num2str(segment)),ImageSort
		OximVarRowSel = segment==1 ? 2 : 3
	ELSEIF(varSel==2)
		setDimLabel 1,0,$(varSelName+num2str(segment)),ImageSort
		OximVarRowSel = segment==1 ? 2 : 3		
	ELSEIF(varSel==3)
		setDimLabel 1,0,$(varSelName+num2str(segment)),ImageSort
		OximVarRowSel = segment==1 ? 2 : 3	
	ELSEIF(varSel==4)
		setDimLabel 1,0,$(varSelName),ImageSort
		OximVarRowSel = 2					
	ENDIF
	
	variable vuelo,oximetro
	IF(AllType==0)
		SVAR actVuelo = root:actVuelo
		sscanf ActVuelo,"Vuelo_%g",vuelo
	ENDIF
	for(i=0;i<imgLen;i++)
		string actDimLabel = getDimLabel(ImageSort,0,i)
		sscanf actDimLabel,"Vuelo_%g_Oxim_%g",vuelo,oximetro
		
		wave OximVars = OximVariables_Get(vuelo=vuelo,oximetro=oximetro,varSel=varSel)
		ImageSort[i][0] = OximVars[OximVarRowSel]
	endfor
	
	IF(varSel==4) //Normalize by maxHR, get achieved maximum
		if(imgType==1) //For HR wave
			for(i=0;i<imgLen;i++)
				variable saveMax = ImageSort[i][0]
				//ImageSort[i][1,] = (ImageSort[i][q]/saveMax) * 100 //Normalize
				MatrixOP/FREE actRow = row(ImageSort,i)
				variable foundMax = waveMax(actRow,1,inf)
				ImageSort[i][0] = foundMax
			endfor
		elseif(imgType==0) //For Saturation wave. !! HR must be done BEFORE OX
			string HRimgSortName = replaceString("Ox",imgSortName,"HR")
			wave HRSortKey = dfr:$(HRimgSortName+"Key")
			ImageSort[][0] = HRSortKey[p]
		endif
	ENDIF
	
	SortColumns/DIML/KNDX={0} sortWaves={ImageSort}
	Duplicate/O/R=[][0] ImageSort,dfr:$(imgSortName+"Key")/WAVE=ImageSortKey
	DeletePoints/M=1 0,1,ImageSort
	MatrixTranspose ImageSort
	
	return ImageSort
END

//-------------------------------------------------------------------//


Function/WAVE OximVariables_Get([vuelo,oximetro,varSel])
	variable vuelo
	variable oximetro
	variable varSel

	SVAR actVuelo = root:actVuelo
	variable actVueloNuM
	IF(ParamIsDefault(Vuelo) || vuelo==0)
		sscanf ActVuelo,"Vuelo_%g",actVueloNum
	ELSE
		sprintf ActVuelo,"Vuelo_%g",Vuelo
		actVueloNum = Vuelo
	ENDIF
	
	SVAR ActOxim = root:ActOxim
	variable actOxNuM
	IF(ParamIsDefault(oximetro) || oximetro==0)
		sscanf ActOxim,"Oxim_%g",actOxNum
	ELSE
		sprintf ActOxim,"Oxim_%g",oximetro
		actOxNum = oximetro
	ENDIF

	DFREF dfrRes = root:Resources:Oximetry
	DFREF dfrVuelo = root:$(actVuelo)
	DFREF dfrOx = dfrVuelo:$(actOxim)

	Make/FREE/N=(4) OximVars
	SetDimLabel 0,0,$"Vuelo",OximVars
	SetDimLabel 0,1,$"Oximetro",OximVars	
	OximVars[0] = actVueloNum
	OximVars[1] = actOxNum	
	
	switch(varSel) //Variable selected
		case 0: //Edad - Sexo
			SetDimLabel 0,2,$"Edad",OximVars
			SetDimLabel 0,3,$"Sexo",OximVars
			NVAR varEdad = dfrOx:v_edad
			SVAR strSexo = dfrOx:s_sexo

			OximVars[2] = varEdad
			OximVars[3] = cmpstr(strSexo,"M")==0 ? 1 : 2
			break	
		case 1: //Tiempos desconectado (diurno/nocturno)
			SetDimLabel 0,2,$"DisconnectTimeDay",OximVars
			SetDimLabel 0,3,$"DisconnectTimeNight",OximVars
			wave Oxim_ConexionTimes = dfrVuelo:Oxim_ConexionTimes
			variable oximRow = findDimLabel(Oxim_ConexionTimes,0,ActOxim)

			OximVars[2] = Oxim_ConexionTimes[oximRow][2]
			OximVars[3] = Oxim_ConexionTimes[oximRow][5]
			break
		case 2: //Tiempos desaturacion (diurno/nocturno)
			SetDimLabel 0,2,$"DesaturationTimeDay",OximVars
			SetDimLabel 0,3,$"DesaturationTimeNight",OximVars
			wave Oxim_DesaturationTimes = dfrVuelo:Oxim_DesaturationTimes
			oximRow = findDimLabel(Oxim_DesaturationTimes,0,ActOxim)

			OximVars[2] = Oxim_DesaturationTimes[oximRow][2]
			OximVars[3] = Oxim_DesaturationTimes[oximRow][5]
			break
		case 3: //Tiempos hipoxia (diurno/nocturno)
			SetDimLabel 0,2,$"HypoxiaTimeDay",OximVars
			SetDimLabel 0,3,$"HypoxiaTimeNight",OximVars
			wave Oxim_HipoxiaTimes = dfrVuelo:Oxim_HipoxiaTimes
			oximRow = findDimLabel(Oxim_HipoxiaTimes,0,ActOxim)

			OximVars[2] = Oxim_HipoxiaTimes[oximRow][2]
			OximVars[3] = Oxim_HipoxiaTimes[oximRow][5]
			break
		case 4: //Max HR
			SetDimLabel 0,2,$"MaxHR",OximVars
			SetDimLabel 0,3,$"Age",OximVars
			
			NVAR varEdad = dfrOx:v_edad
			
			OximVars[2] = 220 - varEdad
			OximVars[3] = varEdad			
			break			
	endswitch
	
	return OximVars
END


//-------------------------------------------------------------------//
Function A2Panel()
END
//////////////////////////////////////////////////////////////////////////////////////////////////////
//02//**PANEL**///////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////

//-------------------------------------------------------------------//
//OXIMETER PANEL

//Reset -1 closes, 0 to front or open, 1 close and open, 2 clean and open
Function show_OximPanelWindow([reset])
	variable reset
	
	string OximWindowName = "OximWindow"
		DoWindow/HIDE=? $(OximWindowName) 
		Variable OximWindowExists = V_flag
		
	variable iniL = 280
	variable iniT = 0
	variable ancho = 1000
	variable alto = 450
		
	IF(reset==1 || reset==-1) //Reset all (1)
		Killwindow/Z $(OximWindowName)
	ELSEIF(reset==0)
		DoWindow/F $(OximWindowName)
	ENDIF
	IF((OximWindowExists==0 && reset!=-1) || (OximWindowExists==1 && reset==1))
		NewPanel/K=1/N=$(OximWindowName)/W=(iniL,iniT,iniL+ancho,iniT+alto)
	ELSEIF((OximWindowExists==1 && reset==2))
		string childWin = childWindowList(OximWindowName)
		variable i
		for(i=0;i<itemsInList(childWin);i++)
			string actWin = OximWindowName + "#" + stringFromList(i,childWin,";")
			killWindow/Z $(actWin)
		endfor
	ELSE
		return 0
	ENDIF	
END

//-------------------------------------------------------------------//

Function show_OximPanel([reset])
	variable reset

	SVAR actVuelo = root:actVuelo
	variable actVueloNuM
	sscanf ActVuelo,"Vuelo_%g",actVueloNum
	SVAR ActOxim = root:ActOxim
	variable actOxNuM
	sscanf ActOxim,"Oxim_%g",actOxNum
	
	string OximPanelName = "OximPanel"
	
	VARIABLE dBTp = 50
	VARIABLE dBTz = 50
	Variable dBToff = 10
	VARIABLE fontZ = 14
	
	DoWindow/HIDE=? $(OximPanelName) 
	Variable OximPanelExists = V_flag
	IF(OximPanelExists==1)
		ControlInfo/W=$(OximPanelName) btOP0
		variable pp0ud = str2num(s_userData[7,inf])
		
		ControlInfo/W=$(OximPanelName) btOP1
		variable pp1ud = str2num(s_userData[7,inf])
	ENDIF
	
	IF(reset==1) //Reset all (1)
		Killwindow/Z $(OximPanelName)
	ELSEIF(reset==0) //To front
		DoWindow/F $(OximPanelName)
	ENDIF
	IF(OximPanelExists==0 || (OximPanelExists==1 && reset==1))
		NewPanel/K=1/N=$(OximPanelName)/W=(0,0,5*dBTp+dBToff,10*dBTp+dBToff)  as "Oximeter Panel"
		ModifyPanel/W=$(OximPanelName) fixedSize=1
	ELSE
		return 0
	ENDIF	
	
	DFREF dfrRes = root:Resources:Oximetry
	
	variable segmentIn = 0
	IF(segmentIn==0)
		string segmentStr = ""
	ELSE
		segmentStr  = "Segm" + num2str(segmentIn)
	ENDIF
	
	//Oxim list
	NVAR OximIni = dfrRes:OximIni
	NVAR OximLast = dfrRes:OximLast
	Make/Free/n=(oximLast) oxims = oximIni + p
	string oximList
	wfprintf oximList,"Oxim %g;",oxims
	oximList = "\"" + oximList + "\""
	string oximListMatch
	sprintf oximListMatch,"Oxim %g",actOxNum //PoPupMenu popupOPox,popMatch=oximListMatch

	//Flight list
	SVAR VuelosDisp = dfrRes:VuelosInRoot
	string vueloList = "\"" + VuelosDisp + "\""
	
	//Display box
	GroupBox gbOP0,pos={dBToff/2,dBToff/2},size={5*dBTp,2.0*dbTp+dBToff},title="Seleccion datos" //ESP: //left 9 top 101 width 193 height 254
	
	Button btOP0,pos={dBTp*0+dBToff,dBTp*0.5+1*dBToff},size={2*dBTz,dBTz/2},proc=show_OximPanel_BT,title="Flight",fSize=fontZ,userdata="active 0",focusRing=0 //ESP:"Vuelo" 
	Button btOP1,pos={dBTp*0+dBToff,dBTp*1.0+2*dBToff},size={2*dBTz,dBTz/2},proc=show_OximPanel_BT,title="Oximeter",fSize=fontZ,userdata="active 0",focusRing=0 //ESP:"Oximetro" 
	
	Button btOP2,pos={dBTp*0+dBToff,dBTp*2.5+0*dBToff},size={3*dBTz,dBTz/2},proc=show_OximPanel_BT,title="Select Flight",fSize=fontZ,userdata="active 0",focusRing=0 //ESP:"Confirmar vuelo" 
	Button btOP3,pos={dBTp*0+dBToff,dBTp*3.0+1*dBToff},size={2*dBTz,dBTz/2},proc=show_OximPanel_BT,title="Select Oximeter",fSize=fontZ-4,userdata="active 0",focusRing=0 //ESP:"Confirmar oximetro"
	Button btOP4,pos={dBTp*2+dBToff,dBTp*3.0+1*dBToff},size={1*dBTz,dBTz/2},proc=show_OximPanel_BT,title="Mark invalid",fSize=fontZ-6,userdata="active 0",focusRing=0 //ESP:"Revisar ox" 
	
	Button btOP5,pos={dBTp*0+dBToff,dBTp*3.5+1*dBToff},size={1*dBTz,dBTz},proc=show_OximPanel_BT,title="Show\nGraph",fSize=fontZ-5,userdata="active 0",focusRing=0 //ESP:"Mostrar\nImagen" 
	Button btOP6,pos={dBTp*1+dBToff,dBTp*3.5+1*dBToff},size={1*dBTz,dBTz},proc=show_OximPanel_BT,title="Show\nSlope",fSize=fontZ-5,userdata="active 0",focusRing=0 //ESP:"Mostrar\nTendencia" 
	Button btOP7,pos={dBTp*2+dBToff,dBTp*3.5+1*dBToff},size={1*dBTz,dBTz},proc=show_OximPanel_BT,title="Manual\nFit",fSize=fontZ-5,userdata="active 0",focusRing=0 //ESP:"Manual\nFit" 
	
	SetVariable svOPvue,pos={dBTp*2.0+(2*dBToff),dBTp*0.5+(1.5*dBToff)},size={dBTz*2.2,dBTz/2},title="Flight",format="%g" //ESP:"Vuelo"
	SetVariable svOPvue,limits={1,9999,1},value=_NUM:actVueloNum,proc=show_OximPanel_Var
	
	PopupMenu popupOPox,pos={dBTp*1.5+(4*dBToff),dBTp*1+(2.2*dBToff)},size={dBTz,dBTz/2},title=""
	PopupMenu popupOPox,mode=1,popColor= (65535,0,0),value=#oximList,proc=show_OximPanel_Pop
	PoPupMenu popupOPox,popMatch=oximListMatch
	
	SetVariable svOPox,pos={dBTp*3.5+(1*dBToff),dBTp*1.0+(2.2*dBToff)},size={dBTz*1,dBTz/2},title="",format="%g"
	SetVariable svOPox,limits={1,12,1},value=_NUM:actOxNum,proc=show_OximPanel_Var
	
	//Segment time data
	SetVariable svOPseg,pos={dBTp*3.5-(1*dBToff),dBTp*2.5+(0.0*dBToff)},size={dBTz*1.5,dBTz/2},title="Segm",format="%g" //ESP: ***
	SetVariable svOPseg,limits={-1,9,1},value=_NUM:segmentIn,proc=show_OximPanel_Var
	
	TitleBox tbOPSegTime,pos={3.5*dBTp-(1*dBToff),3.5*dBTp+(0*dBToff)},size={1.6*dBTz,1*dBTz},fixedSize=1,title="\\JCT: 0000 s\r(0000-0000)"
	TitleBox tbOPSegTime,fsize=12,labelBack=(65535,65535,65535)
	
	//CheckBox cbPP0,pos={dBTp*0.5+dBToff,dBTp*2.0+1.6*dBToff},size={2*dBTz,dBTz/2},title=""
	//CheckBox cbPP0,value=1,mode=0,side=0,proc=
	
	//Segment data by oxigen or heart rate
	GroupBox gbOP1,pos={0.0*dBTp+(dBToff/2),4.5*dBTp+(2*dBToff)},size={2.5*dBTp,3.0*dbTp+dBToff},title=("Oxygen"+segmentStr) //ESP:Oxigeno
	
	ValDisplay vdOPox0,pos={0*dBTp+(1*dBToff),5.0*dBTp+(2*dBToff)},size={2*dBTz,dBTz/2},format="Min %.4g",value=_NUM:0 //,title="Min"
	ValDisplay vdOPox1,pos={0*dBTp+(1*dBToff),5.5*dBTp+(2*dBToff)},size={2*dBTz,dBTz/2},format="Max %.4g",value=_NUM:0 //,title="Max"
	ValDisplay vdOPox2,pos={0*dBTp+(1*dBToff),6.0*dBTp+(2*dBToff)},size={2*dBTz,dBTz/2},format="Avg %.4g",value=_NUM:0 //,title="Avg"
	
	TitleBox tbOPoxFit1,pos={0*dBTp+(1*dBToff),6.5*dBTp+(2*dBToff)},size={2*dBTz,dBTz/2},fixedSize=1,title="y = mx + q"
	TitleBox tbOPoxFit1,fsize=10,labelBack=(65535,65535,65535)
	
	TitleBox tbOPoxFit2,pos={0*dBTp+(1*dBToff),7.0*dBTp+(2*dBToff)},size={2*dBTz,dBTz/2},fixedSize=1,title="y = mx + q"
	TitleBox tbOPoxFit2,fsize=10,labelBack=(65535,65535,65535)
	
	GroupBox gbOP2,pos={2.5*dBTp+(dBToff/2),4.5*dBTp+(2*dBToff)},size={2.5*dBTp,3.0*dbTp+dBToff},title=("Heart rate"+segmentStr) //ESP:Cardiaco
	
	ValDisplay vdOPhr0,pos={2.5*dBTp+(1*dBToff),5.0*dBTp+(2*dBToff)},size={2*dBTz,dBTz/2},format="Min %.4g",value=_NUM:0
	ValDisplay vdOPhr1,pos={2.5*dBTp+(1*dBToff),5.5*dBTp+(2*dBToff)},size={2*dBTz,dBTz/2},format="Max %.4g",value=_NUM:0
	ValDisplay vdOPhr2,pos={2.5*dBTp+(1*dBToff),6.0*dBTp+(2*dBToff)},size={2*dBTz,dBTz/2},format="Avg %.4g",value=_NUM:0
	
	TitleBox tbOPhrFit1,pos={2.5*dBTp+(1*dBToff),6.5*dBTp+(2*dBToff)},size={2*dBTz,dBTz/2},fixedSize=1,title="y = mx + q"
	TitleBox tbOPhrFit1,fsize=fontZ-4,labelBack=(65535,65535,65535)
	
	TitleBox tbOPhrFit2,pos={2.5*dBTp+(1*dBToff),7.0*dBTp+(2*dBToff)},size={2*dBTz,dBTz/2},fixedSize=1,title="y = mx + q"
	TitleBox tbOPhrFit2,fsize=fontZ-4,labelBack=(65535,65535,65535)
	
	TitleBox tbOPBotInfo,pos={0.0*dBTp+(0.5*dBToff),8.0*dBTp+(1.5*dBToff)},size={5*dBTz,1.25*dBTz},fixedSize=1,title="\\JCT: -"
	TitleBox tbOPBotInfo,fsize=fontZ-3,labelBack=(65535,65535,65535)
	
	Button btOP8,pos={dBTp*0+dBToff,dBTp*9.5+0.5*dBToff},size={2*dBTz,dBTz/2},proc=show_OximPanel_BT,title="NIRS",fSize=fontZ-5,userdata="active 0",focusRing=0
	//Button btOP9,pos={dBTp*2+dBToff,dBTp*9.5+0.5*dBToff},size={1*dBTz,dBTz/2},proc=show_OximPanel_BT,title="-",fSize=fontZ-5,userdata="active 0",focusRing=0
	
	SetVariable svOPnirs,pos={dBTp*3.1+(1*dBToff),dBTp*9.5+(0.8*dBToff)},size={dBTz*1.7,dBTz/2},title="Sensors",format="%g" //ESP:"Sensores"
	SetVariable svOPnirs,limits={1,2,1},value=_NUM:1,proc=show_OximPanel_Var
	
	IF(1)
		show_OximPanel_VueloOximHandler() //Update data based on selected flight and oximeter
	ENDIF
	
	
END

//-------------------------------------------------------------------//

Function show_OximPanel_Pop(pop) : PopupMenuControl
	STRUCT WMPopupAction &pop
	switch(pop.eventCode)
		case 2:
			String ctrlName = pop.ctrlname
			Variable popNum = pop.popNum
			String popStr = pop.popStr
			String winNm = pop.win

			strswitch(ctrlName)
				case "popupOPox":
					variable oximNum
					sscanf popStr,"Oxim %g",oximNum
					SetVariable svOPox,value=_NUM:oximNum,win=$(winNm) //Set variable and let func handle
					show_OximPanel_VueloOximHandler()
					break

			EndSwitch
			break
	EndSwitch
	return 0
End

//-------------------------------------------------------------------//

//VAR OximPanel
Function show_OximPanel_Var(SV) : SetVariableControl
	STRUCT WMSetVariableAction &SV
	switch( SV.eventCode )
		case 1: // mouse up
		case 8: // EndEdit
			Variable Valor = SV.dval
			String PanelName = SV.win
			
			SVAR actvuelo = root:actVuelo
			SVAR actOxim = root:actOxim
			
			string dispWinName = "OximWindow"

			StrSwitch(SV.ctrlName)
				case "svOPseg": // 
						show_OximPanel_VueloOximHandler()
					break
					
				case "svOPox": // 
					//Printf "Oximetro %g\n",Valor
						sprintf actOxim,"Oxim_%g",valor
						string oximListMatch
						sprintf oximListMatch,"Oxim %g",valor
						PoPupMenu popupOPox,popMatch=oximListMatch,win=$(panelName)
						
						show_OximPanel_VueloOximHandler()
					break	
				
				case "svOPvue": //Vuelo selector
						sprintf actVuelo,"Vuelo_%g",valor
						show_OximPanel_VueloOximHandler()
					break
			EndSwitch
			break
	endswitch
	return 0
End

//-------------------------------------------------------------------//

//Botones Panel Oximetro
Function show_OximPanel_BT(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	switch( ba.eventCode )
		case 1: // mouse dn
			String PanelName = ba.win
			string btPress = ba.ctrlName
			
			SVAR actvuelo = root:actVuelo
			SVAR actOxim = root:actOxim
			
			string dispWinName = "OximWindow"

			StrSwitch(btPress)
				case "btOP0": // Vuelo
					ControlInfo/W=$(PanelName) btOP0
					variable pp0ud = str2num(s_userData[7,inf])
					IF(pp0ud==0)
						Button btOP0,win=$(PanelName),userdata="active 1",fColor=(65535,43688,32768) //Enable vuelo
					ELSE
						Button btOP0,win=$(PanelName),userdata="active 0",fColor=(0,0,0)
					ENDIF
					
					show_OximPanel_VueloOximHandler()
					break

				case "btOP1": // Oximetro
					ControlInfo/W=$(PanelName) btOP1
					variable pp1ud = str2num(s_userData[7,inf])
					IF(pp1ud==0)
						Button btOP1,win=$(PanelName),userdata="active 1",fColor=(65535,43688,32768) //Enable oxim
					ELSE
						Button btOP1,win=$(PanelName),userdata="active 0",fColor=(0,0,0)
					ENDIF
					
					show_OximPanel_VueloOximHandler()
					break
					
				case "btOP2": // Confirmar todos los oximetros del vuelo
					Confirmar_Vuelo(dataAdd=1,filteredData=0)
					break
					
				case "btOP3": // Confirmar oximetro
					Confirmar_Oximetro(dataAdd=1)
					break	
									
				case "btOP4": // Revisar oximetro
					variable RevOx
					string RevOxHelp = "1. Exclude Oximeter;2. Unmark Oximeter"
					Prompt RevOx, "Accion: ", popUp RevOxHelp
								
					DoPrompt/HELP=("-") "Action to perform on selected oximeter: ", RevOx
						if (V_Flag)
							return -1
						endif
					RevOx = RevOx==1 ? -1 : 0
					
					Confirmar_Oximetro(dataAdd=RevOx)
					break	
					
				case "btOP5": // Mostrar imagen	
					OximToImage_Handler(inType=1,inRemake=1,NormalizeHRbyAge=2)	
					break	
					
				case "btOP6": // Mostrar promedio y sdev de imagen
					variable Segment = 1
					OximToImage_GetAverages_Display(AllType=0,Segment=Segment)
					break						
				
				case "btOP7": //Custom fit
					OximData_CustomFit()
					break
					
				case "btOP8": //NIRS
					ControlInfo/W=$(PanelName) btOP8
					variable pp8ud = str2num(s_userData[7,inf])
					IF(pp8ud==0)
						Button btOP8,win=$(PanelName),userdata="active 1",fColor=(65535,43688,32768) //Enable oxim
					ELSE
						Button btOP8,win=$(PanelName),userdata="active 0",fColor=(0,0,0)
					ENDIF
					
					ControlInfo/W=$(PanelName) svOPvue
					variable vueloNum = v_value

					ControlInfo/W=$(PanelName) svOPnirs
					variable setSensor = v_value					
					
					show_NIRS(vueloNum,setSensor)
					break	
								
			EndSwitch
			
		break
	endswitch
	return 0
End

//-------------------------------------------------------------------//

Function show_OximPanel_VueloOximHandler()
	string panelName = "OximPanel"
	string dispWinName = "OximWindow"

	ControlInfo/W=$(PanelName) btOP0
	variable pp0ud = str2num(s_userData[7,inf])
		
	ControlInfo/W=$(PanelName) btOP1
	variable pp1ud = str2num(s_userData[7,inf])
	
	variable showVu=pp0ud,showOx=pp1ud
	
	ControlInfo/W=$(PanelName) svOPvue
	variable vueloNum = v_value
	//sscanf s_value,"Vuelo_%g",vueloNum
	
	ControlInfo/W=$(PanelName) svOPox
	variable oximNum = v_value
	
	ControlInfo/W=$(PanelName) svOPseg
	variable segmentIn = v_value
	
	IF(showVu==0 && showOx==0)
		show_OximPanelWindow(reset=-1)
		//return 0
	ENDIF
	
	DFREF dfrResource = root:Resources:Oximetry
	
	wave OximData = show_OximPanel_VueloOximHandler_Data(segmentIn)
	IF(!waveExists(OximData))
		return 0
	ELSE
		string/G dfrResource:OximInfo/N=oximInfo
		oximInfo = show_OximPanel_VueloOximHandler_Info(oxim=oximNum)
		string timeData,oxFit1,oxFit2,hrFit1,hrFit2
		IF(segmentIn==0)
			string segmentStr = ""
		ELSEIF(segmentIn==-1)
			segmentStr = " All S"
		ELSE
			segmentStr  = " S" + num2str(segmentIn)
		ENDIF
		GroupBox gbOP1,win=$(panelName),title=("Oxygen"+segmentStr) //ESP:"Oxigeno"
	
		ValDisplay vdOPox0,win=$(panelName),value=_NUM:OximData[0][0]
		ValDisplay vdOPox1,win=$(panelName),value=_NUM:OximData[1][0]
		ValDisplay vdOPox2,win=$(panelName),value=_NUM:OximData[2][0]
		
		sprintf oxFit1,"q = %.02f",OximData[3][0]
		sprintf oxFit2,"m = %+.03e",OximData[4][0]
		TitleBox tbOPoxFit1,win=$(panelName),title=oxFit1
		TitleBox tbOPoxFit2,win=$(panelName),title=oxFit2
		
		GroupBox gbOP2,win=$(panelName),title=("Heart Rate"+segmentStr) //ESP:"Cardiaco"
		
		ValDisplay vdOPhr0,win=$(panelName),value=_NUM:OximData[0][1]
		ValDisplay vdOPhr1,win=$(panelName),value=_NUM:OximData[1][1]
		ValDisplay vdOPhr2,win=$(panelName),value=_NUM:OximData[2][1]
		
		sprintf hrFit1,"q = %.02f",OximData[3][1]
		sprintf hrFit2,"m = %+.03e",OximData[4][1]
		TitleBox tbOPhrFit1,win=$(panelName),title=hrFit1
		TitleBox tbOPhrFit2,win=$(panelName),title=hrFit2
		
		sprintf timeData,"\\JCT: %0.4g s\r(%0.4g-%0.4g)",OximData[5][1]-OximData[5][0],OximData[5][0],OximData[5][1]
		TitleBox tbOPSegTime,win=$(panelName),title=timeData
		
		TitleBox tbOPBotInfo,win=$(panelName),variable=oximInfo//title=oximInfo
	ENDIF	
	
	IF(showVu==0 && showOx==0)
		//show_OximPanelWindow(reset=-1)
		return 0
	ENDIF
	
	show_OximPanelWindow(reset=2)
	IF(showVu==1 && showOx==1) //show both
		showOxim(oximNum,processed=1,hostWin=dispWinName,modeDisp=1)
		showFlight(vueloNum,hostWin=dispWinName,modeDisp=1)
	ELSEIF(showVu==1) //Show vuelo
		showFlight(vueloNum,hostWin=dispWinName)
		
	ELSEIF(showOx==1) //Show oxim
		showOxim(oximNum,processed=1,hostWin=dispWinName)
	ENDIF
	
	IF(showOx==1)
		variable showFit=1
		showOxim_higlight(segmentIn,pan=1,showFit=showFit)
	ENDIF

END

//-------------------------------------------------------------------//

//Segment data compilator for HR and Saturation waves
Function/WAVE show_OximPanel_VueloOximHandler_Data(variable segment)

	SVAR actvuelo = root:actVuelo
	DFREF dfrVuelo = root:$(actVuelo)

	SVAR actOxim = root:actOxim	
	DFREF dfrOx = dfrVuelo:$(actOxim)
	
	variable actOxNum
	sscanf actOxim,"Oxim_%g",actOxNum
	
	IF(segment==0 || segment==-1)
		wave oxSat = dfrOx:w_sat_proc
		wave oxHr = dfrOx:w_lpm_proc
		
		IF(!waveExists(oxSat) && !waveExists(oxHr))
			return $("")
		ELSE
			Make/FREE/N=(6,2) OximData
			SetDimLabel 1,0,'O2',OximData
			SetdimLabel 1,1,'HR',OximData
		ENDIF
			
		OximData[0][0] = waveMin(oxSat) //o2 min
		OximData[1][0] = waveMax(oxSat) //o2 max
		OximData[2][0] = mean(oxSat) //o2 avg
		
		OximData[0][1] = waveMin(oxHr) //hr min
		OximData[1][1] = waveMax(oxHr) //hr max
		OximData[2][1] = mean(oxHr) //hr avg
		
		OximData[3][0] = 0 	//o2 base
		OximData[4][0] = 0	//o2 pendiente
		
		OximData[3][1] = 0	//hr base
		OximData[4][1] = 0	//hr pendiente
		
		OximData[5][0] = 0 //timeIn
		OximData[5][1] = indexToScale(oxSat,dimSize(oxSat,0),0) //timeOut

	ELSE
		Wave Oxim_SegmentData = dfrVuelo:Oxim_SegmentData
		Wave Oxim_SegmentFitCoefs = dfrVuelo:Oxim_SegmentFitCoefs
		
		IF(!waveExists(Oxim_SegmentData))
			return $("")
		ELSE
			Make/FREE/N=(6,2) OximData
			SetDimLabel 1,0,'O2',OximData
			SetdimLabel 1,1,'HR',OximData
		ENDIF
			
		OximData[0][0] = Oxim_SegmentData[actOxNum-1][0][segment-1] //o2 min
		OximData[1][0] = Oxim_SegmentData[actOxNum-1][1][segment-1] //o2 max
		OximData[2][0] = Oxim_SegmentData[actOxNum-1][2][segment-1] //o2 avg
		
		OximData[0][1] = Oxim_SegmentData[actOxNum-1][4][segment-1] //hr min
		OximData[1][1] = Oxim_SegmentData[actOxNum-1][5][segment-1] //hr max
		OximData[2][1] = Oxim_SegmentData[actOxNum-1][6][segment-1] //hr avg
		
		OximData[3][0] = Oxim_SegmentFitCoefs[actOxNum-1][0][segment-1] //o2 base
		OximData[4][0] = Oxim_SegmentFitCoefs[actOxNum-1][1][segment-1] //o2 pendiente
		
		OximData[3][1] = Oxim_SegmentFitCoefs[actOxNum-1][4][segment-1] //hr base
		OximData[4][1] = Oxim_SegmentFitCoefs[actOxNum-1][5][segment-1] //hr pendiente
		
		//Last 2 cols for time
		Wave AllSegmentTimes = dfrOx:AllSegmentTimes
		IF(WaveExists(AllSegmentTimes))
			variable segIn = AllSegmentTimes[segment-1][0]
			variable segOut = AllSegmentTimes[segment-1][1]
		ENDIF		
		OximData[5][0] = segIn
		OximData[5][1] = segOut

	ENDIF
	
	return OximData
END

//-------------------------------------------------------------------//

Function/S show_OximPanel_VueloOximHandler_Info([variable oxim])
	SVAR actvuelo = root:actVuelo
	DFREF dfrVuelo = root:$(actVuelo)

	SVAR actOxim = root:actOxim
	variable actOxNum
	IF(oxim!=0)
		actOxNum = oxim
		sprintf actOxim,"Oxim_%g",actOxNum
	ELSE
		sscanf actOxim,"Oxim_%g",actOxNum
	ENDIF
	DFREF dfrOx = dfrVuelo:$(actOxim)

	SVAR Nombre = dfrOx:s_apellidoP
	NVAR Edad = dfrOx:v_edad
	SVAR Sexo = dfrOx:s_sexo
	SVAR Rango = dfrOx:s_rango
	
	wave ConexionTimes = dfrVuelo:Oxim_ConexionTimes
	wave ConexionLag = dfrVuelo:Oxim_ConexionLag
	
	wave DesaturationTimes = dfrVuelo:Oxim_DesaturationTimes
	wave DesaturationLag = dfrVuelo:Oxim_DesaturationLag
	
	wave HipoxiaTimes = dfrVuelo:Oxim_HipoxiaTimes
	wave HipoxiaLag = dfrVuelo:Oxim_HipoxiaLag
	
	variable oximIndice = findDimLabel(ConexionTimes,0,actOxim)
	string OximInfoText = "-"
	IF(oximIndice==-2)
		return oximInfoText
	ENDIF
	
	variable d1 = ConexionTimes[oximIndice][0] 	//Start
	variable d2 = DesaturationLag[oximIndice][0] 	//Start to desat
	variable d3 = HipoxiaLag[oximIndice][0] 		//Start to hipox
	variable d4 = ConexionTimes[oximIndice][2] 	//Start to RC
	variable d5 = HipoxiaLag[oximIndice][1] 		//RC to hipox
	variable d6 = DesaturationLag[oximIndice][1] 	//RC to desat
	
	variable n1 = ConexionTimes[oximIndice][3] 	//Start
	variable n2 = DesaturationLag[oximIndice][3] 	//Start to desat
	variable n3 = HipoxiaLag[oximIndice][3] 		//Start to hipox
	variable n4 = ConexionTimes[oximIndice][5] 	//Start to RC
	variable n5 = HipoxiaLag[oximIndice][4] 		//RC to hipox
	variable n6 = DesaturationLag[oximIndice][4] 	//RC to desat
	
	d1 = d1<0 ? 0 : d1
	d2 = d2<0 ? 0 : d2
	d3 = d3<0 ? 0 : d3
	d4 = d4<0 ? 0 : d4
	d5 = d5<0 ? 0 : d5
	d6 = d6<0 ? 0 : d6
	
	n1 = n1<0 ? 0 : n1
	n2 = n2<0 ? 0 : n2
	n3 = n3<0 ? 0 : n3
	n4 = n4<0 ? 0 : n4
	n5 = n5<0 ? 0 : n5
	n6 = n6<0 ? 0 : n6
	
	
	sprintf oximInfoText,"%s (%s), %g\n[D] 97:%gs, 89:%gs, RC:%gs, 89:%gs, 97:%gs\n[N] 97:%gs, 89:%gs, RC:%gs, 89:%gs, 97:%gs"\
	,Nombre,sexo,edad,d2,d3,d4,d5,d6,n2,n3,n4,n5,n6
	
	return oximInfoText
END

//-------------------------------------------------------------------//
///////////////////////////////////////////////////////////////////////
//-------------------------------------------------------------------//
//Vuelo status panel

//-------------------------------------------------------------------//

Function vueloStatus_Panel([variable resetPanel,variable updateInfo,string mainDispString])
	
	//Get Global variables for display
	DFREF dfrResource = root:Resources:Oximetry
	IF(dataFolderRefStatus(dfrResource)==0)
		Init_Globals()
		DFREF dfrResource = root:Resources:Oximetry
	ENDIF
	
	SVAR actvuelo = root:actVuelo
	SVAR actOxim = root:actOxim	
	
	NVAR/Z VuelosIRC = dfrResource:VuelosInRootCount
//	IF(!NVAR_Exists(VuelosIRC))
//		Variable/G dfrResource:VuelosInRootCount/N=VuelosIRC = 0 // Create vuelos cargados global var
//	endif
	NVAR/z VuelosDC = dfrResource:VuelosDispCount
//	IF(!NVAR_Exists(VuelosDC))
//		Variable/G dfrResource:VuelosDispCount/N=VuelosDC = 0 // Create vuelos disponibles global var
//	ENDIF
//	
	SVAR /Z VSmainInfo = dfrResource:VSmainInfo
//	IF(!SVAR_Exists(VSmainInfo))
//		String/G dfrResource:VSmainInfo/N=VSmainInfo = "-"	// Create vspanel bottom info display string
//	ENDIF
//	
	SVAR /Z VStipovuelo = dfrResource:VStipovuelo
//	IF(!SVAR_Exists(VStipovuelo))
//		String/G dfrResource:VStipovuelo/N=VStipovuelo = "-"	// Create vspanel vuelo type display string
//	ENDIF
	SVAR /Z VSorigExpNm = dfrResource:VSorigExpNm
//	IF(!SVAR_Exists(VSorigExpNm))
//		String/G dfrResource:VSorigExpNm/N=VSorigExpNm = "-"	// Create vspanel vuelo original Igor experiment name display string
//	ENDIF	
	
	//Update global variables
	IF(!ParamIsDefault(mainDispString) && cmpstr(mainDispString,"")!=0)
		VSmainInfo = mainDispString
	ENDIF
	
	DFREF dfrVu = root:$(actVuelo)
	IF(DataFolderRefStatus(dfrVu)==1)
		SVAR/Z tipovuelo = dfrVu:s_tipodeVuelo
		SVAR/Z origExpNm = dfrVu:OrigExpName
		IF(SVAR_Exists(tipoVuelo))
			VStipoVuelo = tipoVuelo
		ENDIF
		IF(SVAR_Exists(origExpNm))
			VSorigExpNm = origExpNm
		ENDIF
	ENDIF
		
	//Main window
	string vuelosStname = "VuelosStatusPanel"
		
	variable posX = 300
	variable posY = 300
	variable ancho = posX + 1400
	variable bajo = posY + 650
	
	VARIABLE dBTp = 50
	Variable dBToff = 10
	VARIABLE fontZ = 14
	
	DoWindow/HIDE=? $(vuelosStname) 
	Variable vuelosStnameExists = V_flag	
	IF(resetPanel==1) //Reset all (1)
		VueloStatus_Panel_FilterWave() //Reset filter selections
		VueloStatus_Panel_FilterWave(saveSets=1)
		Killwindow/Z $(vuelosStname)
	ELSEIF(vuelosStnameExists==1 && resetPanel==0) //To front
		DoWindow/F $(vuelosStname)
	ENDIF
	IF(vuelosStnameExists==0 || (vuelosStnameExists==1 && resetPanel==1))
		NewPanel/K=1/N=$(vuelosStname)/W=(posx,posY,ancho,bajo) as "Database Panel"//ESP:"Panel Base de Datos"
		ModifyPanel/W=$(vuelosStname) fixedSize=1
	ELSE
		return 0
	ENDIF	
	
	//Listbox status waves
	wave/Z VSsel = dfrResource:VuelosStatus_Sel
	IF(updateInfo || !waveExists(VSsel))
		loadFlight_CheckFolder(reCheck=1)
		vueloStatus_InfoWave() //Take vuelo status and make suitable wave for listbox on panel
		wave VSsel = dfrResource:VuelosStatus_Sel
	ENDIF
	
	wave/T VStext = dfrResource:VuelosStatus_Text //text has data status
	wave/T VSInfo = dfrResource:VuelosStatus_Info //info has data ID (name, sex, age)
	wave VScolors = dfrResource:VuelosStatus_Colors

	variable textOrInfo = 1
	ListBox lbVSstatus,pos={4*dBTp+(0*dBToff),0*dBTp+(1*dBToff)},size={23.5*dBTp+(1*dBToff),10.0*dBTp+(1*dBToff)}
	IF(textOrInfo==0)
		ListBox lbVSstatus,listWave=VStext,selWave=VSsel,colorWave=VScolors,helpWave=VSInfo
	ELSEIF(textOrInfo==1)
		ListBox lbVSstatus,listWave=VSInfo,selWave=VSsel,colorWave=VScolors,helpWave=VStext
	ENDIF
	ListBox lbVSstatus, mode=6,userColumnResize=1,editStyle= 1,widths={60},proc=VueloStatus_Controls_LB,fSize=fontZ-3
	
	//MENU CONTROLES
	
	variable ordenMenu = 1 // Variable que define el orden de las tres secciones de controles a la izquierda del panel.
	
	variable OMDataSel,OMManejarData,OMFiltrados
	switch(ordenMenu)
		case 0:	// 0: Manejar datos, Data seleccionada, datos filtrados.
			OMDataSel = 0
			OMManejarData = 3.5
			OMFiltrados = 7.0
			break		// 
		case 1:	// 1: Data seleccionada, manejar datos, datos filtrados.
			OMDataSel = 2.9
			OMManejarData = -0.70
			OMFiltrados = 7.0
			break
		case 2:	// 2: Datos filtrados, data seleccionada, manejar datos
			OMDataSel = 8.5
			OMManejarData = 5.0
			OMFiltrados = -0.1
			break
	endswitch
	
	//Actual selected data info
	GroupBox gbVS0,pos={0*dBTp+(1.0*dBToff),(dBTp*(OMDataSel+0.0))+(1*dBToff)},size={3.5*dBTp+(1.0*dBToff),4.0*dBTp},title="Selected Data"//ESP:"Data seleccionada"
	
	TitleBox tbVSvu,pos={0.5*dBTp+(0*dBToff),(dBTp*(OMDataSel+0.5))+(1*dBToff)},fixedSize=1,size={2*dBTp,dBTp/2},labelBack=(65535,65535,65535),variable=actvuelo
	TitleBox tbVSox,pos={0.5*dBTp+(0*dBToff),(dBTp*(OMDataSel+1.0))+(1*dBToff)},fixedSize=1,size={2*dBTp,dBTp/2},labelBack=(65535,65535,65535),variable=actOxim
	
	TitleBox tbVS0,pos={0.5*dBTp+(0*dBToff),(dBTp*(OMDataSel+2.0))+(0*dBToff)},fixedSize=1,size={3*dBTp,dBTp/2},labelBack=(65535,65535,65535),title="-"
	TitleBox tbVS0,variable=VStipovuelo,fsize=11
	
	TitleBox tbVS1,pos={0.5*dBTp+(0*dBToff),(dBTp*(OMDataSel+2.0))+(3*dBToff)},fixedSize=1,size={3*dBTp,dBTp/2},labelBack=(65535,65535,65535),title="-"
	TitleBox tbVS1,variable=VSorigExpNm,fsize=11
	
	Button btVSres,pos={2.0*dBTp+(3*dBToff),(dBTp*(OMDataSel+0.5))+(1*dBToff)},size={1*dBTp,1*dBTp},proc=VueloStatus_Controls_BT,title="Oximeter\nPanel",fSize=fontZ-4,userdata="active 0",focusRing=0 //ESP:"Panel\nOxim"
	
	Button btVS0,pos={0.5*dBTp+(0*dBToff),(dBTp*(OMDataSel+3.25))+(0*dBToff)},size={3*dBTp,3*dBTp/4},proc=VueloStatus_Controls_BT,title="Report",fSize=fontZ,userdata="active 0",focusRing=0 //ESP:"Reporte"
	
	//Loading, processing, and handling data Vuelos
	GroupBox gbVS1,pos={0*dBTp+(1.0*dBToff),(dBTp*(OMManejarData+0.25)+3*dBToff)},size={3.5*dBTp+(1.0*dBToff),2.75*dBTp},title="Handle data" //ESP:"Manejar datos"
	
	Button btVS1,pos={0.0*dBTp+(2.5*dBToff),(dBTp*(OMManejarData+1.0)+1*dBToff)},size={1.5*dBTp,dBTp/2},proc=VueloStatus_Controls_BT,title="Search flight",fSize=fontZ-3,userdata="active 0",focusRing=0 //ESP:"Buscar vuelo"
	
	Button btVS2,pos={1.5*dBTp+(2.5*dBToff),(dBTp*(OMManejarData+1.0)+1*dBToff)},size={1.5*dBTp,dBTp/2},proc=VueloStatus_Controls_BT,title="Edit flight",fSize=fontZ-3,userdata="active 0",focusRing=0 //ESP:"Editar vuelo"
	
	Button btVS3,pos={0.5*dBTp+(0*dBToff),(dBTp*(OMManejarData+1.5)+1*dBToff)},size={3*dBTp,dBTp/2},proc=VueloStatus_Controls_BT,title="Load flight",fSize=fontZ,userdata="active 0",focusRing=0 //ESP:"Cargar Vuelos"
		
	ValDisplay vdVS0,pos={0.5*dBTp-(1*dBToff),(dBTp*(OMManejarData+2.0)+2*dBToff)},fixedSize=1,size={3*dBTp,dBTp/2},title="Loaded flights: ",value=#"root:Resources:Oximetry:VuelosInRootCount" //ESP:"Vuelos cargados: " //labelBack=(65535,65535,65535)
	ValDisplay vdVS1,pos={0.5*dBTp-(1*dBToff),(dBTp*(OMManejarData+2.0)+5*dBToff)},fixedSize=1,size={3*dBTp,dBTp/2},title="Available flights: ",value=#"root:Resources:Oximetry:VuelosDispCount" //ESP:"Vuelos disponibles: " //,labelBack=(65535,65535,65535)
	
	//Filtered data:
	
	GroupBox gbVS2,pos={0*dBTp+(1.0*dBToff),(dBTp*(OMFiltrados+0.0)+1*dBToff)},size={3.5*dBTp+(1.0*dBToff),5.5*dBTp+(0.5*dBToff)},title="Filtered Data"//ESP:"Datos filtrados"
	
	Button btVS4,pos={0.5*dBTp+(0*dBToff),(dBTp*(OMFiltrados+0.0)+3*dBToff)},size={3*dBTp,0.7*dBTp},proc=VueloStatus_Controls_BT,title="Graph summary",fSize=fontZ,userdata="active 0",focusRing=0	 //ESP:"Imagen Resumen"
	
	string DisplayModes = "\"" + "1. Status: Data;2. Status: Names (ID);3. DC Time;4. Desaturation Time;5. Hypoxia time" +\
	";6. Lag DC-Desaturation;7. Lag DC-Hypoxia;8. Lag RC-Hypoxia recover;9. Lag RC-Resaturation;10. Biometric (Age);11. Biometric (Sex);10. Multiple Filter (3-11)" + "\""
	//ESP:string DisplayModes = "\"" + "1. Status: Data;2. Status: Nombres (ID);3. Tiempo DC;4. Tiempo Desaturacion;5. Tiempo Hipoxia" +\
	//";6. Lag DC-Desaturacion;7. Lag DC-Hipoxia;8. Lag RC-RecHipoxia;9. Lag RC-Resaturacion;10. Biometrica (Edad);11. Biometrica (Sexo);10. Filtro multiple (3-11)" + "\""
	
	wave/Z VSfilteredVars = dfrResource:VSfilteredVars	// Create vspanel bottom info display string
	variable MinLow = 0,Low = 0,High = 800,MaxHigh = 800 //Default values
	variable presetParams = 10
	IF(!WaveExists(VSfilteredVars) || dimSize(VSfilteredVars,1)!=presetParams)
		wave VSfilteredVars = VueloStatus_Panel_FilterWave()
	ENDIF
	
	TitleBox tbVS4,pos={(0*dBTp)+(2.5*dBToff),(dBTp*(OMFiltrados+1.0))+(1.7*dBToff)},fixedSize=1,size={2*dBTp,0.5*dBTp},title="Variable selection",fSize=FontZ-4,frame=0	//ESP:"Seleccion de variable"
	PopupMenu popSVInfoDisplay,align=1,pos={(3*dBTp)+(3.0*dBToff),(dBTp*(OMFiltrados+1.0))+(3.2*dBToff)},size={dBTp/2,dBTp*2},value=#DisplayModes
	PopupMenu popSVInfoDisplay,mode=1+textOrInfo,proc=VueloStatus_Controls_Pop//,title=""
	PopupMenu popSVInfoDisplay,bodyWidth=(dBTp*3.0+1*dBToff)
	
	//Filtered data: Selection variables
	string varSelHelpStr = "Selection variables. Data inside this range is included in the selection group."//ESP:"Conjunto seleccionado. Datos en este rango se incluyen en el calculo especifico."
	SetVariable svVS0,pos={0.5*dBTp-(1*dBToff),(dBTp*(OMFiltrados+1.5))+(3*dBToff)},size={dBTp*1.5,dBTp/2},title="Low",format="%g"
	SetVariable svVS0,limits={0,9999,1},value=_NUM:Low,proc=VueloStatus_Controls_Var,fSize=fontZ-3,help={varSelhelpStr}
	
	SetVariable svVS3,pos={2.0*dBTp+(0*dBToff),(dBTp*(OMFiltrados+1.5))+(3*dBToff)},size={dBTp*1.5,dBTp/2},title="High",format="%g"
	SetVariable svVS3,limits={1,9999,1},value=_NUM:High,proc=VueloStatus_Controls_Var,fSize=fontZ-3,help={varSelhelpStr}

	//Filtered data: Limits variables
	string varLimHelpStr = "Limit variables. Data outside this range is excluded from general and selection groups."//"Conjunto general. Datos fuera de este rango no se incluyen."
	SetVariable svVS2,pos={0.5*dBTp-(1*dBToff),(dBTp*(OMFiltrados+4.0))+(1*dBToff)},size={dBTp*1.5,dBTp/2},title="Min",format="%g"
	SetVariable svVS2,limits={-9999,9999,1},value=_NUM:MinLow,proc=VueloStatus_Controls_Var,fSize=fontZ-3,help={varLimhelpStr}
	
	SetVariable svVS1,pos={2.0*dBTp+(0*dBToff),(dBTp*(OMFiltrados+4.0))+(1*dBToff)},size={dBTp*1.5,dBTp/2},title="Max",format="%g"
	SetVariable svVS1,limits={-9999,9999,1},value=_NUM:MaxHigh,proc=VueloStatus_Controls_Var,fSize=fontZ-3,help={varLimhelpStr}

	//Filtered data: Sliders
	Slider slVSLow,pos={0.5*dBTp+(0*dBToff),(dBTp*(OMFiltrados+2.0))+(3*dBToff)},size={2/3*dBTp,1.5*dBTp},title="Low"
	Slider slVSLow,limits={MinLow,High,1},vert=1,proc=VueloStatus_Controls_SL,value=Low,focusRing=0,fSize=FontZ-2
	
	Slider slVSHigh,pos={1.5*dBTp+(3*dBToff),(dBTp*(OMFiltrados+2.0))+(3*dBToff)},size={2/3*dBTp,1.5*dBTp},title="High"
	Slider slVSHigh,limits={Low,MaxHigh,1},vert=1,proc=VueloStatus_Controls_SL,value=High,focusRing=0,fSize=FontZ-2 //ticks=8

	//Filtered data: Edit status and Data panel buttons
	Button btVS5,pos={0.0*dBTp+(2.5*dBToff),(dBTp*(OMFiltrados+4.5))+1*dBToff},size={1.5*dBTp,dBTp/2},proc=VueloStatus_Controls_BT,title="Save filters",fSize=fontZ-4,userdata="active 0",focusRing=0 //ESP:"Guardar filtros"
	
	Button btVS6,pos={1.5*dBTp+(2.5*dBToff),(dBTp*(OMFiltrados+4.5))+1*dBToff},size={1.5*dBTp,dBTp/2},proc=VueloStatus_Controls_BT,title="Load filters",fSize=fontZ-4,userdata="active 0",focusRing=0 //ESP:"Cargar filtros"
	
	Button btVSdataPanel,pos={0.5*dBTp+(0*dBToff),(dBTp*(OMFiltrados+5.0))+1*dBToff},size={3*dBTp,dBTp/2},proc=VueloStatus_Controls_BT,title="Data panel",fSize=fontZ,userdata="active 0",focusRing=0 //ESP:"Panel Datos Muestra"
	//

	//Under LB vuelo data selection
	TitleBox tbVS2,pos={4*dBTp+(0*dBToff),(10.5*dBTp)+(0.5*dBToff)},fixedSize=1,size={4.5*dBTp,1.5*dBTp},title="-"
	TitleBox tbVS2,variable=VSmainInfo,fixedSize=1,fSize=FontZ-4
	
	TitleBox tbVS3,pos={4*dBTp+(0*dBToff),(12.0*dBTp)+(0.6*dBToff)},fixedSize=1,size={2*dBTp,0.5*dBTp},title="Flight selection",fSize=FontZ-4,frame=0 //ESP:"Seleccion de vuelos"
	
	
	string VuelosDataModes = "\"" + "1. All flights;2. Valid flights;3. Flights: Day+Night;4. Flights: Day only;5. Flights: Fast decompress."\
	+";6. Flights: Medical;7. Favorite flights;8. Flights: NIRS;9. Color help" + "\""
	//ESP:string VuelosDataModes = "\"" + "1. Todos los vuelos;2. Vuelos validos;3. Vuelos tipo Diur+Noct;4. Vuelos tipo Diurnos;5. Vuelos Descompresion R."\
	//+";6. Vuelos Medicos;7. Vuelos confirmados;8. Vuelos NIRS;9. Clave colores panel" + "\""
	PopupMenu popSVDataModes,align=1,pos={7.0*dBTp+(2.0*dBToff),dBTp*11.5+(4.5*dBToff)},size={dBTp/2,dBTp*2},value=#VuelosDataModes
	PopupMenu popSVDataModes,mode=1,proc=VueloStatus_Controls_Pop//,title=""
	PopupMenu popSVDataModes,bodyWidth=(dBTp*3.0+2*dBToff)
	
	Button btVSox,pos={9*dBTp-(0.5*dBToff),dBTp*10+(3*dBToff)},size={1.0*dBTp,dBTp/2},proc=VueloStatus_Controls_BT,title="SpO2",fSize=fontZ-3,userdata="active 1",fColor=(65535,43688,32768),focusRing=0 //ESP:SpO2"
	
	Button btVShr,pos={9*dBTp-(0.5*dBToff),dBTp*10.5+(3*dBToff)},size={1.0*dBTp,dBTp/2},proc=VueloStatus_Controls_BT,title="HR",fSize=fontZ-3,userdata="active 0",focusRing=0 //ESP:FC
	
	TitleBox tbVS4,pos={8.0*dBTp+(0*dBToff),(12.0*dBTp)+(0.5*dBToff)},fixedSize=1,size={2*dBTp,0.5*dBTp},title="Fav/Excl",fSize=FontZ-4,frame=0 //ESP:"Seleccion de vuelos"
	Button btVSfavorite,pos={7.8*dBTp-(0*dBToff),dBTp*11.5+(4.2*dBToff)},size={0.6*dBTp,0.5*dBTp},proc=VueloStatus_Controls_BT,title="★",fSize=fontZ-1,focusRing=0,help={"Mark data as favorite"}
	Button btVSexclude,pos={8.4*dBTp-(0*dBToff),dBTp*11.5+(4.2*dBToff)},size={0.6*dBTp,0.5*dBTp},proc=VueloStatus_Controls_BT,title="\\Z18×",fSize=fontZ-1,focusRing=0,help={"Exclude data from analysis"}
	Button btVSconfig,pos={9.2*dBTp-(0*dBToff),dBTp*11.5+(4.2*dBToff)},size={0.6*dBTp,0.5*dBTp},proc=VueloStatus_Controls_BT,title="\\Z18⚙️",fSize=fontZ-1,focusRing=0,help={"Handle fav/excl"}
	
	vueloStatus_Panel_MainDisp()
END

//-------------------------------------------------------------------//

//Create or reset filter values. Holds selection of values chosen in VueloStatus Panel
Function/WAVE VueloStatus_Panel_FilterWave([variable saveSets])
	DFREF dfrResource = root:Resources:Oximetry
	
	variable MinLow = 0,Low = 0,High = 800,MaxHigh = 800 //Default values
	variable presetParams = 12 //THIS MUST AGREE WITH VueloStatus_Panel variable
	
	IF(saveSets==1)
		Make/O/N=(5,presetParams,11) dfrResource:VSfilteredVars_saveSets/WAVE=VSfilteredVars
		SetDimLabel 2,0,'DefaultSet',VSfilteredVars
	ELSE
		Make/O/N=(5,presetParams) dfrResource:VSfilteredVars/WAVE=VSfilteredVars
	ENDIF
	
	SetDimLabel 0,0,'MinLow',VSfilteredVars
	SetDimLabel 0,1,'Low',VSfilteredVars
	SetDimLabel 0,2,'High',VSfilteredVars
	SetDimLabel 0,3,'MaxHigh',VSfilteredVars
	SetDimLabel 0,4,'Spec',VSfilteredVars
	VSfilteredVars[0][][0] = MinLow
	VSfilteredVars[1][][0] = Low
	VSfilteredVars[2][][0] = High
	VSfilteredVars[3][][0] = MaxHigh
	VSfilteredVars[4][][0] = 0
	
	SetDimLabel 1,0,'Default',VSfilteredVars
	SetDimLabel 1,1,'Status',VSfilteredVars
	SetDimLabel 1,2,'Nombres',VSfilteredVars
	SetDimLabel 1,3,'TimeDisconnect',VSfilteredVars
	SetDimLabel 1,4,'TimeDesaturation',VSfilteredVars
	SetDimLabel 1,5,'TimeHypoxia',VSfilteredVars
	SetDimLabel 1,6,'TimeLagDesaturationDC',VSfilteredVars
	SetDimLabel 1,7,'TimeLagHypoxiaDC',VSfilteredVars
	SetDimLabel 1,8,'TimeLagDesaturationRC',VSfilteredVars
	SetDimLabel 1,9,'TimeLagHypoxiaRC',VSfilteredVars
	SetDimLabel 1,10,'Age',VSfilteredVars
	SetDimLabel 1,11,'Sex',VSfilteredVars	
	
	//Preset Edad
	VSfilteredVars[0][10][] = 10
	VSfilteredVars[1][10][] = 10
	VSfilteredVars[2][10][] = 100
	VSfilteredVars[3][10][] = 100
	
	//Preset sexo
	VSfilteredVars[0][11][] = 0
	VSfilteredVars[1][11][] = 1 //Male
	VSfilteredVars[2][11][] = 2 //Female
	VSfilteredVars[3][11][] = 3	

	return VSfilteredVars
END

//-------------------------------------------------------------------//

Function/WAVE VueloStatus_Panel_FilterWave_SaveSets([variable load, variable save,string loadName])
	DFREF dfrResource = root:Resources:Oximetry

	wave VSfilteredVars = dfrResource:VSfilteredVars
	IF(!WaveExists(VSfilteredVars))
		wave VSfilteredVars = VueloStatus_Panel_FilterWave()
	ENDIF
	
	wave VSfilteredVarsSets = dfrResource:VSfilteredVars_saveSets
	IF(!WaveExists(VSfilteredVarsSets))
		wave VSfilteredVarsSets = VueloStatus_Panel_FilterWave(saveSets=1)
	ENDIF

	IF(paramIsDefault(loadName))
		loadName = ""
	ENDIF
	
	IF(load>0 && load<=10)
		loadName = getDimLabel(VSfilteredVarsSets,2,load)
		IF(cmpstr(loadName,"")==0)
			loadName = "NONE"
		ENDIF
	
		VSfilteredVars[][][0] = VSfilteredVarsSets[p][q][load]
		printf "[FilterWave_SaveSets] Loading preset #%g, %s\n",load,loadName
	
	ELSEIF(save>0 && save<=10)
		IF(cmpstr(loadName,"")==0)
			loadName = "D" + num2str(save)
		ENDIF
		SetDimLabel 2,save,$(loadName),VSfilteredVarsSets
		
		VSfilteredVarsSets[][][save] = VSfilteredVars[p][q][0]
		printf "[FilterWave_SaveSets] Saving preset #%g as %s\n",save,loadName
	ENDIF
	
	return VSfilteredVars
END

//-------------------------------------------------------------------//

Function/S VueloStatus_Panel_FilterWave_AskSaveSets()

	DFREF dfrResource = root:Resources:Oximetry
	wave VSfilteredVarsSets = dfrResource:VSfilteredVars_saveSets
	IF(!WaveExists(VSfilteredVarsSets))
		wave VSfilteredVarsSets = VueloStatus_Panel_FilterWave(saveSets=1)
	ENDIF
	variable dims = DimSize(VSfilteredVarsSets,2)
	
	string actDimName, actAdd, longAdd = ""
	variable i
	for(i=1;i<dims;i++)
		actDimName = getDimLabel(VSfilteredVarsSets,2,i)
		IF(cmpstr(actDimName,"")==0 || cmpstr(actDimName,"-")==0)
			actDimName = "-"
		ENDIF
		sprintf actAdd,"%g. %s;",i,actDimName
		
		longAdd = longAdd + actAdd
	endfor

	return longAdd
END

//-------------------------------------------------------------------//

//Create or reset panel display
Function vueloStatus_Panel_MainDisp()

	string vuelosStname = "VuelosStatusPanel"
	
	VARIABLE dBTp = 50
	Variable dBToff = 10
	
	//MAIN GRAPH DISPLAY
	variable topDisp = dBTp*10.5+(0.5*dBToff)
	variable leftDisp = dBTp*10
	
	string VSMainDispWin = "VuelosStatusMainDisp"
	
	Display/HOST=$(vuelosStname)/N=$(VSMainDispWin)/W=(leftDisp,topDisp,leftDisp+(dBTp*17.5),topDisp+(dBTp*2.2)) //left top right bottom
	ModifyGraph/W=$(vuelosStname+"#"+VSMainDispWin) frameStyle=1,margin(bottom)=26
	///////

END

//-------------------------------------------------------------------//
//
Function VueloStatus_Panel_CheckVariables()
	//variable ckNombre = 1
	//variable ckEdad = 1
	//variable ckSexo = 1
	//variable ckRango = 1
	
	//CheckBox ckVSnombre,pos={0.5*dBTp-(1*dBToff),dBTp*8.5+2.5*dBToff},size={dBTp/2,dBTp*2},title="Nombre"
	//CheckBox ckVSnombre,proc=VueloStatus_Controls_Ck,value=ckNombre,fSize=FontZ-1
	
	//CheckBox ckVSedad,pos={0.5*dBTp-(1*dBToff),dBTp*9.0+2.5*dBToff},size={dBTp/2,dBTp*2},title="Edad"
	//CheckBox ckVSedad,proc=VueloStatus_Controls_Ck,value=ckEdad,fSize=FontZ-1
	
	//CheckBox ckVSsexo,pos={2.5*dBTp-(2*dBToff),dBTp*8.5+2.5*dBToff},size={dBTp/2,dBTp*2},title="Sexo"
	//CheckBox ckVSsexo,proc=VueloStatus_Controls_Ck,value=ckSexo,fSize=FontZ-1
	
	//CheckBox ckVSrango,pos={2.5*dBTp-(2*dBToff),dBTp*9.0+2.5*dBToff},size={dBTp/2,dBTp*2},title="Rango"
	//CheckBox ckVSrango,proc=VueloStatus_Controls_Ck,value=ckSexo,fSize=FontZ-1
END
		
//-------------------------------------------------------------------//

//IndicePanel checkbox. Contorno, FiringRate
Function VueloStatus_Controls_Ck(ck) : CheckBoxControl
	STRUCT WMCheckboxAction &ck
	Switch(ck.eventCode)
		case 2:
			String ClickedBT = ck.ctrlName
			String WinNm = ck.win
			variable checked = ck.checked
			
			wave VarVS = VueloStatus_PanelChecker() //{popUp,Low,MaxHigh,MinLow,High,sl1,sl2}
				variable InfoDisp = VarVS[0]
				variable Low = VarVS[1]
				variable MaxHigh = VarVS[2]
				variable MinLow = VarVS[3]
				variable High = VarVS[4]
				variable CorteInf = VarVS[5]	
				variable CorteSup = VarVS[6]			
						
			strswitch(ck.ctrlName)
				case "ckVSnombre":	 // 
					print "Name",checked,clickedBT
					break
				case "ckVSedad":	 // 
					print "Age",checked,clickedBT
					break
				case "ckVSsexo":	 // 
					print "Sex",checked,clickedBT
					break										
			endSwitch
			break
	EndSwitch
END

//-------------------------------------------------------------------//

//IndicePanel popUp menus. Catalog,Show,CompCat,CompShow
Function VueloStatus_Controls_Pop(pop) : PopupMenuControl //(ctrlName,popNum,popStr)
	STRUCT WMPopupAction &pop
	switch(pop.eventCode)
		case 2:
			String ctrlName = pop.ctrlname
			Variable popNum = pop.popNum
			String popStr = pop.popStr
			String winNm = pop.win
								
			strswitch(ctrlName)
				case "popSVInfoDisplay": //Pop control for VuelosStatusPanel
					vueloStatus_HandleFilters(InfoDisp=popNum)
					break
				
				case "popSVDataModes": //Pop control for VuelosStatusPanel
					vueloStatus_HandleFilters(VuelosDisp=popNum)
					break	
					
				case "popSDInfoDisplay"://Pop control for VuelosDataPanel
					Reporte_VuelosInfoCompHandle()
					break					

			EndSwitch
			break
	EndSwitch
End


//-------------------------------------------------------------------//

//Botones Panel
Function VueloStatus_Controls_BT(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	switch( ba.eventCode )
		case 1: // mouse dn
			String PanelName = ba.win
			string btPress = ba.ctrlName
									
			StrSwitch(btPress)
				//-------------VuelosStatusPanel-------------
				case "btVSres": // 	Mostrar oxim		
					show_OximPanel(reset=1)
					break
				case "btVS0": // Reporte
					Reporte_Handler()
					
					break
					
				case "btVS1": // Buscar Vuelos
					variable AccionBuscaVuelo
					string AccionBuscaVueloHelp = "1. Search flight in folder;2. Search flight in igor packed experiment;3. Search NIRS flight" //"1. Vuelo en carpeta;2. Vuelo en experimento;3. Vuelo NIRS"
					Prompt AccionBuscaVuelo, "Do: ", popUp AccionBuscaVueloHelp
			
					DoPrompt/HELP=("-") "Search flight: ", AccionBuscaVuelo
					if (V_Flag)
						return -1
					endif
					
					IF(AccionBuscaVuelo==1) //Carpetas
						loadFlight_DataWave(printInfo=1,remakePath=1) 
					ELSEIF(AccionBuscaVuelo==2) //Experimentos
						print "Pendiente..."
					ELSEIF(AccionBuscaVuelo==3) //NIRS
						loadFlight_NIRS(remakePath=1)
					ENDIF
					break
					
				case "btVS2": // Editar vuelos (procesar, eliminar)
					SVAR actvuelo = root:actVuelo
					variable flightNum
					sscanf actVuelo,"Vuelo_%g",flightNum
					
					string flightList = num2str(flightNum) + ";"
					Prompt flightList, "Vuelo: "	
				
					variable AccionVuelo
					string AccionVueloHelp = "1. Process flight;2. Process all flights;3. Process selected list of flights;4. Delete flight"
					//"1. Calcular vuelo;2. Eliminar vuelo;3. Calcular todos los vuelos;4. Calcular conjunto de vuelos seleccionado"
					Prompt AccionVuelo, "Do: ", popUp AccionVueloHelp
			
					DoPrompt/HELP=("-") "Use given flight list to: ", flightList,AccionVuelo
					if (V_Flag)
						return -1
					endif
					
					string firstVuelo = StringFromList(0,flightList,";")
					sprintf actVuelo,"Vuelo_%s",firstVuelo
					
						IF(AccionVuelo==1)
							Flight_CalcAll_Multiple(vueloList=actVuelo)
						ELSEIF(AccionVuelo==2)
							Flight_CalcAll_Multiple(vueloList="",allInRoot=1)
						ELSEIF(AccionVuelo==3)
							Flight_CalcAll_Multiple(vueloList=flightList,allInRoot=2)	
						ELSEIF(AccionVuelo==4)
							loadFlight_DeleteFlight(vueloList=flightList)										
						ENDIF
					
					vueloStatus_HandleFilters()
					break							
					
				case "btVS3": // Cargar vuelos
					loadFlight_handler()	
					break	

				case "btVS4": // Mostrar matriz de resultados  oximetros
					OximToImage_Handler(inType=4,inRemake=1,NormalizeHRbyAge=2,avgErrorType=2)
					break	
					
				case "btVSdataPanel": // Seleccionar data mostrada
					vueloStatus_dataPanel(reset=0) //Open or ToFront
					break	
										
				case "btVS5":
					variable savePS = 1
					string saveName = "D" + num2str(savePS)
					
					string SaveSetHelp = VueloStatus_Panel_FilterWave_AskSaveSets()
					Prompt savePS, "Save preset: ", popUp saveSetHelp
					
					Prompt saveName,"Preset Name: "
								
					DoPrompt/HELP=("-") "Save selected filter values: ", savePS,saveName //"Guardar parametros de filtrado seleccionados: "
						if (V_Flag)
							return -1
						endif
					
					VueloStatus_Panel_FilterWave_SaveSets(save=savePS,loadName=saveName)	//Save filter preset
					break		
					
				case "btVS6":
					SaveSetHelp = VueloStatus_Panel_FilterWave_AskSaveSets() + ";X. Reset"
					Prompt savePS, "Load Preset: ", popUp saveSetHelp //"Cargar preset: "
					DoPrompt/HELP=("-") "Load selected filter values: ", savePS //"Cargar parametros de filtrado seleccionados: "
						if (V_Flag)
							return -1
						endif
					
					savePS = savePS==11 ? -1 : savePS //If X. selected, give value -1 for reset
					vueloStatus_HandleFilters(Stored=savePS)	//Load filter preset
					break										
				
//				case "btVS5": //Confirmar seleccionados
//					Confirmar_TodosVuelos(dataAdd=1,vueloList="")
//					break	
//					
//				case "btVS6": //Resetear seleccionados a original status
//					variable RevOx
//					string RevOxHelp = "1. Rechazar oximetros seleccionados;2. Reiniciar status Oximetros seleccionados"
//					Prompt RevOx, "Accion: ", popUp RevOxHelp
//								
//					DoPrompt/HELP=("-") "Accion a realizar con data seleccionado: ", RevOx
//					if (V_Flag)
//						return -1
//					endif
//					RevOx = RevOx==1 ? -1 : 0
//					Confirmar_TodosVuelos(dataAdd=RevOx,vueloList="")	
//					break	
					
				case "btVSox": //
					ControlInfo/W=$(PanelName) btVSox
					variable btVSoxud = str2num(s_userData[7,inf])
					IF(btVSoxud==0)
						Button btVSox,win=$(PanelName),userdata="active 1",fColor=(65535,43688,32768) //Enable Oximetry rate image
						Button btVShr,win=$(PanelName),userdata="active 0",fColor=(0,0,0)
					ELSE
						//Button btVSox,win=$(PanelName),userdata="active 0",fColor=(0,0,0)
					ENDIF
					OximToImage_Display(displayInVSpanel=1)
					break	
					
				case "btVShr": //
					ControlInfo/W=$(PanelName) btVShr
					variable btVShrud = str2num(s_userData[7,inf])
					IF(btVShrud==0)
						Button btVShr,win=$(PanelName),userdata="active 1",fColor=(65535,43688,32768) //Enable Heart rate image
						Button btVSox,win=$(PanelName),userdata="active 0",fColor=(0,0,0)
					ELSE
						//Button btVShr,win=$(PanelName),userdata="active 0",fColor=(0,0,0)
					ENDIF
					OximToImage_Display(displayInVSpanel=2)			
					break							
								
				//-------------VuelosDataPanel-------------
				case "btVD0": //
					Reporte_VuelosInfoCompHandle() //Just update
					break
				
				case "btVD1": //
					vueloStatus_Panel(resetPanel=0,updateInfo=0)
					break
					
				case "btVD2": //Reset dataPanel
					vueloStatus_dataPanel(reset=1)
					break					
															
			EndSwitch	
		break
	endswitch
	return 0
End			

//-------------------------------------------------------------------//

//VuelosStatusPanel slider for data filtering
Function VueloStatus_Controls_SL(sa) : SliderControl
	STRUCT WMSliderAction &sa
	switch(sa.eventCode)
		case 3:		// Value set by mouse down
		//case 9:		// Value set by dragging mouse or arrow key
		case 4:
			String SliderNm = sa.ctrlName
			String WindowNm = sa.win
			variable valor = sa.curval
					
			strswitch(SliderNm)
				case "slVSLow": // Slider 1 (izq)
					vueloStatus_HandleFilters(Low=valor)
					break
				case "slVSHigh": // Slider 2 (der)
					vueloStatus_HandleFilters(High=valor)
					break
			endswitch
			break
		default:
			break
	endswitch
	return 0
End

//-------------------------------------------------------------------//

//VAR VuelosStatusPanel
Function VueloStatus_Controls_Var(SV) : SetVariableControl
	STRUCT WMSetVariableAction &SV
	switch( SV.eventCode )
		case 1: // mouse up
		case 8: // EndEdit
			Variable Valor = SV.dval
			String PanelName = SV.win
			
			SVAR actvuelo = root:actVuelo
			SVAR actOxim = root:actOxim
				
			StrSwitch(SV.ctrlName)	
				//Arriba	
				case "svVS0": //Low *CorteInf*
					vueloStatus_HandleFilters(Low=valor)
					break	
				case "svVS1": //Max
					vueloStatus_HandleFilters(MaxHigh=valor)
					break	
					
				//Abajo	
				case "svVS2": //Min
					vueloStatus_HandleFilters(MinLow=valor)
					break	
				case "svVS3": //High *CorteSup*
					vueloStatus_HandleFilters(High=valor)
					break	
					
				//VuelosDataPanel
				case "svVDcol": //Column selector for VuelosDataPanel
					Reporte_VuelosInfoCompHandle()
					break																	
			EndSwitch
			break
	endswitch
	return 0
End

//-------------------------------------------------------------------//

//ListBox VueloStatusPanel
Function VueloStatus_Controls_LB(LB) : ListBoxControl
	STRUCT WMListboxAction &LB
	switch( LB.eventCode )
		case 4:
			Wave/T listWave = lb.listWave
			string VSpanelname = lb.win
			
			SVAR actvuelo = root:actVuelo
			SVAR actOxim = root:actOxim
						
			StrSwitch(LB.ctrlName)
				//Panel status
				case "lbVSstatus": //
					vueloStatus_HandleSelected(selRow=lb.row,selCol=lb.col)
					break	
					
				//Panel data
				case "lbVDstatus": //
					vueloStatus_HandleSelected(selRow=lb.row,selCol=lb.col,dataPanel=1)
					break			
							
			EndSwitch
	endswitch
	return 0
END

//-------------------------------------------------------------------//

Function/WAVE VueloStatus_PanelChecker()

	string vuelosStname = "VuelosStatusPanel"
	
	ControlInfo/W=$(vuelosStname) popSVInfoDisplay
	variable popUp = v_value
	
	ControlInfo/W=$(vuelosStname) svVS0
	variable Low = v_value
	
	ControlInfo/W=$(vuelosStname) svVS1
	variable MaxHigh = v_value
	
	ControlInfo/W=$(vuelosStname) svVS2
	variable MinLow = v_value
	
	ControlInfo/W=$(vuelosStname) svVS3
	variable High = v_value	
	
	ControlInfo/W=$(vuelosStname) slVSLow
	variable sl1 = v_value
	
	ControlInfo/W=$(vuelosStname) slVSHigh
	variable sl2 = v_value
	
	ControlInfo/W=$(vuelosStname) popSVDataModes
	variable VueloDt = v_value
	
	ControlInfo/W=$(vuelosStname) btVSox
	variable BTox = str2num(s_userData[7,inf])
			
	ControlInfo/W=$(vuelosStname) btVShr
	variable BThr = str2num(s_userData[7,inf])

	Make/FREE VariablesVS = {popUp,Low,MaxHigh,MinLow,High,sl1,sl2,vueloDt,BTox,BThr}
	return VariablesVS
END

//-------------------------------------------------------------------//

//Administra SetVariable y Sliders de VueloStatusPanel
Function vueloStatus_HandleFilters([VuelosDisp,InfoDisp,Low,MaxHigh,MinLow,High,Stored])
	variable VuelosDisp,InfoDisp, Low, MaxHigh, MinLow, High, Stored

	string PanelName = "VuelosStatusPanel"
	
	DFREF dfrResource = root:Resources:Oximetry
	wave VSfilteredVars = dfrResource:VSfilteredVars
	
	variable MultiFilterNum = 12 //Panel popUp selecting info, last number (multiFilter)
	
	//Get info from panel
	wave VarVS = VueloStatus_PanelChecker() //{popUp,Low,MaxHigh,MinLow,High,sl1,sl2}
	
	variable PanVuelosDisp = VarVS[7]  //Vuelo type selection
	variable PanInfoDisp = VarVS[0]		//Data filter selection
	
	//Check if data selection changed
	IF(ParamIsDefault(VuelosDisp))
		VuelosDisp = PanVuelosDisp
	ENDIF
	
	IF(ParamIsDefault(InfoDisp))
		InfoDisp = PanInfoDisp
	ELSE //Changed info type? update with saved values
		Stored = -2 //Just load from actual VSfilteredVars
	ENDIF	

	//Get values from stored wave				
	IF(Stored>=1 || Stored==-1 || Stored==-2)
		IF(Stored==-1) //Reset values to default
			VueloStatus_Panel_FilterWave()
		ELSEIF(Stored>=1)
			VueloStatus_Panel_FilterWave_SaveSets(load=Stored) //FUNCTION CHANGING VSFiltered by preset selected
		ENDIF
		
		IF(InfoDisp!=MultiFilterNum)
			MinLow = VSfilteredVars[0][InfoDisp]
			Low = VSfilteredVars[1][InfoDisp]
			High = VSfilteredVars[2][InfoDisp]
			MaxHigh = VSfilteredVars[3][InfoDisp]	
		ENDIF
		
	ELSEIF(InfoDisp==MultiFilterNum) //Multi filter, show 0 values
		MinLow = 0;Low = 0
		High = 0;MaxHigh = 0
		
	ELSE
	//Get from function parameters (fill default values with panel data)	
		IF(ParamIsDefault(MinLow))
			MinLow = VarVS[3]
		ENDIF
		
		IF(ParamIsDefault(Low))
			Low = VarVS[1]
		ENDIF
		
		IF(ParamIsDefault(High))
			High = VarVS[4]
		ENDIF
		
		IF(ParamIsDefault(MaxHigh))
			MaxHigh = VarVS[2]
		ENDIF
		
		variable saveValues = 1
	ENDIF
		
	//Check values
	MaxHigh = MaxHigh>MinLow ? MaxHigh : MinLow 	//Max must not be lower than min
	High = MaxHigh>High ? High : MaxHigh 				//Max drags High down
	MinLow = MinLow										//Min is king
	High = High>Low ? High : Low						//High must be at least equal to low
	Low = Low>MinLow ? Low : MinLow		//Low must not be lower than min

	//Save values on wave
	IF(SaveValues==1)
		VSfilteredVars[0][InfoDisp] = MinLow
		VSfilteredVars[1][InfoDisp] = Low
		VSfilteredVars[2][InfoDisp] = High
		VSfilteredVars[3][InfoDisp] = MaxHigh					
	ENDIF

	//Update panel values
	Slider slVSLow,win=$(PanelName),limits={MinLow,High,1},value=Low
	Slider slVSHigh,win=$(PanelName),limits={Low,MaxHigh,1},value=High
	
	SetVariable svVS0,win=$(PanelName),value=_NUM:Low,limits={MinLow,High,1}
	SetVariable svVS1,win=$(PanelName),value=_NUM:MaxHigh
	SetVariable svVS2,win=$(PanelName),value=_NUM:MinLow
	SetVariable svVS3,win=$(PanelName),value=_NUM:High,limits={Low,MaxHigh,1}
		
	vueloStatus_HandleInfoDisplay(VuelosDisp=VuelosDisp,InfoDisp=InfoDisp)
	
	return 0
END

//-------------------------------------------------------------------//

//Funcion que maneja listbox de VuelosStatusPanel. 
Function vueloStatus_HandleInfoDisplay([VuelosDisp,InfoDisp])
	variable VuelosDisp,InfoDisp
	
	DFREF dfrResource = root:Resources:Oximetry
	SVAR VSmainInfo = dfrResource:VSmainInfo
	wave VSfilteredVars = dfrResource:VSfilteredVars
	
	variable MultiFilterNum = 12 //Panel popUp selecting info, last number (multiFilter)
	
	VARIABLE fontZ = 14
	
	IF(VuelosDisp==9)
		wave DefStatusSel = dfrResource:Default_StatusHelpSel
		wave DefStatusCol = dfrResource:Default_Colors
		wave DefStatusHelp = dfrResource:Default_StatusHelp
		ListBox lbVSstatus,listWave=DefStatusHelp,selWave=DefStatusSel,colorWave=DefStatuscol,helpWave=$(""),fSize=fontZ-3
		sprintf VSmainInfo,"Color and status association\n"
		return 0
	ENDIF

	wave/T VStext = dfrResource:VuelosStatus_Text
	wave/T VSInfo = dfrResource:VuelosStatus_Info
	wave VSsel = dfrResource:VuelosStatus_Sel
	wave VScolors = dfrResource:VuelosStatus_Colors
		
	IF(InfoDisp==1 || InfoDisp==2)
		vueloStatus_InfoWave(reCheck=0,conjuntoVuelos=VuelosDisp)
		IF(InfoDisp==1)
			ListBox lbVSstatus,listWave=VStext,selWave=VSsel,colorWave=VScolors,helpWave=VSInfo,fSize=fontZ-3
		ELSEIF(InfoDisp==2)
			ListBox lbVSstatus,listWave=VSInfo,selWave=VSsel,colorWave=VScolors,helpWave=VStext,fSize=fontZ-3
		ENDIF
		
		variable dispDataCount = dimSize(VSsel,0)
	ELSEIF(InfoDisp>=3 && InfoDisp<MultiFilterNum)
		variable OximOrSat = InfoDisp - 3 //0 time, 1 dc, 2 hipox
		
		variable MinLow = VSfilteredVars[0][InfoDisp]
		variable Low = VSfilteredVars[1][InfoDisp]
		variable High = VSfilteredVars[2][InfoDisp]
		variable MaxHigh = VSfilteredVars[3][InfoDisp]
		variable segment = 0	
		
		string VSmainAdd = vueloStatus_InfoWave_Filtered(OximOrSat,Segment,conjuntoVuelos=Vuelosdisp,CorteInferior=Low,CorteSuperior=High,corteMin=MinLow,corteMax=MaxHigh) 
		
		wave/T VSelectText = dfrResource:VuelosSelection_Text
		wave/T VSelectInfo = dfrResource:VuelosSelection_Info
		wave VSelectsel = dfrResource:VuelosSelection_Sel
		wave VSelectcolors = dfrResource:VuelosSelection_Colors
		ListBox lbVSstatus,listWave=VSelectInfo,selWave=VSelectsel,colorWave=VSelectcolors,helpWave=VSelectText,fSize=fontZ-3
		
		dispDataCount = dimSize(VSelectsel,0)
	ELSEIF(InfoDisp==MultiFilterNum) //Multiple Filter
		VSmainAdd = vueloStatus_InfoWave_FilteredMultiple(Segment,conjuntoVuelos=Vuelosdisp) 
		
		wave/T VSelectText = dfrResource:VuelosSelection_Text
		wave/T VSelectInfo = dfrResource:VuelosSelection_Info
		wave VSelectsel = dfrResource:VuelosSelection_Sel
		wave VSelectcolors = dfrResource:VuelosSelection_Colors
		ListBox lbVSstatus,listWave=VSelectInfo,selWave=VSelectsel,colorWave=VSelectcolors,helpWave=VSelectText,fSize=fontZ-3
		
		dispDataCount = dimSize(VSelectsel,0)
	ENDIF
	
	sprintf VSmainInfo,"Shown Flights = %g\n",dispDataCount
	IF(InfoDisp>=3)
		VSmainAdd = replaceString("\nFavorite",VSmainAdd,"; Favorite")
		VSmainAdd = replaceString("\nFiltered",VSmainAdd,"; Filtered")
		VSmainAdd = replaceString("\nExcluded",VSmainAdd,"; Excluded")
		VSmainInfo = VSmainInfo + VSmainAdd
	ENDIF
	
	return 0
END

//-------------------------------------------------------------------//

//
Function vueloStatus_HandleSelected([variable selRow,variable selCol,variable dataPanel])
	SVAR actvuelo = root:actVuelo
	SVAR actOxim = root:actOxim
	
	DFREF dfrResource = root:Resources:Oximetry
	
	string VSpanelname = "VuelosStatusPanel"
	string VDpanelname = "VuelosDataPanel"
	string OximPanelName = "OximPanel"

	IF(dataPanel==0)
		ControlInfo/W=$(VSpanelName) lbVSstatus
	ELSEIF(dataPanel==1)
		ControlInfo/W=$(VDpanelName)	lbVDstatus
	ENDIF
	string listWavePath = S_DataFolder
	string listWaveName = S_Value
	
	wave/T listWave = $(listWavePath + listWaveName)
	Variable listWaveRows = dimSize(listWave,0)
	
	IF(cmpStr(listWaveName,"Default_StatusHelp")==0)
		return 0
	ENDIF

	//Find selected vuelo and oximeter
	IF(paramIsDefault(selRow) && paramIsDefault(selCol))
		//Use existing actVuelo and actOxim
	ELSEIF(dataPanel==0) //Clicked on VuelosStatusPanel
		IF(selRow>=listWaveRows || selRow==-1)
			return 0
		ENDIF
		IF(selCol==0)
			selCol+=1
		ENDIF

		actVuelo = getDimLabel(listWave,0,selRow)
		actOxim = getDimLabel(listWave,1,selCol)
	ELSEIF(dataPanel==1) //Clicked on VuelosDataPanel
		IF(selRow>=listWaveRows || selRow==-1)
			return 0
		ENDIF
		
		string vueloOxim = getDimLabel(listWave,0,selRow)
		variable vueloNum,oximNum
		sscanf vueloOxim,"Vuelo_%g_Oxim_%g",vueloNum,oximNum
		actVuelo = "Vuelo_"+num2str(vueloNum)
		actOxim = "Oxim_"+num2str(oximNum)
	ENDIF

	DFREF dfrVu = root:$(actVuelo)
	
	//Handle VuelosStatusPanel
	DoWindow/HIDE=? $(VSpanelname) 
	Variable VueloStatusPanelExists = V_flag	
	IF(VueloStatusPanelExists==1)
		Wave VSpanelVars = VueloStatus_PanelChecker()
		variable InfoDisp = VSpanelVars[0]
		
		SVAR VStipoVuelo = dfrResource:VStipoVuelo
		SVAR/Z tipovuelo = dfrVu:s_tipodeVuelo
		IF(SVAR_Exists(tipoVuelo))
			VStipoVuelo = tipoVuelo 
		ELSE
			VStipoVuelo = "-"
		ENDIF
	
		SVAR VSorigExpNm = dfrResource:VSorigExpNm
		SVAR/Z origExpNm = dfrVu:OrigExpName
		IF(SVAR_Exists(OrigExpNm))
			VSorigExpNm = origExpNm
		ELSE
			VSorigExpNm = "-"
		ENDIF	
		
		//Update status on selection
		IF(dataPanel==1) //If clicked on VData panel, Update VStatus panel
			IF(InfoDisp==1 || InfoDisp==2)
				Wave VStatusSel = dfrResource:VuelosStatus_Sel
				variable update_vueloRow = findDimLabel(VStatusSel,0,actVuelo)
				variable update_oximCol = findDimLabel(VStatusSel,1,actOxim)			
				IF(update_vueloRow>=0 && update_oximCol>=0)
					VStatusSel[][][0] = 0
					VStatusSel[update_vueloRow][update_oximCol][0] = 1
					
					//variable DataStatus = VStatusSel[update_vueloRow][update_oximCol][1]
				ENDIF
			ELSE
				Wave VSelectionSel = dfrResource:VuelosSelection_Sel
				update_vueloRow = findDimLabel(VSelectionSel,0,actVuelo)
				update_oximCol = findDimLabel(VSelectionSel,1,actOxim)
				IF(update_vueloRow>=0 && update_oximCol>=0)	
					VSelectionSel[][][0] = 0
					VSelectionSel[update_vueloRow][update_oximCol][0] = 1
					
					//variable DataSelection = VSelectionSel[update_vueloRowSel][update_oximColSel][1]
				ENDIF	
			ENDIF
			IF(update_VueloRow!=-2)
				ListBox lbVSstatus,win=$(VSPanelName),row=update_vueloRow
			ENDIF
		ENDIF
		
		variable displayInVSpanel = VSpanelVars[8]==1 ? 1 : 2
		OximToImage_Display(displayInVSpanel=displayInVSpanel)
	ENDIF	
	
	//Handle VuelosDataPanel
	DoWindow/HIDE=? $(VDpanelname) 
	Variable VueloDataPanelExists = V_flag	
	IF(VueloDataPanelExists==1)
		DFREF dfrAVD = root:AllVueloData
		DFREF dfrAVDCmp = dfrAVD:VueloCompilate
		wave VuelosSelWave = dfrAVDCmp:Reporte_VuelosConexionTimes_Sel
	
		vueloOxim = actVuelo + "_" + actOxim
		variable vueloOximRow = findDimLabel(VuelosSelWave, 0, vueloOxim)
		IF(vueloOximRow>=0)
			VuelosSelWave[][][0] = 0
			VuelosSelWave[vueloOximRow][0][0] = 1
		ENDIF
	ENDIF		

	//Handle oximPanel
	DoWindow/HIDE=? $(OximPanelName) 
	Variable OximPanelExists = V_flag
	IF(OximPanelExists==1)
		string oximListMatch = replaceString("_",actOxim," ")
		PoPupMenu popupOPox,popMatch=oximListMatch,win=$(OximpanelName)
		
		sscanf actVuelo,"Vuelo_%g",vueloNum
		SetVariable svOPvue,value=_NUM:vueloNum,win=$(OximpanelName)
		
		sscanf oximListMatch,"Oxim %g",oximNum
		SetVariable svOPox,value=_NUM:oximNum,win=$(OximpanelName) //Set variable and let func handle
	
		show_OximPanel_VueloOximHandler()
	ENDIF

END

//-------------------------------------------------------------------//

//////////////////////////////////////////////////////////////////////////////////////////////////////
//03//**DATA STATUS**/////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
Function A3DataStatus()
END
//-------------------------------------------------------------------//

Function Confirmar_TodosVuelos([variable dataAdd,string vueloList])

	SVAR actvuelo = root:actVuelo
	SVAR actOxim = root:actOxim
	
	string saveVuelo = actVuelo
	string saveOxim = actOxim

	IF(!ParamIsDefault(vueloList) && cmpstr(vueloList,"")!=0 && cmpstr(vueloList,"All")!=0) //Valid vueloList
		variable vueloCount = itemsInList(vueloList,",")
		variable useList = 1
	ELSE //Use all available flights from found folders
		DFREF dfrResource = root:Resources:Oximetry
		WAVE VuelosStatus = dfrResource:VuelosStatus
		vueloCount = dimSize(VuelosStatus,0)
		useList = 0
	ENDIF
	
	variable i,j
	FOR(i=0;i<vueloCount;i++)
		IF(useList==1)
			string actVueloStr = stringFromList(i,vueloList,",")
			sprintf actVueloStr,"Vuelo_%s",actVueloStr
		ELSE
			actVueloStr = getDimLabel(VuelosStatus,0,i)
		ENDIF
		actvuelo = actVueloStr
		
		Confirmar_Vuelo(dataAdd=dataAdd,filteredData=1)
	ENDFOR

	actvuelo = saveVuelo //Return global strings to saved vuelo selection
	actOxim = saveOxim
END

//-------------------------------------------------------------------//

//Call confirmar_oximetro for all oximeters on vuelo
Function Confirmar_Vuelo([variable dataAdd,variable oxim,variable filteredData])
	SVAR actvuelo = root:actVuelo
	SVAR actOxim = root:actOxim

	DFREF dfrResource = root:Resources:Oximetry
	NVAR gOximIni = dfrResource:OximIni
	NVAR gOximFin = dfrResource:OximLast
	IF(oxim<=0)
		variable OximIni = gOximIni
		variable OximFin = gOximFin
	ELSE
		OximIni = Oxim
		gOximFin = Oxim	
	ENDIF
	
	wave VuelosStatus = dfrResource:VuelosStatus
	wave VuelosSelection = dfrResource:VuelosSelection_Sel
	IF(!WaveExists(VuelosSelection))
		print "[Confirmar_Vuelo] VuelosSelection wave not found"
		return 0
	ENDIF
	
	variable VuelodimPos = findDimLabel(VuelosSelection,0,actVuelo)
	IF(VuelodimPos==-2)
		print "[Confirmar_Vuelo] Data not found"
		return 0
	ENDIF
	variable ox
	for(ox=OximIni;ox<=OximFin;ox++)
		sprintf actOxim,"Oxim_%g",ox
		variable VueloOxdimPos = findDimLabel(VuelosSelection,1,actOxim)
		variable actStatus = VuelosSelection[VuelodimPos][VueloOxdimPos][1]
		IF(actStatus!=3)
			Confirmar_Oximetro(dataAdd=dataAdd)
		ENDIF
//		IF(filteredData==0)
//			IF(dataAdd==0)
//				Confirmar_Oximetro(dataAdd=dataAdd)
//			ELSEIF(actStatus==1 || actStatus==2 || actStatus==-1) //Completo, confirmado, incompleto
//				Confirmar_Oximetro(dataAdd=dataAdd)
//			ENDIF
//		ELSEIF(filteredData==1)
//			variable actSelection = VuelosSelection[VuelodimPos][VueloOxdimPos+1][1]
//			IF(actSelection==1 && dataAdd==0)
//				Confirmar_Oximetro(dataAdd=dataAdd)
//			ELSEIF(actSelection==1 && (actStatus==1 || actStatus==2 || actStatus==-1)) //Completo, confirmado, incompleto
//				Confirmar_Oximetro(dataAdd=dataAdd)
//			ENDIF
//		ENDIF
	endfor
END

//-------------------------------------------------------------------//

//dataAdd = 1 agrega o quita data en ConfirmedOxims wave
//dataAdd = 0 solo retorna status
Function Confirmar_Oximetro([variable dataAdd])
	SVAR actvuelo = root:actVuelo
	SVAR actOxim = root:actOxim
	variable actOxNum
	sscanf actOxim,"Oxim_%g",actOxNum
	
	DFREF dfrVuelo = root:$(actVuelo)
	DFREF dfrOx = dfrVuelo:$(actOxim)

	
	DFREF dfrResource = root:Resources:Oximetry
	
	//wave DefaultHelp = dfrResource:Default_StatusHelp
	//wave VuelosStatus = dfrResource:VuelosStatus
	wave/T VuelosStatus_Text = dfrResource:VuelosStatus_text
	wave VuelosStatus_Sel = dfrResource:VuelosStatus_sel
	
	wave VuelosSelection_Sel = dfrResource:VuelosSelection_sel
	wave/T VuelosSelection_Text = dfrResource:VuelosSelection_text
	
	variable VuelodimPos = findDimLabel(VuelosStatus_Sel,0,actVuelo)
	variable VueloOxdimPos = findDimLabel(VuelosStatus_Sel,1,actOxim)
	IF(VuelodimPos==-2 || VueloOxdimPos==-2)
		print "[Confirmar_Oximetro] Data not found"
		return 0
	ENDIF
	variable VuelodimPosSel = findDimLabel(VuelosSelection_Sel,0,actVuelo)
	variable VueloOxdimPosSel = findDimLabel(VuelosSelection_Sel,1,actOxim)
	IF(VuelodimPos==-2 || VueloOxdimPos==-2)
		print "[Confirmar_Oximetro] Data not found"
		return 0
	ENDIF	
	
	variable prevStat = VuelosStatus_Sel[VuelodimPos][VueloOxdimPos][1]
	
	IF(dataAdd==0)
		return prevStat
	ELSEIF(dataAdd==-1) //revisar oxim
		printf "Exluded %s from %s. Previous status: %g\n",actOxim,actVuelo,prevStat
		
		//VuelosStatus[VuelodimPos][VueloOxdimPos] = -3
		VuelosStatus_Text[VuelodimPos][VueloOxdimPos] = "Excluded"
		VuelosStatus_Sel[VuelodimPos][VueloOxdimPos][1] = 5
		VuelosSelection_Text[VuelodimPosSel][VueloOxdimPos] = "Excluded"
		VuelosSelection_Sel[VuelodimPosSel][VueloOxdimPos][1] = 5	
		return -3
	ELSEIF(dataAdd==1)
		printf "Favorited %s from %s. Previous status: %g\n",actOxim,actVuelo,prevStat
		
		//VuelosStatus[VuelodimPos][VueloOxdimPos] = 2
		VuelosStatus_Text[VuelodimPos][VueloOxdimPos] = "Favorite"
		VuelosStatus_Sel[VuelodimPos][VueloOxdimPos][1] = 4
		VuelosSelection_Text[VuelodimPosSel][VueloOxdimPos] = "Favorite"
		VuelosSelection_Sel[VuelodimPosSel][VueloOxdimPos][1] = 4		
		
		//DATA WAVE WITH COMPILATE OF INFO
		//Confirmar_TablaCompilado()
		return 2 //Confirmed
	ENDIF	
END

//-------------------------------------------------------------------//

Function Confirmar_TablaCompilado_Handler([variable InfoDisp,variable conjuntoVuelos])
	SVAR actvuelo = root:actVuelo
	SVAR actOxim = root:actOxim

	DFREF dfrResource = root:Resources:Oximetry
	DFREF dfrAVD = root:AllVueloData
	DFREF dfrAVDCmp = dfrAVD:VueloCompilate	
	
	IF(conjuntoVuelos==0 || conjuntoVuelos==1)
		wave VuelosStatus = dfrResource:VuelosStatus
	ELSEIF(conjuntoVuelos>=2)
		vueloStatus_CleanInfoWave(CleanKey=conjuntoVuelos)
		wave VuelosStatus = dfrResource:VuelosStatus_Clean
	ENDIF

	variable vuelosRows = dimSize(vuelosStatus,0)
	variable vuelosCols = dimSize(vuelosStatus,1)
	
	IF(InfoDisp==0)
		variable noFilter = 1
	ELSEIF(InfoDisp==1 || InfoDisp==2)
		wave VuelosSelection = dfrResource:VuelosStatus_Sel
		noFilter = 1
	ELSE
		wave VuelosSelection = dfrResource:VuelosSelection_Sel
		noFilter = 0 //FILTER!
	ENDIF
	
	Confirmar_TablaCompilado(blank=1)
	
	variable i,j
	FOR(i=0;i<vuelosRows;i++)
		string actVueloStr = getDimLabel(VuelosStatus,0,i)
		actvuelo = actVueloStr
		DFREF dfrVuelo = root:$(actVuelo)
		
		variable VuelodimPos = findDimLabel(VuelosSelection,0,actVuelo)
		for(j=1;j<vuelosCols;j++)
			string actOximStr = getDimLabel(vuelosStatus,1,j)
			actOxim = actOximStr
			
			variable VueloOxdimPos = findDimLabel(VuelosSelection,1,actOxim)
			variable actStatus = VuelosSelection[VuelodimPos][VueloOxdimPos][1]
			
			IF((noFilter==0 && actStatus==1) || noFilter==1)
				Confirmar_TablaCompilado()
			ENDIF
		endfor
	ENDFOR
END



Function Confirmar_TablaCompilado([variable blank])
	SVAR actvuelo = root:actVuelo
	SVAR actOxim = root:actOxim
	variable actOxNum
	sscanf actOxim,"Oxim_%g",actOxNum	
	
	DFREF dfrVuelo = root:$(actVuelo)
	DFREF dfrOx = dfrVuelo:$(actOxim)
	DFREF dfrAVD = root:AllVueloData
	
	variable numSegments = 9
	
	//DATA WAVE WITH COMPILATE OF INFO
	wave/Z ConfirmedOximsSat = dfrAVD:ConfirmedOximsSat
	wave/Z ConfirmedOximsCard = dfrAVD:ConfirmedOximsCard
	IF(!waveExists(ConfirmedOximsSat) || !waveExists(ConfirmedOximsCard) || blank==1)
		Make/O/N=(0,5*numSegments) dfrAVD:ConfirmedOximsSat/WAVE=ConfirmedOximsSat
		Make/O/N=(0,5*numSegments) dfrAVD:ConfirmedOximsCard/WAVE=ConfirmedOximsCard
		
		variable segment
		for(segment=1;segment<=numSegments;segment++)
			variable segmentX = ((segment-1)*5)+1
			SetDimLabel 1,(segmentX-1),$("S"+num2str(segment)+"_in"),ConfirmedOximsSat,ConfirmedOximsCard
			SetDimLabel 1,(segmentX+0),$("S"+num2str(segment)+"_out"),ConfirmedOximsSat,ConfirmedOximsCard
			SetDimLabel 1,(segmentX+1),$("S"+num2str(segment)+"_dur"),ConfirmedOximsSat,ConfirmedOximsCard
			SetDimLabel 1,(segmentX+2),$("S"+num2str(segment)+"_q"),ConfirmedOximsSat,ConfirmedOximsCard
			SetDimLabel 1,(segmentX+3),$("S"+num2str(segment)+"_m"),ConfirmedOximsSat,ConfirmedOximsCard
		endfor
		if(blank==1)
			return 0
		endif
	ENDIF
	
	string fullIDoxim = actVuelo + "_" + actOxim
	variable COdimPos = findDimLabel(ConfirmedOximsSat,0,fullIDoxim)
	IF(COdimPos==-2) //Not found?
		variable COSize = dimSize(ConfirmedOximsSat,0)
		InsertPoints/M=0 COSize, 1, ConfirmedOximsSat, ConfirmedOximsCard
		SetDimLabel 0,COSize,$fullIDoxim,ConfirmedOximsSat, ConfirmedOximsCard
		COdimPos = COSize
	ENDIF
	
	Wave Oxim_ConexionTimes = dfrVuelo:Oxim_ConexionTimes
	
	Wave Oxim_DesaturationLag = dfrVuelo:Oxim_DesaturationLag
	Wave Oxim_DesaturationTimes = dfrVuelo:Oxim_DesaturationTimes
	
	Wave Oxim_SegmentData = dfrVuelo:Oxim_SegmentData
	Wave Oxim_SegmentFitCoefs = dfrVuelo:Oxim_SegmentFitCoefs
	
	Wave AllSegmentTimes = dfrOx:AllSegmentTimes
	IF(WaveExists(AllSegmentTimes))
		for(segment=1;segment<=numSegments;segment++)
			segmentX = ((segment-1)*5)+1
			variable segIn = AllSegmentTimes[segment-1][0]
			variable segOut = AllSegmentTimes[segment-1][1]
				
			ConfirmedOximsSat[COdimPos][segmentX-1] = segIn
			ConfirmedOximsCard[COdimPos][segmentX-1] = segIn
			
			ConfirmedOximsSat[COdimPos][segmentX+0] = segOut
			ConfirmedOximsCard[COdimPos][segmentX+0] = segOut
			
			ConfirmedOximsSat[COdimPos][segmentX+1] = segOut - segIn
			ConfirmedOximsCard[COdimPos][segmentX+1] = segOut - segIn
			
			ConfirmedOximsSat[COdimPos][segmentX+2] = Oxim_SegmentFitCoefs[actOxNum-1][0][segment-1] //o2 base
			ConfirmedOximsSat[COdimPos][segmentX+3] = Oxim_SegmentFitCoefs[actOxNum-1][1][segment-1] //o2 pendiente
			
			ConfirmedOximsCard[COdimPos][segmentX+2] = Oxim_SegmentFitCoefs[actOxNum-1][4][segment-1] //hr base
			ConfirmedOximsCard[COdimPos][segmentX+3] = Oxim_SegmentFitCoefs[actOxNum-1][5][segment-1] //hr pendiente
		endfor
	ELSE
		ConfirmedOximsSat[COdimPos][] = 0
		ConfirmedOximsCard[COdimPos][] = 0
	ENDIF
END

//-------------------------------------------------------------------//

Function vueloStatus_CleanInfoWave([variable CleanKey])
	DFREF dfrResource = root:Resources:Oximetry
	
	wave VuelosStatusMain = dfrResource:VuelosStatus
	
	Duplicate/O VuelosStatusMain,dfrResource:VuelosStatus_Clean/WAVE=VuelosStatus
	
	variable vuelosRows = dimSize(vuelosStatus,0)
	variable vuelosCols = dimSize(vuelosStatus,1)
	variable i,j,deletedNum
	
	for(i=0;i<vuelosRows;i++)
		string actVuelo = getDimLabel(VuelosStatus,0,i-deletedNum)
		
		variable actVueloType = VuelosStatus[i-deletedNum][0]
		variable someData = 0
		
		IF(CleanKey==0 || CleanKey==2) //Vuelos validos
			for(j=1;j<vuelosCols;j++)
				variable actSel = VuelosStatus[i-deletedNum][j]
				IF(actSel==1 || actSel==2 || actSel==-1) //Completo, selected, o incompleto
					someData = 1
					break
				ENDIF
			endfor
		ELSEIF(CleanKey>=3 && CleanKey<=6) //3, 4, 5, 6
			IF(actVueloType>=10 && actVueloType==(CleanKey+8)) //10: -,11: D+N; 12: D, 13: DCr, 14:Medic
				someData = 1
			ENDIF
		ELSEIF(CleanKey==7) //Vuelos with confirmed data
			for(j=1;j<vuelosCols;j++)
				actSel = VuelosStatus[i-deletedNum][j]
				IF(actSel==4) //Completo, selected, o incompleto
					someData = 1
					break
				ENDIF
			endfor
		ENDIF
		
		IF(someData==0)
			deletePoints/M=0 i-deletedNum,1,VuelosStatus
			deletedNum +=1
		ENDIF
	endfor
		
	//vueloStatus_InfoWave(reCheck=0,conjuntoVuelos=0)
END

//-------------------------------------------------------------------//

//Select info wave and color wave
Function vueloStatus_InfoWave([variable reCheck,variable conjuntoVuelos])
	DFREF dfrResource = root:Resources:Oximetry

	NVAR OximIni = dfrResource:OximIni
	NVAR OximFin = dfrResource:OximLast
	
	IF(reCheck)
		loadFlight_CheckFolder(reCheck=reCheck) //Search root for loaded Vuelo_XXX folders. Update VuelosStatus
	ENDIF
	
	IF(conjuntoVuelos==0 || conjuntoVuelos==1)
		wave VuelosStatus = dfrResource:VuelosStatus
	ELSEIF(conjuntoVuelos>=2)
		vueloStatus_CleanInfoWave(CleanKey=conjuntoVuelos)
		wave VuelosStatus = dfrResource:VuelosStatus_Clean
	ENDIF
	variable vuelosRows = dimSize(vuelosStatus,0)
	variable vuelosCols = dimSize(vuelosStatus,1)
	
	IF(WaveExists(VuelosStatus) && (VuelosRows==0 || VuelosCols==0))
		VuelosRows = 1
		VuelosCols = 1
		variable noDataBlank = 1
	ENDIF
		
	Make/O/T/N=(vuelosRows,vuelosCols) dfrResource:VuelosStatus_Text/WAVE=VuelosStatus_Text = "" //Status (Complete, incomplete, not found, other type)
	Make/O/T/N=(vuelosRows,vuelosCols) dfrResource:VuelosStatus_Info/WAVE=VuelosStatus_Info = "" //Info (Name (sex), age)
	Make/O/N=(vuelosRows,vuelosCols,2)/B/U dfrResource:VuelosStatus_Sel/WAVE=VuelosStatus_Sel = 0 //Selection wave
	
	copyDimLabels VuelosStatus,VuelosStatus_Text
	copyDimLabels VuelosStatus,VuelosStatus_Info
	copyDimLabels VuelosStatus,VuelosStatus_Sel
	SetDimLabel 2,1,backColors,VuelosStatus_Sel
	
	IF(noDataBlank==1)
		VuelosStatus_Info[0][0] = "No data"
		VuelosStatus_Text[0][0] = "No data"
		return 0
	ENDIF
	
	wave Default_Colors = dfrResource:Default_Colors
	Duplicate/O Default_Colors,dfrResource:VuelosStatus_Colors/WAVE=VuelosStatus_Colors
	
	Make/FREE/N=(7)/T SelVueloTypeNm = {"-","Diurno+Noct","S.Diurno","Descompresion","Medico"}
	Make/FREE/N=(7)/T SelTextIndicators = {"Unprocessed","Processed","MissingData","NotFound","Favorite","Excluded","Other"}
	
	variable i,j
	for(i=0;i<vuelosrows;i++)
		string actVuelo = getDimLabel(vuelosStatus,0,i)
		variable vueloTypeStatus = vuelosStatus[i][0]<10 ? 10 : vuelosStatus[i][0]
		VuelosStatus_Info[i][0] = actVuelo
		VuelosStatus_Sel[i][0][1] = vueloTypeStatus
		VuelosStatus_Text[i][0] = SelVueloTypeNm[(vueloTypeStatus-10)]
		
		for(j=1;j<vuelosCols;j++)
			string actOxim = getDimLabel(vuelosStatus,1,j)
			variable actStatus = vuelosStatus[i][j]
			
			variable corrStatus
			switch (actStatus)
				case 0:
						corrStatus = 0		// "No procesado"
					break
				case 1:
						corrStatus = 1		// "Completo"		
					break
				case -1:
						corrStatus = 2		// "InCompleto"			
					break
				case -2:
						corrStatus = 3		// "No encontrado"			
					break
				case 2:
						corrStatus = 4		// "Seleccionado"		
					break					
				case -3:
						corrStatus = 5		// "Revisar"	
					break
				case -4:
						corrStatus = 6		// "Otro tipo"		
					break					
			endSwitch
			
			DFREF dfrVuelo = root:$(actVuelo)
			DFREF dfrOx = dfrVuelo:$(actOxim)
			
			SVAR Nombre = dfrOx:s_apellidoP
			NVAR Edad = dfrOx:v_edad
			SVAR Sexo = dfrOx:s_sexo
			SVAR Rango = dfrOx:s_rango
	
			string OximInfoText = ""
			IF(cmpstr(Nombre,"")==0)
				OximInfoText = "-"
			ELSE
				sprintf oximInfoText,"%s (%s), %g",Nombre,sexo,edad
			ENDIF
			
			VuelosStatus_Sel[i][j][1] = corrStatus
			
			VuelosStatus_Text[i][j] = SelTextIndicators[corrStatus]
							
			VuelosStatus_Info[i][j] = OximInfoText
			
		endfor
	endfor	
END

//-------------------------------------------------------------------//

Function/S vueloStatus_InfoWave_Filtered(variable oximOrSat,variable DesconexionNum,[variable conjuntoVuelos,variable corteInferior,variable corteSuperior,variable corteMin,variable corteMax,variable colDato])
	
	DFREF dfrResource = root:Resources:Oximetry
	IF(DataFolderRefStatus(dfrResource)==0)
		Init_Globals()
		DFREF dfrResource = root:Resources:Oximetry
	ENDIF
	NVAR OximIni = dfrResource:OximIni
	NVAR OximFin = dfrResource:OximLast
	
	variable OximInstruct = 11 //>11
	
	IF(conjuntoVuelos==0 || conjuntoVuelos==1)
		wave VuelosStatus = dfrResource:VuelosStatus
		
	ELSEIF(conjuntoVuelos>=2)
		vueloStatus_CleanInfoWave(CleanKey=conjuntoVuelos)
		wave VuelosStatus = dfrResource:VuelosStatus_Clean	
	ENDIF
	
	variable vuelosRows = dimSize(vuelosStatus,0)
	variable vuelosCols = dimSize(vuelosStatus,1)
	
	IF(WaveExists(VuelosStatus) && (VuelosRows==0 || VuelosCols==0))
		VuelosRows = 1
		VuelosCols = 1
		variable noDataBlank = 1
	ENDIF
	
	//Make panel LB display waves
	Make/O/T/N=(vuelosRows,vuelosCols) dfrResource:VuelosSelection_Text/WAVE=VuelosSelection_Text = ""
	Make/O/T/N=(vuelosRows,vuelosCols) dfrResource:VuelosSelection_Info/WAvE=VuelosSelection_Info = ""
	Make/O/N=(vuelosRows,vuelosCols,2)/B/U dfrResource:VuelosSelection_Sel/WAVE=VuelosSelection_Sel = 0

	copyDimLabels VuelosStatus,VuelosSelection_Text
	copyDimLabels VuelosStatus,VuelosSelection_Info
	copyDimLabels VuelosStatus,VuelosSelection_Sel
	SetDimLabel 2,1,backColors,VuelosSelection_Sel //**Req. for color display
	
	wave Default_Colors = dfrResource:Default_Colors
	Duplicate/O Default_Colors,dfrResource:VuelosSelection_Colors/WAVE=VuelosSelection_Colors
	
	IF(noDataBlank==1)
		VuelosSelection_Info[0][0] = "No data"
		VuelosSelection_Text[0][0] = "No data"
		return ""
	ENDIF
	
	DesconexionNum = DesconexionNum==0 ? 1 : DesconexionNum
	variable sel1 = DesconexionNum==1 ? 0 : 3
	variable sel2 = DesconexionNum==1 ? 1 : 4
	variable sel3 = DesconexionNum==1 ? 2 : 5
	
	Make/FREE/N=(5)/T SelVueloTypeNm = {"-","Diurno+Noct","S.Diurno","Descompresion","Medico"}
	Make/FREE/N=(7)/T SelTextIndicators = {"Unselected","Selected","Out of max range","Filtered","Favorite","Excluded","Out of min range"}
	Make/FREE/N=(7) SelCounters = 0
	
	variable i,j
	for(i=0;i<vuelosrows;i++)
		string actVuelo = getDimLabel(vuelosStatus,0,i)
		variable vueloTypeStatus = vuelosStatus[i][0]<10 ? 10 : vuelosStatus[i][0]
		
		VuelosSelection_Sel[i][0][1] = vueloTypeStatus
		VuelosSelection_Text[i][0] = SelVueloTypeNm[(vueloTypeStatus-10)]
		VuelosSelection_Info[i][0] = actVuelo
		
			DFREF dfrVuelo = root:$(actVuelo)

			Wave Oxim_ConexionTimes = dfrVuelo:Oxim_ConexionTimes
			
			Wave Oxim_DesaturationTimes = dfrVuelo:Oxim_DesaturationTimes
			Wave Oxim_DesaturationLag = dfrVuelo:Oxim_DesaturationLag
			
			Wave Oxim_HipoxiaTimes = dfrVuelo:Oxim_HipoxiaTimes	
			Wave Oxim_HipoxiaLag = dfrVuelo:Oxim_HipoxiaLag
			
			IF(oximOrSat==0) //Align to oximeter conexion
				wave selWave  = Oxim_ConexionTimes
				colDato = 2
			ELSEIF(oximOrSat==1)
				wave selWave  = Oxim_DesaturationTimes
				colDato = 2
			ELSEIF(oximOrSat==2)
				wave selWave  = Oxim_HipoxiaTimes
				colDato = 2
			ELSEIF(oximOrSat==3)
				wave selWave  = Oxim_DesaturationLag //DC->97%
				colDato = 0
			ELSEIF(oximOrSat==4)
				wave selWave  = Oxim_HipoxiaLag	 //DC->89%
				colDato = 0
			ELSEIF(oximOrSat==5)
				wave selWave  = Oxim_HipoxiaLag	 //RC->89%
				colDato = 1	
			ELSEIF(oximOrSat==6)
				wave selWave  = Oxim_DesaturationLag //RC->97%
				colDato = 1
			ELSEIF(oximOrSat==7 || oximOrSat==8) //Edad / sexo
				wave selWave = $("")
			ENDIF
			
			IF(!waveExists(selWave))
				variable selWaveMissing = 1
			ELSE
				selWaveMissing = 0
			ENDIF
		
		for(j=1;j<vuelosCols;j++)
			string actOxim = getDimLabel(vuelosStatus,1,j)
			
			variable actProcStatus = vuelosStatus[i][j]
			
			DFREF dfrOx = dfrVuelo:$(actOxim)
			variable ox = 0
			sscanf actOxim,"Oxim_%g",Ox
			
			ox = ox - 1 //Selwaves don't have vuelo column
			
			SVAR Nombre = dfrOx:s_apellidoP
			string checkNombre = "-"
			IF(cmpstr(Nombre,"")!=0)
				checkNombre = Nombre
			ENDIF
			SVAR Sexo = dfrOx:s_sexo
			SVAR Rango = dfrOx:s_rango
			NVAR Edad = dfrOx:v_edad
						
			//Select data for each oximeter
			IF(OximOrSat>=0 && OximOrSat<=6)
				IF(selWaveMissing==0)
					variable ex1 = selWave[ox][sel1]
					variable ex2 = selWave[ox][sel2]
					variable ex3 = selWave[ox][sel3]
					
					variable dato = selWave[ox][colDato]
				ELSE
					dato = NaN
				ENDIF
			ELSEIF(OximOrSat==7 || OximOrSat==8)
				IF(OximOrSat==7 && Nvar_Exists(Edad) && Edad!=0)
					dato = Edad
				ELSEIF(OximOrSat==8 && Svar_Exists(Sexo) && cmpstr(Sexo,"")!=0)
					IF(cmpstr(Sexo,"M")==0)
						dato = 1
					ELSEIF(cmpstr(Sexo,"F")==0)
						dato = 2
					ELSE
						dato = NaN
					ENDIF
				ELSE
					dato = NaN
				ENDIF
			ELSEIF(OximOrSat==9)
				dato = NaN
			ENDIF
			
			IF(ox+1>=OximInstruct)
				dato = NaN
			ENDIF

			//Evaulate if data is between selected range
			variable actStatus = 0 //{"No Seleccionado","Seleccionado","Fuera de rango","Filtrado","Confirmado","Rechazado","Fuera rango min"}
			IF(dato==0 || numtype(dato)==2) //Filtrado
				actStatus = 3 //Filtrado
			ELSEIF((dato<=CorteMin || dato>=CorteMax) && (CorteMin!=0 || CorteMax!=0)) 
				IF(dato<=CorteMin)
					actStatus = 6
				ELSE
					actStatus = 2 //Fuera de rango limite	
				ENDIF
				
			ELSEIF(CorteInferior==0 && CorteSuperior==0 && dato!=0)
				actStatus = 1 //Seleccionado: no hay filtrado
			ELSEIF(dato>=CorteInferior && dato<=CorteSuperior)
				actStatus = 1 //Seleccionado: dentro del rango
			ENDIF
			
			string OximInfoText = "-"
			IF(numtype(dato)==2)
				sprintf oximInfoText,"- (%s)",nombre
			ELSEIF(numtype(dato)!=2)
				sprintf oximInfoText,"%g (%s)",dato,nombre	
			ENDIF
			
			VuelosSelection_Info[i][j] = OximInfoText
			
			VuelosSelection_Text[i][j] = SelTextIndicators[actStatus]
			
			VuelosSelection_Sel[i][j][1] = actStatus
			
			SelCounters[actStatus] +=1			
		endfor
	endfor
	
	string SelCountersFormat	
	wfprintf SelCountersFormat,"%s = %g\n",SelTextIndicators,SelCounters///R=[0,5], textWave, wave0
	Note/K VuelosSelection_Info,SelCountersFormat
	Note/K VuelosSelection_Text,SelCountersFormat
	Note/K VuelosSelection_Sel,SelCountersFormat
	
	return SelCountersFormat
END

//-------------------------------------------------------------------//

Function/S vueloStatus_InfoWave_FilteredMultiple(variable DesconexionNum,[variable conjuntoVuelos])
	
	DFREF dfrResource = root:Resources:Oximetry
	IF(DataFolderRefStatus(dfrResource)==0)
		Init_Globals()
		DFREF dfrResource = root:Resources:Oximetry
	ENDIF
	NVAR OximIni = dfrResource:OximIni
	NVAR OximFin = dfrResource:OximLast
	
	IF(conjuntoVuelos==0 || conjuntoVuelos==1)
		wave VuelosStatus = dfrResource:VuelosStatus
		
	ELSEIF(conjuntoVuelos>=2)
		vueloStatus_CleanInfoWave(CleanKey=conjuntoVuelos)
		wave VuelosStatus = dfrResource:VuelosStatus_Clean	
	ENDIF
	
	variable vuelosRows = dimSize(vuelosStatus,0)
	variable vuelosCols = dimSize(vuelosStatus,1)
	
	IF(WaveExists(VuelosStatus) && (VuelosRows==0 || VuelosCols==0))
		VuelosRows = 1
		VuelosCols = 1
		variable noDataBlank = 1
	ENDIF
	
	//Make panel LB display waves
	Make/O/T/N=(vuelosRows,vuelosCols) dfrResource:VuelosSelection_Text/WAVE=VuelosSelection_Text = ""
	Make/O/T/N=(vuelosRows,vuelosCols) dfrResource:VuelosSelection_Info/WAvE=VuelosSelection_Info = ""
	Make/O/N=(vuelosRows,vuelosCols,2)/B/U dfrResource:VuelosSelection_Sel/WAVE=VuelosSelection_Sel = 0

	copyDimLabels VuelosStatus,VuelosSelection_Text
	copyDimLabels VuelosStatus,VuelosSelection_Info
	copyDimLabels VuelosStatus,VuelosSelection_Sel
	SetDimLabel 2,1,backColors,VuelosSelection_Sel //**Req. for color display
	
	wave Default_Colors = dfrResource:Default_Colors
	Duplicate/O Default_Colors,dfrResource:VuelosSelection_Colors/WAVE=VuelosSelection_Colors
	
	IF(noDataBlank==1)
		VuelosSelection_Info[0][0] = "No data"
		VuelosSelection_Text[0][0] = "No data"
		return ""
	ENDIF
	
	DesconexionNum = DesconexionNum==0 ? 1 : DesconexionNum
	variable sel1 = DesconexionNum==1 ? 0 : 3
	variable sel2 = DesconexionNum==1 ? 1 : 4
	variable sel3 = DesconexionNum==1 ? 2 : 5
	
	wave VSFilters = dfrResource:VSfilteredVars
	variable maxFilter = dimSize(VSFilters,1) //Max num of different parameters
	
	Make/FREE/N=(5)/T SelVueloTypeNm = {"-","Day+Night","Only Day","Fast Decompression","Medical"}
	Make/FREE/N=(7)/T SelTextIndicators = {"Unselected","Selected","Out of max range","Filtered","Favorite","Excluded","Out of min range"}
	//{"No Seleccionado","Seleccionado","Fuera de rango","Filtrado","Confirmado","Rechazado","Fuera de rango minimo"}
	Make/FREE/N=(7) SelCounters = 0
	Make/FREE/N=(7,maxFilter) SelMultipleCounters = 0
	
	variable corteInferior,corteSuperior
	variable corteMin,corteMax
	

	variable oximOrSat,Coldato
	variable i,j,k,r
	for(i=0;i<vuelosrows;i++)
		string actVuelo = getDimLabel(vuelosStatus,0,i)
		variable vueloTypeStatus = vuelosStatus[i][0]<10 ? 10 : vuelosStatus[i][0]
		
		VuelosSelection_Sel[i][0][1] = vueloTypeStatus
		VuelosSelection_Text[i][0] = SelVueloTypeNm[(vueloTypeStatus-10)]
		VuelosSelection_Info[i][0] = actVuelo
		
		DFREF dfrVuelo = root:$(actVuelo)

		Wave Oxim_ConexionTimes = dfrVuelo:Oxim_ConexionTimes  //col 2
		
		Wave Oxim_DesaturationTimes = dfrVuelo:Oxim_DesaturationTimes //col 2
		Wave Oxim_DesaturationLag = dfrVuelo:Oxim_DesaturationLag //col 0
		
		Wave Oxim_HipoxiaTimes = dfrVuelo:Oxim_HipoxiaTimes	//col 2
		Wave Oxim_HipoxiaLag = dfrVuelo:Oxim_HipoxiaLag //col 0
		
		make/free/n=(maxFilter-3,vuelosCols) DecisionNumWave = 0
		make/free/n=(maxFilter-3,vuelosCols)/T DecisionTxtWave = ""	
				
			for(j=1;j<vuelosCols;j++)
				string actOxim = getDimLabel(vuelosStatus,1,j)
				
				variable actProcStatus = vuelosStatus[i][j]
				
				DFREF dfrOx = dfrVuelo:$(actOxim)
				variable ox = 0
				sscanf actOxim,"Oxim_%g",Ox
				ox = ox - 1 //Selwaves don't have vuelo column
				
				SVAR Nombre = dfrOx:s_apellidoP
				string checkNombre = "-"
				IF(cmpstr(Nombre,"")!=0)
					checkNombre = Nombre
				ENDIF
				SVAR Sexo = dfrOx:s_sexo
				SVAR Rango = dfrOx:s_rango
				NVAR Edad = dfrOx:v_edad
				
				for(k=3;k<maxFilter;k++) //Loop filters
					oximOrSat = k-3
					
					corteMin	= VSFilters[0][k]
					corteInferior = VSFilters[1][k]
					cortesuperior = VSFilters[2][k]
					corteMax = VSFilters[3][k]
					
					IF(oximOrSat==0) //Align to oximeter conexion
						wave selWave  = Oxim_ConexionTimes
						colDato = 2
					ELSEIF(oximOrSat==1)
						wave selWave  = Oxim_DesaturationTimes
						colDato = 2
					ELSEIF(oximOrSat==2)
						wave selWave  = Oxim_HipoxiaTimes
						colDato = 2
					ELSEIF(oximOrSat==3)
						wave selWave  = Oxim_DesaturationLag //DC->97%
						colDato = 0
					ELSEIF(oximOrSat==4)
						wave selWave  = Oxim_HipoxiaLag	 //DC->89%
						colDato = 0
					ELSEIF(oximOrSat==5)
						wave selWave  = Oxim_HipoxiaLag	 //RC->89%
						colDato = 1	
					ELSEIF(oximOrSat==6)
						wave selWave  = Oxim_DesaturationLag //RC->97%
						colDato = 1	
					ELSEIF(oximOrSat==7 || oximOrSat==8) //Edad / sexo
						wave selWave = $("")
					ENDIF
					
					IF(!waveExists(selWave))
						variable selWaveMissing = 1
					ELSE
						selWaveMissing = 0
					ENDIF
			
					//Select data for each oximeter
					IF(OximOrSat>=0 && OximOrSat<=4)
						IF(selWaveMissing==0)
							variable ex1 = selWave[ox][sel1]
							variable ex2 = selWave[ox][sel2]
							variable ex3 = selWave[ox][sel3]
							
							variable dato = selWave[ox][colDato]
						ELSE
							dato = NaN
						ENDIF
					ELSEIF(OximOrSat==7 || OximOrSat==8)
						IF(OximOrSat==7 && Nvar_Exists(Edad) && Edad!=0)
							dato = Edad
						ELSEIF(OximOrSat==8 && Svar_Exists(Sexo) && cmpstr(Sexo,"")!=0)
							IF(cmpstr(Sexo,"M")==0)
								dato = 1
							ELSEIF(cmpstr(Sexo,"F")==0)
								dato = 2
							ELSE
								dato = NaN
							ENDIF
						ELSE
							dato = NaN
						ENDIF
					ELSEIF(OximOrSat==9)
						dato = NaN
					ENDIF
	
					//Evaulate if data is between selected range
					variable actStatus = 0 //{"No Seleccionado","Seleccionado","Fuera de rango","Filtrado","Confirmado","Rechazado","Fuera rango min"}
					IF(dato==0 || numtype(dato)==2) //Filtrado
						actStatus = 3 //Filtrado
					ELSEIF((dato<=CorteMin || dato>=CorteMax) && (CorteMin!=0 || CorteMax!=0)) 
						IF(dato<=CorteMin)
							actStatus = 6
						ELSE
							actStatus = 2 //Fuera de rango limite	
						ENDIF
						
					ELSEIF(CorteInferior==0 && CorteSuperior==0 && dato!=0)
						actStatus = 1 //Seleccionado: no hay filtrado
					ELSEIF(dato>=CorteInferior && dato<=CorteSuperior)
						actStatus = 1 //Seleccionado: dentro del rango
					ENDIF
					
					string OximInfoText = "-"
					IF(cmpstr(nombre,"")!=0)
						OximInfoText = nombre
					ENDIF
				
					IF(k==3) //First parameter of filtering
						setDimLabel 1,j,$(actOxim),DecisionNumWave,DecisionTxtWave
					ENDIF
				
					DecisionTxtWave[oximOrSat][j]  = SelTextIndicators[actStatus]
					DecisionNumWave[oximOrSat][j]  = actStatus
					
					SelMultipleCounters[actStatus][k] +=1			
			endfor
			
			actStatus = 1
			for(r=0;r<maxFilter-3;r++)
				IF(DecisionNumWave[r][j]!=1)
					actStatus = 0 //1 filter didn't pass
					break
				ENDIF
			endfor	
			
			VuelosSelection_Info[i][j] = OximInfoText
			
			VuelosSelection_Text[i][j] = SelTextIndicators[actStatus]
			
			VuelosSelection_Sel[i][j][1] = actStatus
			
			SelCounters[actStatus] +=1	

		endfor
			
	endfor
	
	string SelCountersFormat	
	wfprintf SelCountersFormat,"%s = %g\n",SelTextIndicators,SelCounters///R=[0,5], textWave, wave0
	Note/K VuelosSelection_Info,SelCountersFormat
	Note/K VuelosSelection_Text,SelCountersFormat
	Note/K VuelosSelection_Sel,SelCountersFormat
	
	return SelCountersFormat
END
				

//-------------------------------------------------------------------//
Function A4Load()
END

//////////////////////////////////////////////////////////////////////////////////////////////////////
//04//**DATA LOAD**///////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////

Function/S loadFlight_NIRS([variable remakePath])

	NewDataFolder/O root:VuelosNIRS
	DFREF dfrNIRS = root:VuelosNIRS

	PathInfo AllNIRSFlightFolder
	IF(cmpStr(s_path,"")==0 || remakePath==1) //Path not created
		string AllFFmsg
		sprintf AllFFmsg,"Select folder containing NIRS flights"
		NewPath/M=AllFFmsg AllNIRSFlightFolder
	ENDIF
	String AllExpFoldPath = s_path
	IF(cmpstr(AllExpFoldPath,"")==0)
		return ""
	ENDIF
	
	string extensionNIRS = ".xlsx"
	string NIRSVuelosDisponibles = IndexedFile(AllNIRSFlightFolder, -1, extensionNIRS)
	
	string VuelosMatch = "(?i)Vuelo"
	string NIRSVuelosDisponiblesFilter = grepList(NIRSVuelosDisponibles,VuelosMatch,0,";")
	string NIRSvuelosDisponiblesSort = sortList(NIRSVuelosDisponiblesFilter,";",16)
	
	variable NIRSvuelosDisponiblesCount = itemsInList(NIRSVuelosDisponiblesSort,";")

	IF(1)//(printInfo==1)
		printf "NIRS flights found: %g\n%s\n",NIRSvuelosDisponiblesCount,NIRSvuelosDisponiblesSort
	ENDIF
	
	DFREF dfrResource = root:Resources:Oximetry
	String/G dfrResource:NIRSSelPathDir/N=SelPathDir = AllExpFoldPath //Global str for selected NIRS Vuelos containing folder
	String/G dfrResource:NIRSVuelosDisponibles = NIRSVuelosDisponiblesSort //Global str with every Vuelo_XXX folder name
	Variable/G dfrResource:NIRSVuelosDispCount = NIRSvuelosDisponiblesCount //Global var counting how many vuelos

	return NIRSVuelosDisponiblesSort
	
END

Function loadFlight_NIRS_loadExcel([variable indexLoad])

	
	DFREF dfrResource = root:Resources:Oximetry
	SVAR NIRSpath = dfrResource:NIRSSelPathDir
	SVAR NIRSdisp = dfrResource:NIRSVuelosDisponibles
	NVAR NIRSdispCount = dfrResource:NIRSVuelosDispCount

	variable toLoadIndex = indexLoad != 0 ? indexLoad : 0
	IF(toLoadIndex >= NIRSdispCount)
		print "NIRS load index out of bounds"
		return 0
	ENDIF
	
	string toLoad = stringFromList(toLoadIndex,NIRSdisp,";")

	NewDataFolder/O root:VuelosNIRS
	DFREF dfrNIRS = root:VuelosNIRS
	
	NewDataFolder/O/S dfrNIRS:$(toLoad)
	DFREF dfrImporte = dfrNIRS:$(toLoad)
	
	XLLoadWave/J=3/D/P=AllNIRSFlightFolder toLoad
	printf "Loading %s [%s]\n",toLoad,s_value
	
	XLLoadWave/D/P=AllNIRSFlightFolder/Q/O/c=1 toLoad
	
	string/g dfrImporte:ExcelInfo = s_value
	
	IF(0) //Excel fecha como Texto
		wave/T Rawfecha = dfrImporte:ColumnB
		wave Rawtiempo = dfrImporte:ColumnC
		
		variable nmptsFecha = dimSize(RawFecha,0)
		Make/O/N=(nmptsFecha)/D dfrImporte:DateVuelo/WAVE=DateVuelo
		Make/O/N=(nmptsFecha)/T dfrImporte:DateVueloT/WAVE=DateVueloT
		setScale y,0,0,"dat",DateVuelo,DateVueloT
		
		string fechaTxt = RawFecha[0]
		variable fDia,fMes,fAo
		sscanf fechaTxt,"%d%*[.]%d%*[.]%d",fDia,fMes,fAo
		Variable fechaNum = date2secs((2000+fAo),fMes,fDia)
	ELSEIF(1) //Excel fecha como numero
		wave Rawfecha2 = dfrImporte:ColumnB
		wave Rawtiempo = dfrImporte:ColumnC
		
		nmptsFecha = dimSize(RawFecha2,0)
		Make/O/N=(nmptsFecha)/D dfrImporte:DateVuelo/WAVE=DateVuelo
		Make/O/N=(nmptsFecha)/T dfrImporte:DateVueloT/WAVE=DateVueloT
		setScale y,0,0,"dat",DateVuelo,DateVueloT
		
//		string fechaTxt = RawFecha[0]
//		variable fDia,fMes,fAo
//		sscanf fechaTxt,"%d%*[.]%d%*[.]%d",fDia,fMes,fAo
		fechaNum = RawFecha2[0]
	
	ENDIF
	
	DateVuelo[] = fechaNum + RawTiempo
	DateVueloT[] = secs2date(fechaNum,0) +" "+ Secs2Time(RawTiempo[p],1)
END



//Take found vuelos from selected path, make helper wave containing all available flights
Function/WAVE loadFlight_DataWave([variable printInfo,variable remakePath,variable ListWaveMake])

	DFREF dfrResource = root:Resources:Oximetry
	
	string ListaVueloName = "ListaVuelos"
	IF(ListWaveMake==0)
		string flightsInPath = loadFlight_Find(printInfo=printInfo,remakePath=remakePath) //Returns svar VuelosDisponibles
		string loadFlights = flightsInPath
		ListaVueloName += "_Path"
	ELSEIF(ListWaveMake==1)
		SVAR flightsInRoot= dfrResource:VuelosInRoot
		loadFlights = flightsInRoot
		ListaVueloName += "_Root"
	ENDIF

	variable loadCount = itemsInList(loadFlights,";")
	Make/O/N=(loadCount,4) dfrResource:$(ListaVueloName)/WAVE=ListaVuelos	
	SetDimLabel 1,0,'VueloNum',ListaVuelos
	SetDimLabel 1,1,'VueloType',ListaVuelos
	SetDimLabel 1,2,'TextOxims',ListaVuelos
	SetDimLabel 1,3,'InstrOxims',ListaVuelos
	
	variable i,actVueloNuM
	for(i=0;i<loadCount;i++)
		string actVuelo = stringFromList(i,loadFlights,";")
		SetDimLabel 0,i,$(actVuelo),ListaVuelos

		sscanf ActVuelo,"Vuelo_%g",actVueloNum
		ListaVuelos[i][0] = actVueloNum
	endfor
	
	IF(ListWaveMake==1)
		DFREF dfrResource = root:Resources:Oximetry
		wave VuelosStatus = dfrResource:VuelosStatus
		variable VueloStatusCount = DimSize(VuelosStatus,0)
	
		variable VueloCount = DimSize(ListaVuelos,0)
		FOR(i=0;i<vueloCount;i++)
			String actvueloStr = getDimLabel(ListaVuelos,0,i)
			DFREF dfrVuelo = root:$(actVueloStr)
			
			SVAR/Z s_tipoDeVuelo = dfrVuelo:s_tipodeVuelo
			IF(SVAR_Exists(s_tipodeVuelo)==1)
				IF(strSearch(s_tipoDeVuelo,"Noctur",0,2)!=-1)
					ListaVuelos[i][1] = 11
				ELSEIF(strSearch(s_tipoDeVuelo,"Diur",0,2)!=-1 && strSearch(s_tipoDeVuelo,"Noctur",0,2)==-1)
					ListaVuelos[i][1] = 12
				ELSEIF(strSearch(s_tipoDeVuelo,"Descomp",0,2)!=-1)
					ListaVuelos[i][1] = 13
				ELSEIF(strSearch(s_tipoDeVuelo,"dico",0,2)!=-1)
					ListaVuelos[i][1] = 14
				ENDIF
			ELSE
				ListaVuelos[i][1] = 0
			ENDIF
			
			variable VuelosPos = findDimLabel(VuelosStatus,0,actVueloStr)
			VuelosStatus[VuelosPos][0] = ListaVuelos[i][1]
		ENDFOR	
		
	ENDIF
	
	IF(printInfo==1 && ListWaveMake==1) //lw=0 has print already
		print ListaVueloName,": ",loadFlights
	ENDIF
	
	return ListaVuelos
END


//	IF(useList==1)
//		string actVueloStr = stringFromList(i,vueloList,",")
//		sprintf actVueloStr,"Vuelo_%s",actVueloStr
//	ELSE
//		actVueloStr = getDimLabel(VuelosStatus,0,i)
//	ENDIF

//-------------------------------------------------------------------//

//Check path for matching Vuelo_XXX folders, create VuelosDisponibles global str and VuelosDispCount global var. Return sorted vuelos list
Function/S loadFlight_Find([variable printInfo,variable remakePath])

	PathInfo AllFlightFolder
	IF(cmpStr(s_path,"")==0 || remakePath==1) //Path not created
		string AllFFmsg
		sprintf AllFFmsg,"Select base folder containing individual folders with raw flight data (ex: Vuelo_001)"
		NewPath/M=AllFFmsg AllFlightFolder
		PathInfo AllFlightFolder
	ENDIF
	String AllExpFoldPath = s_path
	IF(cmpstr(AllExpFoldPath,"")==0)
		return ""
	ENDIF
	
	string VuelosDisponibles = IndexedDir(AllFlightFolder, -1, 0)
	
	string VuelosMatch = "(?i)Vuelo"
	string VuelosDisponiblesFilter = grepList(VuelosDisponibles,VuelosMatch,0,";")
	string vuelosDisponiblesSort = sortList(VuelosDisponiblesFilter,";",16)

	IF(printInfo==1)
		printf "Flights found: %g\n",itemsInList(VuelosDisponiblesSort,";")
	ENDIF
	
	DFREF dfrResource = root:Resources:Oximetry
	String/G dfrResource:SelPathDir/N=SelPathDir = AllExpFoldPath //Global str for selected raw Vuelos containing folder
	String/G dfrResource:VuelosDisponibles = VuelosDisponiblesSort //Global str with every Vuelo_XXX folder name
	Variable/G dfrResource:VuelosDispCount = itemsInList(VuelosDisponiblesSort,";") //Global var counting how many vuelos

	return VuelosDisponiblesSort
END

//-------------------------------------------------------------------//

//Check root folder for vuelos found. Add to vueloStatus if reCheck==1
Function/S loadFlight_CheckFolder([variable reCheck])
	DFREF dfrResource = root:Resources:Oximetry
	SVAR VuelosDisponibles = dfrResource:VuelosDisponibles

	string FoldersFound = DataFolderDir(1,root:)[8,inf]
	string FoldersFoundRepl = replaceString("\r", FoldersFound ,"")
	FoldersFoundRepl = replaceString(",",FoldersFoundRepl,";")
	string FoldersFoundGrep = GrepList(FoldersFoundRepl,"Vuelo_",0,";")
	FoldersFoundGrep = sortList(FoldersFoundGrep,";",16)

	String/G dfrResource:VuelosInRoot = FoldersFoundGrep
	
	variable vuelosFound = itemsInList(FoldersFoundGrep,";")
	variable/G dfrResource:VuelosInRootCount = vuelosFound
	
	IF(reCheck)
		DFREF dfrResource = root:Resources:Oximetry
		wave VuelosStatus = dfrResource:VuelosStatus
		variable i
		for(i=0;i<vuelosFound;i++)
			string actVuelo = stringFromList(i,FoldersFoundGrep,";")
			variable dimPos = findDimLabel(VuelosStatus,0,actVuelo)
			IF(dimPos==-2) //Not found?
				variable VuelosStatusSize = dimSize(VuelosStatus,0)
				InsertPoints/M=0 VuelosStatusSize, 1, VuelosStatus
				SetDimLabel 0,VuelosStatusSize,$actVuelo,VuelosStatus
			ENDIF
		endfor
		
		loadFlight_DataWave(ListWaveMake=1) //Make ListaVuelos_Root from VuelosInRoot string.
	ENDIF
	
	
	
	return FoldersFoundGrep
END

//-------------------------------------------------------------------//

Function loadFlight(variable vueloNum,[variable remakePath,variable calcular,variable noUpdateList])

	PathInfo AllFlightFolder
	IF(cmpStr(s_path,"")==0 || remakePath==1) //Path not created
		string AllFFmsg
		sprintf AllFFmsg,"Select base folder containing individual folders with raw flight data (ex: Vuelo_001)s"
		NewPath/M=AllFFmsg AllFlightFolder
	ENDIF
	String AllExpFoldPath = s_path

	string VuelosDisponibles = IndexedDir(AllFlightFolder, -1, 0)
	
	string findVueloGrep = "_"+num2str(vueloNum)+"(?![0-9])"
	string findVuelo = grepList(VuelosDisponibles,findVueloGrep,0,";")
	IF(cmpStr(findVuelo,"")==0)
		print "loadFlight: Flight folder not found"
		return 0
	ENDIF
	
	string VueloName
	sprintf VueloName,"Vuelo_%g",vueloNum
	
	string SelectedFolderStr = AllExpFoldPath+VueloName
	NewPath/O SelectedFlightFolder,SelectedFolderStr
	
	String FolderAvailable = IndexedFile(SelectedFlightFolder, -1, ".pxp")
	Variable UnpackedFound = ItemsInList(FolderAvailable,";")
	
	IF(UnpackedFound==0)
		print "loadFlight: Experiment file (.pxp) not found"
		return 0
	ENDIF
	
	string VueloArchivoName = stringFromList(0,FolderAvailable,";")
	
	string waveLoadBaseList = "w_alt;w_altT;w_velAscenso_p"
	string stringLoadBaseList = "s_horaFinvuelo;s_horaInicioVuelo;s_horasVueloActual;s_tipodeVuelo"
	string variableLoadBaseList = "v_numOximetroSint;v_segsCeroDesnitrog;v_segsInicioVuelo;v_segsTotalesVuelo;v_segsVueloActual"
	
	string waveLoadOximList = "w_conexion;w_lpm;w_sat"
	string stringLoadOximList = "s_apellidoP;s_sexo;v_edad" //s_apellidoM;s_gradoMilitar;s_especialidad;s_nacionalidad;s_sintomas
	
	string waveLoadList = waveLoadBaseList + ";" + waveLoadOximList
	string stringLoadList = stringLoadBaseList + ";" + variableLoadBaseList + ";" + stringLoadOximList
	
	SetDataFolder root:
	
	LoadData/J=waveLoadList/p=SelectedFlightFolder/o/t=$(VueloName)/R VueloArchivoName 
	
	LoadData/J=stringLoadList/p=SelectedFlightFolder/o/t=$(VueloName)/R VueloArchivoName 

	DFREF dfrV = root:$(VueloName)
	String/G dfrV:OrigExpName = VueloArchivoName
	
	wave VuelosStatus = root:Resources:Oximetry:VuelosStatus
	variable dimPos = findDimLabel(VuelosStatus,0,VueloName)
	IF(dimPos==-2) //Not found?
		variable VuelosStatusSize = dimSize(VuelosStatus,0)
		InsertPoints/M=0 VuelosStatusSize, 1, VuelosStatus
		SetDimLabel 0,VuelosStatusSize,$VueloName,VuelosStatus
	ENDIF
	
	IF(calcular==1)
		Flight_CalcVuelo(vueloName)
	ENDIF
	IF(noUpdateList==0)
		vueloStatus_InfoWave()
	ENDIF
END

//-------------------------------------------------------------------//

Function loadFlight_CargarTodos([variable calcular])

	SVAR VuelosDisp = root:Resources:Oximetry:VuelosDisponibles
	variable VuelosCount = itemsInList(VuelosDisp,";")
	variable i
	for(i=0;i<VuelosCount;i++)
		string actVuelo = stringFromList(i,VuelosDisp,";")
		variable actVueloNum
		sscanf ActVuelo,"Vuelo_%g",actVueloNum
	
		loadFlight(actVueloNum,calcular=calcular,noUpdateList=1)
	endfor
	
	vueloStatus_InfoWave()
	printf "Loaded %g vuelos\n",vuelosCount
END

//-------------------------------------------------------------------//

Function loadFlight_Handler()

	SVAR/Z VuelosDisp = root:Resources:Oximetry:VuelosDisponibles
	IF(!Svar_Exists(VuelosDisp))
		String/G root:Resources:Oximetry:VuelosDisponibles = ""
	ENDIF
	string VuelosDispHelp = vuelosDisp

		Variable inputFlight=-1
		variable inputCalc=0
		
		Prompt VuelosDispHelp, "Available flights"
		
		Prompt inputFlight, "Load flight (-1: load every flight): "//"Cargar vuelo (-1: cargar todos): "
		string inputCalcHelp = "Only load;Load and process"
		Prompt inputCalc, "Process data", popup inputCalcHelp
		
		DoPrompt/HELP=("Select flight number to load") "Select flight number to load", VuelosDispHelp,inputFlight,inputcalc
		if (V_Flag)
			return -1
		endif
		variable vueloNum = inputFlight
		variable calcular = inputCalc-1

	IF(inputFlight==0)
		print "[loadFlight_Handler] Select a flight number."
	ELSEIF(inputFlight==-1)
		loadFlight_CargarTodos(calcular=calcular)
		vueloStatus_Panel(resetPanel=1,updateInfo=1) //Reset?
	ELSEIF(inputFlight>0)
		loadFlight(VueloNum,remakePath=0,calcular=calcular)
	ELSE
		return 0
	ENDIF
END

//-------------------------------------------------------------------//

Function loadFlight_DeleteFlight([string vueloList])

	IF(!ParamIsDefault(vueloList) && cmpstr(vueloList,"")!=0) //Valid vueloList
		printf "Delete flights: %s\n",vueloList
	ELSE 
		print "loadFlight_DeleteFlight: no flights selected"
		return 0
	ENDIF
	
	DFREF dfrResource = root:Resources:Oximetry
	wave VuelosStatus = dfrResource:VuelosStatus
	
	variable i,foundDF,notfoundDF
	variable vueloCount = itemsInList(vueloList,";")
	for(i=0;i<vueloCount;i++)
		string actVueloStr = stringFromList(i,vueloList,";")
		IF(strsearch(actVueloStr,"Vuelo_",0)==-1)
			actVueloStr = "Vuelo_" + actVueloStr
		ENDIF
		
		string currFlightDF = "root:" + actVueloStr
		IF(DataFolderExists(currFlightDF)==1)
			//print "Found folder: " + currFlightDF
			foundDF += 1
			
			killDataFolder currFlightDF
			
			variable dimPos = findDimLabel(VuelosStatus,0,actVueloStr)
			IF(dimPos==-2) //Not found?
				printf "loadFlight_DeleteFlight: %s not found on VuelosStatus list\n",actVueloStr
			ELSE
				deletePoints/M=0 dimPos,1,VuelosStatus
			ENDIF
		ELSE
			notfoundDF += 1
		ENDIF

	endfor
	
	IF(vueloCount==1)
	 printf "Flight %s deleted\n",actVueloStr
	ELSE
		printf "Flights deleted: %g. Flights not found: %g\n",foundDF,notfoundDF
	ENDIF
END

//-------------------------------------------------------------------//

//////////////////////////////////////////////////////////////////////////////////////////////////////
//05//**Reporte de datos**////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
Function A5Reporte()
END
//-------------------------------------------------------------------//

Function Reporte_Handler()
	DFREF dfrResource = root:Resources:Oximetry

	NVAR OximIni = dfrResource:OximIni
	NVAR OximFin = dfrResource:OximLast
	NVAR VuelosInRootCount = dfrResource:VuelosInRootCount
	
	SVAR actvuelo = root:actVuelo
		variable actVueloNum
		sscanf actVuelo,"Vuelo_%g",actVueloNum
	SVAR actOxim = root:actOxim
		variable actOximNum
		sscanf actOxim,"Oxim_%g",actOximNum
	
	wave VuelosStatus = dfrResource:VuelosStatus
	variable vuelosRows = dimSize(vuelosStatus,0)
	variable vuelosCols = dimSize(vuelosStatus,1)
	
	wave/T VuelosStatus_Text = dfrResource:VuelosStatus_Text
	wave/T VuelosStatus_Info = dfrResource:VuelosStatus_Info
//	wave VuelosStatus_Sel = dfrResource:VuelosStatus_Sel
//	wave VuelosStatus_Colors = dfrResource:VuelosStatus_Colors

	variable AccionReporte,SalidaReporte
	
	string AccionReporteHelp = "1. Current flight;2. Current oxymeter on selected flight;3. Selected list of flights;4. All flights"
	//"1. Actual vuelo;2. Actual oximetro en vuelo;3. Lista manual de vuelos;4. Todos los vuelos"
	Prompt AccionReporte, "Select data: ", popUp AccionReporteHelp
	
	string SalidaReporteHelp = "1. Print;2. Layout"
	Prompt SalidaReporte, "Choose output type: ", popUp SalidaReporteHelp

	string PromptAsk
	//sprintf PromptAsk,"List: C%g/S%g/F%g. Current selection: oxim %s, flight %g.",VuelosInRootCount,VuelosRows,0,actOxim,actVueloNum //"Lista: C%g/S%g/F%g. Actual sel: oxim %s de vuelo %g."
	sprintf PromptAsk,"Current selection: oxim %s, flight %g.",actOxim,actVueloNum //"Lista: C%g/S%g/F%g. Actual sel: oxim %s de vuelo %g."
	DoPrompt/HELP=("Report options") PromptAsk,SalidaReporte,AccionReporte
	if (V_Flag)
		return -1
	endif

	IF(AccionReporte==1) //Actual vuelo -> data vuelo + 8 oxims
		variable i
		print "//////Report",actVuelo,"//////"
		for(i=1;i<=8;i++)
			string actOximReport = show_OximPanel_VueloOximHandler_Info(oxim=i)
			print actOximReport
		endfor
	ELSEIF(AccionReporte==2) //Actual oximetro en vuelo -> Data 1 oxim vs generales
		actOximReport = show_OximPanel_VueloOximHandler_Info(oxim=actOximNum)
		print actOximReport
	ELSEIF(AccionReporte==3) //Actual lista de vuelos -> Data lista vs generales	
		//Reporte_VuelosInfoCompHandle(AskListaVuelos=1)
	ELSEIF(AccionReporte==4) //Data general
		//Reporte_VuelosInfoCompHandle()
	ENDIF
END

//-------------------------------------------------------------------//

Function Reporte_VuelosInfoCompHandle([variable AskListaVuelos,variable promptRep, variable ReporteData, variable statShow])
	String SelectedVuelos = ""
	IF(AskListaVuelos==1)
		SVAR actvuelo = root:actVuelo
		variable actVueloNum
		sscanf actVuelo,"Vuelo_%g",actVueloNum
		SelectedVuelos = num2str(actVueloNum) + ","
	
		Prompt SelectedVuelos, "Flight ID (comma separated): "
		DoPrompt/HELP=("Select flight numbers") "Show data for flights: ", SelectedVuelos
			if (V_Flag)
				return -1
			endif
	ENDIF
	
	IF(promptRep) //Ask in a prompt
		string ReporteDataHelp = "1. ConectionTimes;2. DesaturationTimes;3. HypoxiaTimes;4. DesaturationLag;5. HypoxiaLag;6. Slope (HR);7. Slope (SpO2)"
		Prompt ReporteData, "Select Data: ", popUp ReporteDataHelp
	
		statShow = 2 //2=First diff
		Prompt statShow, "Select statistic column: "
		
		DoPrompt/HELP=("Options for report") "Data: ",ReporteData,statShow
			if (V_Flag)
				return -1
			endif		
		IF(ReporteData==0)
			return 0
		ENDIF
		
		ReporteData -= 1
	ELSEIF(!paramIsDefault(ReporteData) && !paramIsDefault(StatShow)) //Use given values
		//
	ELSE
		string vuelosStname = "VuelosDataPanel"
	
		ControlInfo/W=$(vuelosStname) popSDInfoDisplay
		ReporteData = v_value - 1
		
		ControlInfo/W=$(vuelosStname) svVDcol
		statShow = v_value
		
	ENDIF
	
	Wave VSpanelVars = VueloStatus_PanelChecker()
	variable InfoDisp = VSpanelVars[0]
	variable conjuntoVuelos = VSpanelVars[7]
//		IF(InfoDisp==1 || InfoDisp==2)
//			Wave VSselwave = dfrResource:VuelosStatus_Sel
//		ELSE
//			Wave VSselwave = dfrResource:VuelosSelection_Sel
//		ENDIF
//		update_vueloRow = findDimLabel(VSselwave,0,actVuelo)
//		update_oximCol = findDimLabel(VSselwave,1,actOxim)

	//InfoDisp = InfoDisp==10 ? 0 : InfoDisp //If filtro multiple selected, show default oximConexionTimes
	string VuelosInfoCompReport = Reporte_VuelosInfoComp(statShow=statShow,waveShow=ReporteData,InfoDisp=InfoDisp,conjuntoVuelos=conjuntoVuelos,ListaVuelos=SelectedVuelos)	
	
	IF(cmpstr(VuelosInfoCompReport,"")==0)
		vueloStatus_DataPanel(update=1,reporteString=VuelosInfoCompReport,DispData=0,DispColumna=-1,FontVarLB=0,FontVarTB=0)
	ELSE
		vueloStatus_DataPanel(reporteString=VuelosInfoCompReport)
	ENDIF
	
END

//-------------------------------------------------------------------//

Function/S Reporte_VuelosInfoComp([variable statShow ,variable waveShow,variable InfoDisp,variable conjuntoVuelos,string ListaVuelos,variable blank])

	SVAR actvuelo = root:actVuelo
	SVAR actOxim = root:actOxim
	
	string saveVuelo = actVuelo
	string saveOxim = actOxim

	DFREF dfrResource = root:Resources:Oximetry

	NVAR OximIni = dfrResource:OximIni
	NVAR OximFin = dfrResource:OximLast
		
	NewDataFolder/O root:AllVueloData
	DFREF dfrAVD = root:AllVueloData
	NewDataFolder/O dfrAVD:VueloCompilate
	DFREF dfrAVDCmp = dfrAVD:VueloCompilate
	
	IF(blank)
		Make/O/N=(0,1)/T dfrAVDCmp:Reporte_VuelosConexionTimes_Text
		Make/O/N=(0,1,2) dfrAVDCmp:Reporte_VuelosConexionTimes_Sel
		Make/O/N=(0,3) dfrAVDCmp:Reporte_VuelosConexionTimes_Color
		return "-"
	ENDIF
	
	//Get or create compilate table
	IF(waveShow>=0 && waveShow<=4)
			wave Rep_ConexionTimes = Reporte_CompilateOximTimes(waveshow=waveShow,InfoDisp=InfoDisp,conjuntoVuelos=conjuntoVuelos,ListaVuelos=ListaVuelos)
			string waveShowName = note(Rep_ConexionTimes)
	ELSEIF(waveShow==5 || WaveShow==6) //If wave is type "confirmed oxims", skip rest of for loop
		Confirmar_TablaCompilado_Handler(InfoDisp=InfoDisp,conjuntoVuelos=conjuntoVuelos)
		IF(WaveShow==5)
			Wave ConfirmedCard = dfrAVD:ConfirmedOximsCard
			Duplicate/O ConfirmedCard,dfrAVDCmp:Reporte_VuelosConexionTimes/WAVE=Rep_ConexionTimes
			waveShowName = nameOfWave(ConfirmedCard)
		ELSEIF(WaveShow==6)
			Wave ConfirmedSat = dfrAVD:ConfirmedOximsSat
			Duplicate/O ConfirmedSat,dfrAVDCmp:Reporte_VuelosConexionTimes/WAVE=Rep_ConexionTimes
			waveShowName = nameOfWave(ConfirmedSat)
		ENDIF
	ENDIF
	
	//Create statistical column with percentiles
	WaveStats/Q/PCST Rep_ConexionTimes
	wave M_WaveStats
	
	IF(DimSize(Rep_ConexionTimes,0)<3 || statShow==-1)
		Make/O/N=(0,1) dfrAVDCmp:Reporte_VuelosConexionTimes_Quant/WAVE=VuelosQuantCol
		variable noStatShow = 1
		string statID = ""
	ELSE
		statID = getDimLabel(Rep_ConexionTimes,1,statShow)
		
		variable minStat = M_WaveStats[%min][statShow] //%min
		variable maxStat  = M_WaveStats[%max][statShow] //%max
		variable AvgStat = M_WaveStats[%avg][statShow] //%avg
		variable sdevStat = M_WaveStats[%sdev][statShow] //%sdev
		MatrixOp/FREE FinalColExtract = col(Rep_ConexionTimes,statShow)
		StatsQuantiles/QW/Q FinalColExtract
		wave W_QuantileValues
		Duplicate/o W_QuantileValues,dfrAVDCmp:Reporte_VuelosConexionTimes_Quant/WAVE=VuelosQuantCol
		KillWaves W_QuantileValues
	ENDIF
	
	//FOR PANEL, make sel and color tables
	Duplicate/o Rep_ConexionTimes,dfrAVDCmp:Reporte_VuelosConexionTimes_Sel/WAVE=VuelosSelWave
	VuelosSelWave = 0
	redimension/N=(-1,-1,2) VuelosSelWave
	SetDimLabel 2,1,backColors,VuelosSelWave
	
	IF(noStatShow==0)
		VuelosSelWave[][statShow][1] = VuelosQuantCol[p]
	ENDIF
	
	variable colorTable = 3 //Seleccionar color para columna de estadistica en VuelosDataPanel
	wave/z VuelosColWave = dfrAVDCmp:Reporte_VuelosConexionTimes_Color
	IF(!waveExists(VuelosColWave) || dimSize(VuelosColWave,0)==0)
		IF(colorTable==1)
			ColorTab2Wave BlueRedGreen
		ELSEIF(colorTable==2)
			ColorTab2Wave RedWhiteBlue
		ELSEIF(colorTable==3)
			ColorTab2Wave 	RedWhiteGreen	
		ENDIF
		Wave M_Colors
		Variable Ncolors = DimSize(M_colors,0)
		IF(Ncolors==256)
			Resample/UP=25/DOWN=64 M_Colors
		ENDIF
		Duplicate/O M_Colors,dfrAVDCmp:Reporte_VuelosConexionTimes_Color/WAVE=VuelosColWave
	ENDIF
	
	//Make actual display wave
	Make/O/T/N=(dimSize(Rep_ConexionTimes,0),dimSize(Rep_ConexionTimes,1)) dfrAVDCmp:Reporte_VuelosConexionTimes_Text/WAVE=VuelosTextWave
	CopyDimLabels Rep_ConexionTimes,VuelosTextWave
	
	VuelosTextWave[][] = num2str(Rep_ConexionTimes[p][q])
	IF(noStatShow==0)
		VuelosTextWave[][statShow] = VuelosTextWave[p][statShow] + " (" + num2str(VuelosQuantCol[p]) + ")" 
	ENDIF
	
	insertPoints/M=1 0,1,VuelosTextWave,VuelosSelWave
	SetDimLabel 1,0,$("ID ("+WaveShowName+")"),VuelosTextWave,VuelosSelWave
	variable i,waveFinalShowSize = dimSize(VuelosTextWave,0)
	for(i=0;i<waveFinalShowSize;i++)
		VuelosTextWave[i][0] = getDimLabel(VuelosTextWave,0,i)
	endfor
	
	string BiomReport = Reporte_MakeBiometrics()
	
	string finalOutput	
	sprintf finalOutput,"[%s: %s] %g data.\n%s\nMin=%g; Max=%g;Avg=%g\nQ25=%g; Q75=%g; IQR=%g;\nMedian=%g; MAD=%g; sdev=%g;"\
	,waveShowName,statID,waveFinalShowSize,BiomReport,minStat,maxStat,avgStat,v_Q25,v_Q75,V_IQR,v_Median,V_MAD,sdevStat	
	
	return finalOutput
END

//-------------------------------------------------------------------//

Function/S Reporte_MakeBiometrics()
	
	DFREF dfrAVD = root:AllVueloData
	DFREF dfrAVDCmp = dfrAVD:VueloCompilate

	wave ReporteWave = dfrAVDCmp:Reporte_VuelosConexionTimes
	Duplicate/o ReporteWave,dfrAVDCmp:Reporte_Biometrics/WAVE=ReporteBiometrics
	SetDimLabel 1,0,Edad,ReporteBiometrics
	SetDimLabel 1,1,Sexo,ReporteBiometrics
	
	ReporteBiometrics = NaN
	Redimension/N=(-1,2) ReporteBiometrics
	
	variable i,oxCount = dimSize(ReporteBiometrics,0)
	variable vue,ox
	
	for(i=0;i<oxCount;i++)
		string actDim = getDimLabel(ReporteBiometrics,0,i)
		sscanf actDim,"Vuelo_%g_Oxim_%g",vue,ox
		
		DFREF dfrVuelo = root:$("Vuelo_"+num2str(vue))
		DFREF dfrOx = dfrVuelo:$("Oxim_"+num2str(ox))
			
		SVAR Nombre = dfrOx:s_apellidoP
		SVAR Sexo = dfrOx:s_sexo
		SVAR Rango = dfrOx:s_rango
		NVAR Edad = dfrOx:v_edad
		
		IF(Edad==0 || !Nvar_Exists(Edad))
			variable EdadVal = NaN
			variable SexoVal = NaN
		ENDIF
		IF(cmpstr(Sexo,"M")==0)
			SexoVal = 0
		ELSEIF(cmpstr(Sexo,"F")==0)
			SexoVal = 1
		ELSE
			SexoVal = NaN
		ENDIF
		
		ReporteBiometrics[i][0] = Edad
		ReporteBiometrics[i][1] = SexoVal
	endfor
	
	WaveStats/PCST/Q ReporteBiometrics
	wave M_WaveStats
	
	variable EdadAvg = M_WaveStats[3][0]
	variable EdadSdev = M_WaveStats[4][0]
	
	variable SexoSum = M_WaveStats[23][1] //F sums 1 -> total sum = total fems
	variable SexoInv = M_WaveStats[1][1] //Sexo Nans
	variable SexoH = OxCount - SexoSum - SexoInv //Sexo Homs
	
	string finalMsg
	sprintf finalMsg,"Age: %.4g (±%.5g), H:%g/F:%g/Nan:%g",EdadAvg,EdadSdev,SexoH,SexoSum,SexoInv
	
	killWaves/Z M_WaveStats
	
	return finalMsg
END

//-------------------------------------------------------------------//

Function/WAVE Reporte_CompilateOximTimes([variable waveShow,variable InfoDisp,variable conjuntoVuelos,string ListaVuelos])
	SVAR actvuelo = root:actVuelo
	SVAR actOxim = root:actOxim

	DFREF dfrResource = root:Resources:Oximetry
	DFREF dfrAVD = root:AllVueloData
	DFREF dfrAVDCmp = dfrAVD:VueloCompilate	
	
	IF(conjuntoVuelos==0 || conjuntoVuelos==1)
		wave VuelosStatus = dfrResource:VuelosStatus
	ELSEIF(conjuntoVuelos>=2)
		vueloStatus_CleanInfoWave(CleanKey=conjuntoVuelos)
		wave VuelosStatus = dfrResource:VuelosStatus_Clean
	ENDIF
	variable vuelosRows = dimSize(vuelosStatus,0)
	variable vuelosCols = dimSize(vuelosStatus,1)
	IF(vuelosRows==0) //No data loaded on vuelosStatus
		return $""
	ENDIF
	
	variable checkInfoDisplay = InfoDisp>=3 ? 1 : -1 //Clean by selection / clean by Zero values
	IF(checkInfoDisplay==1)
		wave/T VuelosSelection_Text = dfrResource:VuelosSelection_Text
		wave/T VuelosSelection_Info = dfrResource:VuelosSelection_Info
		wave VuelosSelection_Sel = dfrResource:VuelosSelection_Sel
	ENDIF

	variable i,j
	string ListaVuelosFull = ""
	IF(cmpstr(ListaVuelos,"")!=0)
		variable selectedFlights = 1
		variable ListaVuelosCount = itemsInList(ListaVuelos,",")
		for(i=0;i<Listavueloscount;i++)
			ListaVuelosFull += "Vuelo_" + stringFromList(i,ListaVuelos,",") + ","
		endfor
	ENDIF
	
	variable notCreated = 1
	for(i=0;i<vuelosRows;i++)
		string actVueloStr = getDimLabel(VuelosStatus,0,i)
		variable VuelodimPos = findDimLabel(VuelosSelection_Sel,0,actVueloStr)
		
		IF(selectedFlights==1)
			variable VueloFound = FindListItem(actvueloStr, ListaVuelosFull,",")
			IF(vueloFound==-1) //Not on list
				variable notFound = 1
				//print actVuelo,"listaVuelos",ListaVuelosFull
				continue
			ELSE
				notFound = 0
			ENDIF	
		ENDIF
			
		DFREF dfrVuelo = root:$(actVueloStr)	
				
		switch(waveShow)
			case 0:
				Wave Oxim_ConexionTimes = dfrVuelo:Oxim_ConexionTimes
				Wave SelectedWave = Oxim_ConexionTimes
				break
			case 1:
				Wave Oxim_DesaturationTimes = dfrVuelo:Oxim_DesaturationTimes
				Wave SelectedWave = Oxim_DesaturationTimes
				break
			case 2:
				Wave Oxim_HipoxiaTimes = dfrVuelo:Oxim_HipoxiaTimes	
				Wave SelectedWave = Oxim_HipoxiaTimes	
				break
			case 3:
				Wave Oxim_DesaturationLag = dfrVuelo:Oxim_DesaturationLag
				Wave SelectedWave = Oxim_DesaturationLag
				break
			case 4:
				Wave Oxim_HipoxiaLag = dfrVuelo:Oxim_HipoxiaLag
				Wave SelectedWave = Oxim_HipoxiaLag
				break																				
		endswitch
		
		IF(!WaveExists(SelectedWave))
			continue
		ENDIF
		
		string waveShowName = NameOfWave(SelectedWave)
		variable waveShowSize = dimSize(SelectedWave,0)
		variable waveShowCol = dimSize(SelectedWave,1)
//		IF(statShow>=waveShowCol)
//			printf "[Reporte_VuelosInfoComp] Columna de datos seleccionada (%g) excede el rango de la tabla (%g)!\n",statShow,waveShowCol
//			return ""
//		ENDIF
		
		//Create alternative version and clean if asked
		Duplicate/FREE SelectedWave,SelectedWave_Vuelo
		IF(checkInfoDisplay==1) //Check selection wave from VuelosStatusPanel 
			variable deletedNum = 0
			For(j=0;j<waveShowSize;j++)
				string actOxLabel = getDimLabel(SelectedWave_Vuelo,0,j-deletedNum)
				variable actOxPos = findDimLabel(VuelosSelection_Sel,1,actOxLabel)
				variable actStatus = VuelosSelection_Sel[VueloDimPos][actOxPos][1]
				IF(actStatus!=1) //Not selected
					deletePoints/M=0 j-deletedNum,1,SelectedWave_Vuelo
					deletedNum +=1
				ENDIF
			ENDFOR
		ELSEIF(checkInfoDisplay==-1) //Alternative: clean 0 values (Do not put Oxims with no data on compilate table)
			deletedNum = 0
			For(j=0;j<waveShowSize;j++)
				MatrixOp/FREE RowExtract = row(SelectedWave_Vuelo,j-deletedNum)
				variable sumCols = sum(RowExtract)
				IF(sumCols==0) //Empty
					deletePoints/M=0 j-deletedNum,1,SelectedWave_Vuelo
					deletedNum +=1
				ENDIF
			ENDFOR
		ENDIF
		
		variable newWaveShowSize = dimSize(SelectedWave_Vuelo,0)
		IF(newWaveShowSize==0)
			continue
		ENDIF

		//Add vuelo ID to row label
		For(j=0;j<waveShowSize-deletedNum;j++)
			string actDimLabel = actvueloStr + "_" + getDimLabel(SelectedWave_Vuelo,0,j)
			setDimLabel 0,j,$(actDimLabel),SelectedWave_Vuelo
		ENDFOR
		//
		
		IF(i==0 || notCreated== 1)
			Duplicate/O SelectedWave_Vuelo,dfrAVDCmp:Reporte_VuelosConexionTimes/WAVE=Rep_ConexionTimes
			notCreated = 0
		ELSEIF(DimSize(SelectedWave_Vuelo,0)>0)
			Concatenate/NP=0/DL {SelectedWave_Vuelo}, Rep_ConexionTimes
		ENDIF

	endfor

	note/K Rep_ConexionTimes,waveShowName
	return Rep_ConexionTimes
END

//-------------------------------------------------------------------//

Function vueloStatus_DataPanel([variable reset,variable update,string reporteString,variable DispData,variable DispColumna,variable FontVarLB,variable FontVarTB])
	SVAR actvuelo = root:actVuelo
	SVAR actOxim = root:actOxim

	//Resources for panel
	DFREF dfrResource = root:Resources:Oximetry
	SVAR /Z VDbotInfo = dfrResource:VDbotInfo
	IF(!SVAR_Exists(VDbotInfo))
		String/G dfrResource:VDbotInfo/N=VDbotInfo = "-"	// Create and initialize it
	ENDIF
	IF(!ParamIsDefault(reporteString) && cmpstr(reporteString,"")!=0)
		VDbotInfo = reporteString
	ENDIF
	
	DFREF dfrAVD = root:AllVueloData
	DFREF dfrAVDCmp = dfrAVD:VueloCompilate
	wave listW = dfrAVDcmp:Reporte_VuelosConexionTimes_Text
	wave selW = dfrAVDcmp:Reporte_VuelosConexionTimes_Sel
	wave colW = dfrAVDcmp:Reporte_VuelosConexionTimes_Color
	IF(!WaveExists(listW) || !WaveExists(selW) || !WaveExists(colW))
		Reporte_VuelosInfoComp(blank=1) 
		DFREF dfrAVD = root:AllVueloData
		DFREF dfrAVDCmp = dfrAVD:VueloCompilate
		wave listW = dfrAVDcmp:Reporte_VuelosConexionTimes_Text
		wave selW = dfrAVDcmp:Reporte_VuelosConexionTimes_Sel
		wave colW = dfrAVDcmp:Reporte_VuelosConexionTimes_Color
	ENDIF
	
	//Size and position variables
	variable posX = 300
	variable posY = 300
	variable ancho = posX + 1000 + 20
	variable bajo = posY + 500 + 10
	
	VARIABLE dBTp = 50
	Variable dBToff = 10
	VARIABLE fontZ = 14	
	
	//Panel window
	string vuelosStname = "VuelosDataPanel"
	
	DoWindow/HIDE=? $(vuelosStname) 
	Variable vuelosStnameExists = V_flag
		
	IF(reset==1) //Reset all (1)
		Killwindow/Z $(vuelosStname)
	ELSEIF(reset==0) //To front
		DoWindow/F $(vuelosStname)
	ENDIF
	
	IF(vuelosStnameExists==0 || (vuelosStnameExists==1 && reset==1))
		NewPanel/K=1/N=$(vuelosStname)/W=(posx,posY,ancho,bajo) as "Population Data Panel"
	ELSE
		return 0
	ENDIF
	
	IF(vuelosStnameExists==1 && update==1)
		ListBox lbVDstatus,fSize=fontZ-3 + FontVarLB
		PopupMenu popSDInfoDisplay,mode=DispData
		SetVariable svVDcol,limits={-1,99,1},value=_NUM:DispColumna
		TitleBox tbVDBotInfo,variable=VDbotInfo,fsize=fontZ-3 + FontVarLB
		return 1
	ENDIF
		
	//Main control initials
	ListBox lbVDstatus,pos={0*dBTp+(1*dBToff),0*dBTp+(1*dBToff)},size={20*dBTp,8.0*dBTp}
	ListBox lbVDstatus,listWave=listW,editStyle= 1,widths={60},proc=VueloStatus_Controls_LB,fSize=fontZ-3
	ListBox lbVDstatus,selWave=selW,colorWave=colW,mode= 2,userColumnResize=1
	
	GroupBox gbVD0,pos={0*dBTp+(1.0*dBToff),8.0*dBTp+(1.5*dBToff)},size={10.0*dBTp,1.7*dBTp},title="Data selection" //ESP:"Seleccion de Data"
	
	TitleBox tbVDvu,pos={0.5*dBTp+(0*dBToff),dBTp*8.0+(4*dBToff)},fixedSize=1,size={2*dBTp,dBTp/2},labelBack=(65535,65535,65535),variable=actvuelo
	TitleBox tbVDox,pos={0.5*dBTp+(0*dBToff),dBTp*8.5+(4*dBToff)},fixedSize=1,size={2*dBTp,dBTp/2},labelBack=(65535,65535,65535),variable=actOxim
	
	Button btVD0,pos={2.5*dBTp+(1*dBToff),8.0*dBTp+(4*dBToff)},size={2*dBTp,1*dBTp},proc=VueloStatus_Controls_BT,title="Update\nData",fSize=fontZ-1,focusRing=0 //ESP:"Actualizar\nDatos"
	Button btVD1,pos={4.5*dBTp+(1*dBToff),8.0*dBTp+(4*dBToff)},size={2*dBTp,0.5*dBTp},proc=VueloStatus_Controls_BT,title="Database Panel",fSize=fontZ-3,focusRing=0 //ESP:"Panel Base Datos"
	Button btVD2,pos={4.5*dBTp+(1*dBToff),8.5*dBTp+(4*dBToff)},size={2*dBTp,0.5*dBTp},proc=VueloStatus_Controls_BT,title="Reset",fSize=fontZ-1,focusRing=0 //ESP:"Resetear"
	
	string ReporteDataHelp = "\"" + "1. Conection Time;2. Desaturation Time;3. Hypoxia Time;4. Desaturation Lag;5. Hypoxia Lag;6. Slope (HR);7. Slope (SpO2)" + "\""
	//ESP:string ReporteDataHelp = "\"" + "1. ConexionTimes;2. DesaturationTimes;3. HipoxiaTimes;4. DesaturationLag;5. HipoxiaLag;6. Pendientes (HR);7. Pendientes (Ox)" + "\""
	PopupMenu popSDInfoDisplay,pos={9.0*dBTp+(0*dBToff),dBTp*8.0+(4*dBToff)},title="Data:" //ESP:"Data:"
	PopupMenu popSDInfoDisplay,proc=VueloStatus_Controls_Pop,value= #ReporteDataHelp,mode=1,bodyWidth=(dBTp*2+3*dBToff)
	
	DispColumna = DispColumna==0 ? 2 : DispColumna
	SetVariable svVDcol,pos={7.0*dBTp+(0*dBToff),dBTp*8.5+(4*dBToff)},size={dBTp*2.2,dBTp/2},title="Column",format="%g" //ESP:"Columna"
	SetVariable svVDcol,limits={-1,99,1},value=_NUM:DispColumna,proc=VueloStatus_Controls_Var	
	
	TitleBox tbVDBotInfo,pos={10.0*dBTp+(2*dBToff),8.0*dBTp+(2*dBToff)},size={5*dBTp,1.5*dBTp},fixedSize=1,title=""
	TitleBox tbVDBotInfo,fsize=fontZ-3,labelBack=(65535,65535,65535),variable=VDbotInfo
	
	//Reporte_VuelosInfoCompHandle()
END


//-------------------------------------------------------------------//

// PNG: width= 48, height= 48
Picture settingsIcon
	ASCII85Begin
	M,6r;%14!\!!!!.8Ou6I!!!!Q!!!!Q#R18/!*96tLB%;S#%C4q6id5errE(l]r.%o!!6n,6pXdcJaJ
	lOC/[D4`da,F$_,(g<p[9+eqj*6B5pjC?.=Z!$&X=7T>3DTcUoc+HiWOXFJ05</#?N/"]I^(2f6C,0
	('.$WSV^YcR$'^IW-D`1Z.qtgt\;R-W$L'Kp5[Dp4ZTiR6(F^ONlN>RnE<T.O*e;6$%+014f$#c-8]
	""JuNpRu9Z6">lJM2Lm+3-;\d')o*\+$iN`2D:UN`Y+!a_@l/,CRQh:0Fi;#q&'/pb=X0_"mR@_s$T
	*E]^h7;-%6+r`^d=(V?A*;?Y5=pT-\1(\9npYGE%WDe(F:bRj/&sT(=4^cE>s>aW_W[H,r"`+-P#Qp
	s27U,:_-Y2/cd=o[)f]#?6o9H-@osJDP4dLTUs&,#MOaaHb^(b!W^i'o`4TP7pHEmU?c=G@KPaA"a]
	6Zo.CrsVNSPY7/8tM49Yq@aC5/D@tA]/[)YMX&#1Y2>n#Y-$(Tgbf0e1&`5Vm=lN670L.#6@mgJ0Ur
	Rl8:5XV8?i287ME^>i=r6gZt$.tSh;OBD@&T_n](nW)E,qa3WD#uqdg`>Fo$R#aX)uW(rcBEV2GZ("
	A/LB*j]I",`).;=@/m4Se,.<ln,WheSPARM`k498Y5F_\lN$\QRB0#o&O6sL^r$d22)h$Y%f"Aun&f
	A+Jbh"rsJP/.jUTLg5C*)HUensJ?2(uZGo=uf\`mtr=I$Mdm(<EVs3q*]qf&Duuj.>,9[CAVJGYQ5I
	pVCY;$+rkVR^,#g>0u&0UeG0uTXhTmoM6SUI/`1g4X,q24s6>E5;IEt.NCbP"[rUu;!^#L2?3^W!(f
	US7'8jaJc
	ASCII85End
End


//**//

Menu "Flights"
	"01. Panel: Flight Status", vueloStatus_Panel(resetPanel=0,updateInfo=0)
	"02. Panel: Flight Status (reset panel)", vueloStatus_Panel(resetPanel=1,updateInfo=1)
	"03. Search flight data",loadFlight_DataWave(printInfo=1,remakePath=1)
	"04. Load flight data",loadFlight(-1)
	"05. Recheck info",vueloStatus_InfoWave(reCheck=1)
	"06. Reset data",Init_Globals()
END

//**//
